<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$conf_config_table = 'config';
$conf_config_groups_table = 'config_groups';
include_once ($config['inc_dir'].'forms.inc.php');

//      
function AdminConfigurationEdit( $paddr, $group = '', $showhidden = false, $showtitles = true,
									$modname = '', $method_name = 'a=configsave' )
									//  group    0,   
{
	global $config, $db, $site, $conf_config_table, $conf_config_groups_table;

	$site->AddCSSFile('configuration.css');

	//      
	$temp = $db->Select($conf_config_table, '');
	$configs = array();
	for($i = 0, $cnt = count($temp); $i < $cnt; $i++){
		$configs[$temp[$i][1]][] = $temp[$i];
	}
	unset($temp);

	//   
	if($group == ''){
		$q = '';
	}else{
		$q = "`name`='$group'";
	}
	$cfg_grps = $db->Select($conf_config_groups_table, $q);

	//      
	$text = '<form action="'.$config['admin_file'].'?exe='.$paddr.'&'.$method_name.'" method="post">';
	for($i = 0, $cnt = count($cfg_grps); $i < $cnt; $i++){
		//       
		if($group === 0){
			if($cfg_grps[$i][4] == 0)
				continue;
		}
		//      
		if(!isset($configs[$cfg_grps[$i][0]])){
			$jcnt = 0;
		}else{
			$jcnt = count($configs[$cfg_grps[$i][0]]);
		}
		//      
		$text .= '<table cellspacing="1" cellpadding="0" class="configtable">';
		if($showtitles){
			$text .= '<tr><th colspan="3" height="30">'.SafeDB($cfg_grps[$i][2], 255, str).'</th></tr>';
		}
		// $text .= '<tr><th></th><th></th></tr>';

		//   
		if($jcnt > 0){
			for($j = 0; $j < $jcnt; $j++){
				#     
				if($configs[$cfg_grps[$i][0]][$j][4] == '0' && !$showhidden)
					continue;
				$name = SafeDB($configs[$cfg_grps[$i][0]][$j][2], 255, str, false, false);
				$desc = SafeDB($configs[$cfg_grps[$i][0]][$j][6], 255, str, false, false);
				$type = $configs[$cfg_grps[$i][0]][$j][10];
				$value = $configs[$cfg_grps[$i][0]][$j][3];
				$kind = $configs[$cfg_grps[$i][0]][$j][7];
				$hname = SafeDB($configs[$cfg_grps[$i][0]][$j][5], 255, str, false, false);
				$values = $configs[$cfg_grps[$i][0]][$j][8];
				$text .= '<tr>'
				.'<td class="leftc">'.$hname.'<br /><font style="color:#808080;font-size:8pt;">'.$desc.'</font></td>'
				.'<td class="rightc">'.FormsGetControl($name, $value, $kind, $type, $values).'</td>'
				.'</tr>';
			}
		}else{
			$text .= '<tr><td class="leftc" align="center">      . </td></tr>';
		}

		//  
		$text .= '</table><br />';
	}
	$text .= '<table class="configsubmit"><tr><td>'.$site->Submit('').'</td></tr></table>';
	$text .= '</form>';
	if($modname != ''){
		$modname = $modname;
	}else{
		$modname = '';
	}
	AddTextBox($modname, $text);
}

//     
function AdminConfigurationSave( $paddr, $group = '', $showhidden = false )
{
	global $config, $db, $conf_config_table, $conf_config_groups_table;
	//      
	$temp = $db->Select($conf_config_table, '');
	for($i = 0, $cnt = count($temp); $i < $cnt; $i++){
		$configs[$temp[$i][1]][] = $temp[$i];
	}
	unset($temp);
	//   
	if($group == ''){
		$q = '';
	}else{
		$q = "`name`='".$group."'";
	}
	$cfg_grps = $db->Select($conf_config_groups_table, $q);
	for($i = 0, $cnt = count($cfg_grps); $i < $cnt; $i++){
		//       
		if($group == ''){
			if($cfg_grps[$i][4] == 0)
				continue;
		}
		//      
		if(!isset($configs[$cfg_grps[$i][0]])){
			continue;
		}
		for($j = 0, $jcnt = count($configs[$cfg_grps[$i][0]]); $j < $jcnt; $j++){
			//      
			if($configs[$cfg_grps[$i][0]][$j][4] == 0 && !$showhidden)
				continue;
			$name = $configs[$cfg_grps[$i][0]][$j][2];
			$kind = explode(':', $configs[$cfg_grps[$i][0]][$j][7]);
			$kind = trim(strtolower($kind[0]));
			$savefunc = trim($configs[$cfg_grps[$i][0]][$j][9]);
			$type = trim($configs[$cfg_grps[$i][0]][$j][10]);
			if($type != ''){
				$type = explode(',', $type);
			}else{
				$type = array(255, str, false);
			}
			$where = "`name`='$name' and `group_id`='".$cfg_grps[$i]['id']."'";
			if(isset($_POST[$name])){
				switch($kind){
					case 'edit':
					case 'radio':
					case 'combo':
						if(FormsConfigCheck2Func('function', $savefunc, 'save')){
							$savefunc = CONF_SAVE_PREFIX.$savefunc;
							$value = $savefunc(FormsCheckType($_POST[$name], $type));
						}else{
							$value = FormsCheckType($_POST[$name], $type);
						}
						break;
					case 'text':
						if(FormsConfigCheck2Func('function', $savefunc, 'save')){
							$savefunc = CONF_SAVE_PREFIX.$savefunc;
							$value = $savefunc(FormsCheckType($_POST[$name], $type));
						}else{
							$value = FormsCheckType($_POST[$name], $type);
						}
						break;
					case 'check':
					case 'list':
						if(FormsConfigCheck2Func('function', $savefunc, 'save')){
							$savefunc = CONF_SAVE_PREFIX.$savefunc;
							$value = $savefunc(FormsCheckType($_POST[$name], $type));
						}else{
							if(isset($_POST[$name])){
								$c = count($_POST[$name]);
							}else{
								$c = 0;
							}
							$value = '';
							for($k = 0; $k < $c; $k++){
								$value .= ',';
								$value .= FormsCheckType($_POST[$name][$k], $type);
							}
							$value = substr($value, 1);
						}
						break;
					default:
						if(FormsConfigCheck2Func('function', $savefunc, 'save')){
							$savefunc = CONF_SAVE_PREFIX.$savefunc;
							$value = $savefunc(FormsCheckType($_POST[$name], $type));
						}else{
							$value = FormsCheckType($_POST[$name], $type);
						}
				}
				$db->Update($conf_config_table, 'value=\''.$value.'\'', $where);
			}
		}
	}
	GO($config['admin_file'].'?exe='.$paddr);
}

?>