<?php
if(!defined('VALID_RUN')){
	Header("Location: http://" . getenv("HTTP_HOST") . "/index.php");
	exit();
}

//    
//  (,   ..)
class Comments
{
	var $Table = '';
	var $Object = 0;
	var $LastErrors = array();

	function Comments( $table, $object )
	{
		global $config;
		$this->Table = $table;
		$this->Object = $object;
	}

	function PrintErrors()
	{
		$text = '      :<br><ul>';
		foreach($this->LastErrors as $error){
			$text .= '<li>' . $error;
		}
		$text .= '</ul><center><a href="javascript:history.back()"></a></center>';
		return $text;
	}

	function RenderComments( $blockname, $page = 0, $EnNav = false, $com_on_page = 10, $nav_url = '' )
	{
		global $site, $db, $config;
		$site->AddBlock($blockname, true, true, 'com');
		$where = "`object`='" . $this->Object . "'";
		$coms = $db->Select($this->Table, $where);
		//FIXME:   ..      ?
		SortArray($coms, 3, true); //  
		if(count($coms) > $com_on_page && $EnNav){
			$comm_nav_obj = new Navigation($page, 'comments_navigation');
			$comm_nav_obj->GenNavigationMenu($coms, $com_on_page, $nav_url);
		}
		foreach($coms as $comment){
			$uid = $comment[2];
			$vars = array();
			if($uid != 0){
				$userinfo = GetUserInfo($uid);
				$vars['text'] = strip_tags($comment[9]);
				$vars['public'] = $comment[3];
				$vars['author'] = '<a href="index.php?name=user&op=userinfo&user=' . $uid . '">' . $userinfo['name'] . '</a>';
				if($userinfo['hideemail'] == '0'){
					$vars['email'] = AntispamEmail($userinfo['email']);
				}else{
					$vars['email'] = '&nbsp;';
				}
				$vars['homepage'] = $userinfo['url'];
				$vars['icq'] = $userinfo['icq'];
				if($userinfo['online']){
					$vars['status'] = '  .';
				}else{
					$vars['status'] = '';
				}
				$vars['rank_image'] = $userinfo['rank_image'];
				$vars['rank_name'] = $userinfo['rank_name'];
				$vars['avatar'] = $userinfo['avatar_file'];
				$vars['regdate'] = ': ' . TimeRender($userinfo['regdate'], false);
				$ruser = true;
			}else{
				$vars['author'] = strip_tags($comment[4]);
				$vars['text'] = strip_tags($comment[9]);
				$vars['public'] = $comment[3];
				if($comment[6] != '' && $comment[7] != 0){
					$vars['email'] = AntispamEmail(strip_tags($comment[6]));
				}else{
					$vars['email'] = '&nbsp;';
				}
				if($comment[5] != ''){
					$vars['homepage'] = strip_tags($comment[5]);
				}else{
					$vars['homepage'] = '';
				}
				if($comment[8] != ''){
					$vars['icq'] = strip_tags($comment[8]);
				}else{
					$vars['icq'] = '&nbsp;';
				}
				$vars['rank_image'] = '';
				$vars['rank_name'] = '';
				$vars['avatar'] = GetPersonalAvatar(0);
				$vars['regdate'] = '';
				$ruser = false;
			}
			//FIXME:     
			if($vars['homepage'] != ''){
				$vars['homepage'] = '<a href="http://' . $vars['homepage'] . '" target="_blank">' . $vars['homepage'] . '</a>';
			}else{
				$vars['homepage'] = '&nbsp;';
			}
			$vars['public'] = ': ' . TimeRender($vars['public']);
			SmiliesReplace($vars['text']);
			$site->AddSubBlock($blockname, true, $vars, array(), 'comment.html');
		}
	}

	/**
	 *       
	 *
	 * @param int $page //  
	 * @param bool $EnNav //   
	 * @param int $com_on_page //    
	 * @param str $nav_url // URL  
	 * //: "$config['admin_file'].'?exe=news&a=readfull&id='"
	 * @param str $saveurl // URL        
	 * //: "$config['admin_file'].'?exe=news&a="
	 * @return comments
	 */
	function AdminRenderComments( $page = 0, $EnNav = false, $com_on_page = 10, $nav_url = '', $saveurl = '', $editing = true )
	{
		global $config, $db, $site;
		// TODO:    Object == 0, ..   -  . .
		$where = "`object`='" . $this->Object . "'";
		$coms = $db->Select($this->Table, $where);
		SortArray($coms, 3, true); //   
		if(count($coms) > $com_on_page && $EnNav){
			$navigator = new Navigation($page);
			$navigator->GenNavigationMenu($coms, $com_on_page, $nav_url);
			AddNavigation();
			$nav = true;
		}else{
			$nav = false;
			AddText('<br>');
		}
		$text = '<center><h5 style="margin-top:4px;margin-bottom:8px;">-  -</h5></center>
		<form action="' . $saveurl . 'deletecomment" method="post">';
		foreach($coms as $comment){
			$user_id = $comment[2];
			$public = TimeRender($comment[3]);
			$commtext = strip_tags($comment[9]);
			$user_ip = strip_tags($comment[10]);
			if($user_id != 0){
				$userinfo = GetUserInfo($user_id);
				$author = $userinfo['name'];
				$email = PrintEmail($userinfo['email'], $author);
				$homepage = $userinfo['url'];
				$icq = $userinfo['icq'];
				if($userinfo['online']){
					$online = '<b>  .</b>';
				}else{
					$online = '';
				}
				$avatar = '<img src="' . $userinfo['avatar_file'] . '">';
				$rank_image = '<img src="' . $userinfo['rank_image'] . '">';
				$rank_name = $userinfo['rank_name'];
				$regdate = ': ' . TimeRender($userinfo['regdate'], false);
				$ruser = true;
			}else{
				$author = strip_tags($comment[4]);
				$homepage = strip_tags($comment[5]);
				$icq = strip_tags($comment[8]);
				$email = PrintEmail(strip_tags($comment[6]), $author);
				$online = '';
				$rank_image = '';
				$rank_name = '';
				$avatar = '<img src="' . GetPersonalAvatar(0) . '">';
				$regdate = '';
				$ruser = false;
			}
			if($homepage != ''){
				$homepage = '<a href="http://' . $homepage . '" target="_blank">' . $homepage . '</a>';
			}else{
				$homepage = '&nbsp;';
			}
			if($ruser){
				$author = '<a href="index.php?name=user&op=userinfo&user=' . $user_id . '">' . $author . '</a>';
			}
			$text .= '
			<table cellspacing="0" cellpadding="0" width="90%" align="center" class="commtable">
				<tr>
					<th class="commth"><b>:</b></th>
					<th class="commth">E-mail:</th>
					<th class="commth">:</th>
					<th class="commth">:</th>
					<th class="commth">ip:</th>
					<th colspan="2" class="commth"></th>
				</tr>
				<tr>
					<th class="commth"><b>' . $author . '</b></th>
					<th class="commth">' . $email . '</th>
					<th class="commth">' . $homepage . '</th>
					<th class="commth">' . $public . '</td>
					<th class="commth">' . ($ruser && $userinfo['type'] == '1' ? '?.?.?.?' : $comment[10]) . '</td>
					<th class="commth">' . ($editing ? '<a href="' . $saveurl . 'editcomment&cid=' . $comment[0] . ($page != 0 ? '&page=' . $page : '') . '"><img src="images/admin/edit.gif" title=""></a>' : '&nbsp;') . '</td>
					<th class="commth">' . ($editing ? $site->Check('delcomments[]', $comment[0]) : '&nbsp;') . '</th>
				</tr>
				<tr>
					<td valign="top" class="commtd" width="140">' . $rank_image . '<br>' . $rank_name . '</td>
					<td colspan="6" rowspan="2" class="commtext" valign="top">
						' . $commtext . '
					</td>
				</tr>
				<tr>
					<td align="center" valign="top" width="140" class="commtd">' . ($config['comments']['show_avatars'] == '1' ? $avatar . '<br>' : '') . $regdate . '<br><b>' . $online . '</b></td>
				</tr>
			</table>';
		}
		AddText($text);
		if($nav){
			AddNavigation();
		}
		$text = '';
		if(count($coms) > 0){
			if($editing){
				$text .= '<p><center>' . $site->Submit(' ') . '</senter></p>';
			}
		}else{
			$text .= '<center>-   -<br><br></center>';
		}
		$text .= '</form>';
		AddText($text);
	}

	function AdminEditComment( $backurl = '', $saveurl = '' )
	{
		global $config, $db, $site, $user;
		if($backurl == ''){
			$backurl = $_SERVER['HTTP_REFERER'];
		}
		$useracess = $user->CheckAccess2('user', 'editing');
		$edituserdata = '';
		$edittext = '';
		$id = SafeEnv($_GET['cid'], 11, int);
		$db->Select($this->Table, "`id`='$id'");
		$com = $db->FetchRow();
		if($com[2] != 0){ // 
			$userinfo = GetUserInfo($com[2]);
			if(!$useracess){
				$edituserdata = ' disabled';
			}
			if(groupIsSystem($userinfo['access']) && !$user->isSuperUser()){
				$edituserdata = ' disabled';
				$edittext = ' disabled';
			}
		}else{ //
			$edituserdata = '';
		}
		$text = '';
		if($com[2] != 0 && $edituserdata == '' && $config['comments']['usercomment_warning'] == '1'){
			$text .= '<table cellspacing="0" cellpadding="0" class="cfgtable"><tr><td><font color="#FF0000">!</font><br>   .      ,       .</td></tr></table>';
		}
		FormRow(':', $site->Edit('comment_name', $com[4], false, 'maxlength="50"' . $edituserdata));
		FormRow('E-mail:', $site->Edit('comment_mail', $com[6], false, 'maxlength="50"' . $edituserdata));
		FormRow(' e-mail:', $site->Check('hideemail', '1', ($com[7] == '1' ? true : false), $edituserdata));
		FormRow(':', $site->Edit('comment_site', $com[5], false, 'maxlength="250"' . $edituserdata));
		FormRow('ICQ:', $site->Edit('comment_icq', $com[8], false, 'maxlength="15"' . $edituserdata));
		FormRow('', $site->TextArea('comment_msg', $com[9], 'style="width:400px;height:200px;"' . $edittext));
		AddForm('<form action="' . $saveurl . '&cid=' . $id . '" method="post">', $site->Hidden('backurl', $backurl) . $site->Button('', 'onclick="history.go(-1)"') . $site->Submit(''));
	}

	function AdminSaveComment()
	{
		global $config, $db, $user;
		$id = SafeEnv($_GET['cid'], 11, int);
		$useracess = $user->CheckAccess2('user', 'editing');
		$edituserdata = true;
		$edittext = true;
		$db->Select($this->Table, "`id`='$id'");
		$com = $db->FetchRow();
		if($com[2] != 0){ //  
			$userinfo = GetUserInfo($com[2]);
			if(!$useracess){
				$edituserdata = false;
			}
			if(groupIsSystem($userinfo['access']) && !$user->isSuperUser()){
				$edituserdata = false;
				$edittext = false;
			}
		}else{ // 
			$edituserdata = true;
		}
		if($edituserdata){
			$name = SafeEnv($_POST['comment_name'], 50, str, true);
			$mail = SafeEnv($_POST['comment_mail'], 50, str, true);
			if(isset($_POST['hideemail'])){
				$hideemail = '1';
			}else{
				$hideemail = '0';
			}
			$icq = SafeEnv($_POST['comment_icq'], 15, str, true);
			$homepage = SafeEnv(url($_POST['comment_site']), 250, str, true);
			if($com[2] != 0){
				$set = "name='$name',email='$mail',hideemail='$hideemail',icq='$icq',url='$homepage'";
				$db->Update('users', $set, "`id`='" . $com[2] . "'");
				UpdateUserComments($com[2], $com[2], $name, $mail, $hideemail, $homepage, $icq);
			}
		}
		if($edittext){
			$text = SafeEnv($_POST['comment_msg'], $config['comments']['maxlength'], str, true);
			$set = "message='$text'";
			if($com[2] == 0){
				$set .= ",name='$name',homepage='$homepage',email='$mail',hide_email='$hideemail',icq='$icq'";
			}
			$db->Update($this->Table, $set, "`id`='$id'");
		}
		GO(SafeEnv($_POST['backurl'], 255, str, false, false));
	}

	function AdminDeleteComment( $backurl = '' )
	{ //      .
	}

	function RenderForm( $blockname, $url )
	{
		global $site, $user, $db, $config;
		$vars['title'] = ' ';
		$vars['lname'] = '  <font color="#FF0000">*</font>';
		$vars['lemail'] = ' e-mail';
		$vars['lhideemail'] = ' e-mail';
		$vars['licq'] = 'ICQ';
		$vars['lsite'] = '';
		$vars['ltext'] = '  <font color="#FF0000">*</font>';
		$vars['url'] = $url;
		$vars['scaption'] = '';
		$vars['hcaption'] = ' ';
		if($user->isDef('u_name')){
			$vars['name'] = $user->Get('u_name');
		}else{
			$uname = '';
		}
		if($user->isDef('u_email')){
			$vars['email'] = $user->Get('u_email');
		}else{
			$vars['email'] = '';
		}
		if($user->isDef('u_hideemail')){
			$vars['hideemail'] = $user->Get('u_hideemail');
		}else{
			$vars['hideemail'] = '0';
		}
		if($user->isDef('u_homepage')){
			$vars['site'] = $user->Get('u_homepage');
		}else{
			$vars['site'] = '';
		}
		if($user->isDef('u_icq')){
			$vars['icq'] = $user->Get('u_icq');
		}else{
			$vars['icq'] = '';
		}
		if($vars['hideemail'] == '1'){
			$vars['hideemail'] = 'checked';
		}else{
			$vars['hideemail'] = '';
		}
		$vars['kaptcha_url'] = 'index.php?name=plugins&p=antibot';
		$vars['kaptcha_width'] = '120';
		$vars['kaptcha_height'] = '40';
		$site->AddBlock($blockname, true, false, 'form', 'commform.html');
		$smilies = $db->Select('smilies');
		$site->AddBlock('smilies', true, true, 'smile');
		foreach($smilies as $smile){
			$smile['file'] = $config['general']['smilies_dir'] . $smile['file'];
			$smile['code'] = SafeDB($smile['code'], 255, str);
			$sub_codes = explode(',', $smile['code']);
			$smile['code'] = $sub_codes[0];
			$site->AddSubBlock('smilies', true, $smile);
		}
		$site->Blocks[$blockname]['vars'] = $vars;
	}

	function CheckFlood()
	{
		global $db, $config;
		$floodTime = SafeEnv($config['comments']['floodtime'], 10, int, false, false);
		$db->Select($this->Table, "`user_ip`='" . getip() . "' and `public`>'" . (time() - $floodTime) . "'");
		if($db->NumRows() > 0){
			return true;
		}else{
			return false;
		}
	}

	/**
	 *    
	 * @param String $object_name //      (id)  where 
	 * @param String $object_table //    
	 * @param Integer $allow_coll //   allow_comments
	 * @param Integer $en_coll //   enabled  
	 * @return Boolean //  false   
	 */
	function AddComment( $object_name, $object_table, $allow_coll, $en_coll )
	{
		global $db, $config, $user;
		//TODO: $object_name -     _GET     id   !
		$er = array();
		$db->QueryResult = array();
		$this->LastErrors = array();
		if(isset($_GET[$object_name])){
			$object = SafeEnv($_GET[$object_name], 11, int);
		}else{
			$er[] = '   .';
		}
		if((!isset($_POST['name']) || !isset($_POST['email']) || !isset($_POST['site']) || !isset($_POST['icq']) || !isset($_POST['text'])) && !$user->Auth){
			$er[] = '  .';
		}else{
			if($user->Auth){
				$name = $user->Get('u_name');
				$email = $user->Get('u_email');
				$hideemail = $user->Get('u_hideemail');
				$site = $user->Get('u_homepage');
				$icq = $user->Get('u_icq');
			}else{
				$name = SafeEnv($_POST['name'], 50, str, true);
				CheckNikname($name, $er, true);
				$email = SafeEnv($_POST['email'], 50, str, true);
				if($email != ''){
					if(!CheckEmail($email)){
						$er[] = ' E-mail  .     : <b>domain@host.ru</b> .';
					}
				}
				if(isset($_POST['hideemail'])){
					$hideemail = '1';
				}else{
					$hideemail = '0';
				}
				$user->Def('u_hideemail', $hideemail);
				$site = Url(SafeEnv($_POST['site'], 250, str, true));
				$user->Def('u_homepage', $site);
				if($_POST['icq'] == '' || is_numeric($_POST['icq'])){
					$icq = SafeEnv($_POST['icq'], 15, str, true);
					$user->Def('u_icq', $icq);
				}else{
					$er[] = ' ICQ    !';
				}
				$r = $db->Select($object_table, "`$object_name`='$object'");
				if($db->NumRows() == 0){
					$er[] = '<font color="#FF0000">  </font>';
				}else{
					if($r[0][$en_coll] == '0'){
						$er[] = '<font color="#FF0000">  </font>';
					}
					if($r[0][$allow_coll] == '0'){
						$er[] = '<font color="#FF0000"> </font>';
					}
				}
			}
			$text = DivideWord(SafeEnv($_POST['text'], $config['comments']['maxlength'], str), $config['comments']['max_word_length']);
		}
		if($this->CheckFlood()){
			$er[] = ' ,  .';
		}
		$user->Def('u_name', $name);
		if(strlen($text) == 0){
			$er[] = '    .';
		}
		if(!$user->Auth && !$user->isDef('captcha_keystring') || $user->Get('captcha_keystring') != $_POST['keystr']){
			$er[] = '      .';
		}
		if($user->Auth){
			$uid = $user->Get('u_id');
		}else{
			$uid = 0;
		}
		if(count($er) == 0){
			$vals = Values('', $object, $uid, time(), $name, $site, $email, $hideemail, $icq, $text, SafeEnv(getip(), 23, str));
			$db->Insert($this->Table, $vals);
			return true;
		}else{
			$this->LastErrors = $er;
			return false;
		}
	}

	//   
	function DeleteComments( $object )
	{
		global $db, $config;
		$object = SafeEnv($object, 11, int);
		$db->Delete($this->Table, "`object`='$object'");
	}
} // 
?>