<?php

//      
if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

class Navigation
{
	public  $page = 0;
	public $param_name;
	public $template_block;

	//
	public function Navigation( $page, $block_name = 'navigation', $param_name = 'page' )
	{
		global $site;
		$this->page = $page;
		$this->param_name = $param_name;
		$this->template_block = $block_name;
	}

	private function AddItem( $pos, $link )
	{
		global $site;
		$site->Blocks[$this->template_block]['child'][$pos]['sub'][] = $site->CreateSubBlock(true, array('link'=>$link));
	}

	public function DisableNavigation()
	{
		global $site;
		$site->AddBlock($this->template_block, true, false);
	}

	/**
	 *    .
	 *
	 * @param Integer $page //   ( 1)
	 * @param Array $items //    .       .
	 * @param Integer $nOnPage //   
	 * @param String $link //  .       page.
	 * @return String //       
	 */
	public function GenNavigationMenu( &$items, $nOnPage, $link, $page = null )
	{
		global $site;
		if(count($items) <= $nOnPage){
			$this->DisableNavigation();
			return;
		}else{
			$items_block = array();
			$items_block['back'] = $site->CreateBlock(true, true, 'item', 'navigation_item.html');
			$items_block['begin'] = $site->CreateBlock(true, true, 'item', 'navigation_item.html');
			$items_block['left'] = $site->CreateBlock(true, true, 'item', 'navigation_item.html');
			$items_block['right'] = $site->CreateBlock(true, true, 'item', 'navigation_item.html');
			$items_block['end'] = $site->CreateBlock(true, true, 'item', 'navigation_item.html');
			$items_block['next'] = $site->CreateBlock(true, true, 'item', 'navigation_item.html');
			$site->AddBlock($this->template_block, true, false, 'nav', 'navigation.html', '', $items_block);
		}
		if($page == null){
			$page = $this->page;
		}
		$icnt = count($items);
		//  
		if($icnt > $nOnPage){
			$pages = array_chunk($items, $nOnPage);
		}else{
			$pages[0] = $items;
		}
		if($page < 1){
			$page = 1;
		}elseif($page > count($pages)){
			$page = count($pages);
		}
		$items = $pages[$page - 1]; #page-1   page  1,    0
		$num_pages = count($pages);
		#      
		$min = $page - 5;
		$max = $page + 5;
		if($min < 1){
			$min = 1;
		}
		if($max > $num_pages){ #    
			$max = $num_pages; # count       1
		}
		#     
		if($page > 1){ #   
			$back = $this->AddItem('back', '<a href="'.$link.'&'.$this->param_name.'='.($page - 1).'">&lt;&lt;&lt;</a>');
		}else{
			$back = $this->AddItem('back', '&lt;&lt;&lt;');
		}
		#     
		if($min > 1){
			$begin = $this->AddItem('begin', '<a href="'.$link.'&'.$this->param_name.'=1">1..</a>');
		}
		$litems = '';
		$ritems = '';
		# 
		for($i = $min; $i <= $max; $i++){
			if($i < $page){
				$litems .= $this->AddItem('left', '<a href="'.$link.'&'.$this->param_name.'='.$i.'">'.$i.'</a>');
			}elseif($i > $page){
				$ritems .= $this->AddItem('right', '<a href="'.$link.'&'.$this->param_name.'='.$i.'">'.$i.'</a>');
			}else{
				$Active = $i;
			}
		}
		#     
		if($max < $num_pages){
			$end = $this->AddItem('end', '<a href="'.$link.'&'.$this->param_name.'='.$num_pages.'">..'.$num_pages.'</a>');
		}
		#     
		if($page < $num_pages){
			$next = $this->AddItem('next', '<a href="'.$link.'&'.$this->param_name.'='.($page + 1).'">&gt;&gt;&gt;</a>');
		}else{
			$next = $this->AddItem('next', '&gt;&gt;&gt;');
		}
		$site->Blocks[$this->template_block]['vars']['active'] = $Active;
	}
}

?>