<?php

# LinkorCMS
#  2006-2010    (galitsky@pochta.ru)
# : user.class.php
# :     

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

if(!defined("USER")){
	define("USER", true);
}else{
	return;
}

class User
{
	public $Auth = false;
	public $Started = false;
	public $session = array();
	public $errors = array();
	public $online = null;
	public $online_process = false;
	public $SuperUser = false;
	public $host;

	public function Started( $func )
	{
		if($this->Started == false){
			echo $errors[] = "<b>!</b> : User->$func():   .<br />";
			return false;
		}else{
			return true;
		}
	}

	public function Def( $name, $value )
	{
		if($this->Started('Def')){
			$_SESSION[$name] = $value;
			$this->session[$name] = $value;
		}
	}

	public function UnDef( $name )
	{
		if($this->Started('UnDef')){
			unset($_SESSION[$name]);
			unset($this->session[$name]);
		}
	}

	public function isDef( $name )
	{
		return isset($this->session[$name]) || isset($_SESSION[$name]);
	}

	public function Get( $name )
	{
		if($this->Started('Get')){
			if(isset($this->session[$name])){
				return $this->session[$name];
			}elseif(isset($_SESSION[$name])){
				return $_SESSION[$name];
			}else{
				return false;
			}
		}
	}

	public function isAdmin()
	{
		if($this->Get('u_level') == '1'){
			return true;
		}else{
			return false;
		}
	}

	//   
	public function AccessLevel()
	{
		if($this->Get('u_level') === false){
			return 4;
		}else{
			return $this->Get('u_level');
		}
		//1 
		//2 
		//3 
		//4 
	}

	/**
	 *       
	 *      
	 * @param Integer $viewlevel //   
	 * @param Integer $accesslevel //   
	 * @return Boolean
	 */
	public function AccessIsResolved( $viewlevel, $user_access = null )
	{
		if($user_access == null){
			global $user;
			$user_access = $user->AccessLevel();
		}
		if($user_access == 1){
			return true;
		}elseif($user_access == 2 && ($viewlevel == 4 || $viewlevel == 2)){
			return true;
		}elseif($user_access == 3 && ($viewlevel == 4 || $viewlevel == 3)){
			return true;
		}elseif($user_access == $viewlevel){
			return true;
		}
	}
	public $access2 = array();
	public $SuperAccess2 = false;

	//       
	//      
	// $result[group] = array(name,name,name,...);
	public function AccessInit( $UserAccessGroup )
	{
		global $config, $db;
		$this->access2 = array();
		$this->SuperUser = false;
		$this->SuperAccess2 = false;
		if($UserAccessGroup == -1 || $UserAccessGroup == 0){
			return;
		}
		$access = $db->Select('usertypes', "`id`='".$UserAccessGroup."'");
		$ac2 = array();
		if($db->NumRows() > 0){
			if(trim($access[0][3]) != 'ALL'){
				$ac2 = unserialize($access[0][3]);
			}else{
				$this->SuperAccess2 = true;
			}
			if($access[0][4] == '1'){
				$this->SuperUser = true;
				$this->SuperAccess2 = true;
			}else{
				$this->SuperUser = false;
			}
		}
		$this->access2 = $ac2;
	}

	//     
	public function CheckAccess2( $AccessGroup, $AccessKey )
	{
		//          false      
		//return true;
		//
		if($this->SuperAccess2 || (isset($this->access2[$AccessGroup]) && in_array($AccessKey, $this->access2[$AccessGroup]))){
			return true;
		}else{
			return false;
		}
	}

	//    ()
	public function isSuperUser()
	{
		return $this->SuperUser;
	}

	//  id   
	public function AccessGroup()
	{
		//-1 
		//0 
		//   
		if(!$this->Auth){
			return -1;
		}
		$acc = $this->Get('u_access');
		if($acc < 0){
			return 0;
		}else{
			return $acc;
		}
	}

	//   
	public function Name()
	{
		return $this->Get('u_name');
	}

	//    
	public function OnlineProcess( $page )
	{
		global $config, $db;
		//  
		$time = time();
		$time2 = $time - 600;
		$db->Delete('online', "`time` < $time2");
		if($this->online_process){
			return;
		}else{
			$this->online_process = true;
		}
		$ip = getip();
		if($this->Auth === true){
			$id = $this->Get('u_id');
		}else{
			$id = -1;
		}
		$name = $this->Get('u_name');
		if(!$name){
			$name = '';
		}
		$level = $this->Get('u_level');
		$where = "`u_ip`='$ip'";
		$db->Select('online', $where);
		$uri = SafeEnv($_SERVER['REQUEST_URI'], 255, str);
		if(strpos($uri, $config['admin_file']) !== false){
			$uri = '';
			$page = '-';
		}
		if($db->NumRows() > 0){
			$db->Update('online', "'$time','$id','$name','$level','$uri','$page','$ip'", $where, true);
		}else{
			$db->Insert('online', "'$time','$id','$name','$level','$uri','$page','$ip'");
		}
	}

	//     
	public function Online()
	{
		global $config, $db;
		if($this->online == null){
			$info = array('admins'=>array(), 'members'=>array(), 'guests'=>array());
			$db->Select('online', '');
			while($memb = $db->FetchRow()){
				if($memb[3] == 1){
					$info['admins'][] = $memb;
					$info[$memb[1]] = $memb;
				}elseif($memb[3] == 2){
					$info['members'][] = $memb;
					$info[$memb[1]] = $memb;
				}else{
					$info['guests'][] = $memb;
				}
			}
			$this->online = $info;
			return $info;
		}else{
			return $this->online;
		}
	}

	// 
	public function User()
	{
		global $config, $site;
		$this->host = false;

		if($this->Started == false){
			if(!session_start()){
				echo $this->errors[] = '<b>!</b>: User->User():    .<br />';
			}else{
				$this->Started = true;
			}
		}

		//   http_referer.
		if($this->isDef('REFERER')){
			$_SERVER['HTTP_REFERER'] = $this->Get('REFERER');
		}else{
			if(isset($_SERVER['HTTP_REFERER']) && trim($_SERVER['HTTP_REFERER']) != ''){
				$this->Def('FIRST_REFERER', SafeEnv(trim($_SERVER['HTTP_REFERER']), 255, str));
			}
		}
		$this->Def('REFERER', "http://".getenv("HTTP_HOST").$_SERVER['REQUEST_URI']);
		//

		if(isset($_SESSION['u_auth'])){
			if($this->Get('u_ip') == getip()){
				$this->session = $_SESSION;
				$this->Auth = $this->Get('u_auth');
			}else{
				$this->UnLogin(true);
			}
		}

		if(isset($_COOKIE['auth']) && !$this->AllowCookie('auth')){
			setcookie('auth', '', time() - 3600);
			$this->RegisterGuestData();
		}

		if(!isset($_COOKIE['auth'])){
			$this->RegisterGuestData();
		}

		if(!defined('SETUP_SCRIPT')){
			$this->AccessInit($this->AccessGroup());
			if($this->Auth){
				@date_default_timezone_set($this->Get('u_timezone'));
			}
		}

	}

	//	     .
	public function ChargePoints( $num, $user_id = null )
	{
		if($num == 0 || (!$this->Auth && $user_id == null)){
			return false;
		}
		global $config, $db;
		if($user_id != null){
			$id = $user_id;
		}elseif($this->Auth){
			$id = $this->Get('u_id');
		}
		$db->Select('users', "`id`='$id'");
		if($db->NumRows() == 0){
			return false;
		}
		$usr = $db->FetchRow();
		$points = SafeDB($usr[18], 11, int);
		$points = $points + $num;
		$db->Update('users', "points='$points'", "`id`='$id'");
		return true;
	}

	//	      
	public function Login( $login, $pass, $remember = false, $Second = false )
	{
		global $config, $db;
		sleep($config['security']['login_sleep']);
		$login = SafeEnv($login, 15, str);
		$pass = md5(SafeEnv($pass, 15, str));
		$db->Select('users', "`login`='".$login."' and `pass`='".$pass."'");
		$u = $db->FetchRow();
		if($db->NumRows() > 0 && $u[20] == '1'){
			if($Second){
				$this->SecondLoginAdmin = $u[22] == '1';
			}
			if(!$this->Auth){
				$this->Auth = true;
				// 
				$auth = base64_encode($login.':'.md5($pass.$config['salt']));
				if($remember){
					$expires = time() + 2592000;
				}else{
					$expires = null;
				}
				setcookie('auth', $auth, $expires);
				$this->RegisterData($u);
				$visits = $u[19] + 1;
				$db->Update('users', "lastvisit='".time()."',lastip='".getip()."',visits='".$visits."'", "`id`='".$u[0]."'");
			}
			return true;
		}else{
			if($Second){
				$this->SecondLoginAdmin = false;
			}else{
				if($u[20] == '0'){
					return '<center><br />   .    E-Mail      .        !<br /></center>';
				}else{
					return '<center>    !</center>';
				}
			}
		}
	}

	//      cookie
	//         .
	public function AllowCookie( $CookieName, $AdminCookie = false )
	{
		global $config, $db;

		if(!isset($_COOKIE[$CookieName])) return false;

		$auth = base64_decode($_COOKIE[$CookieName]);
		$auth = explode(":", $auth);
		$cookie_md5 = $auth['1'];

		$reg = false;

		if($this->isDef('u_login')){
			$u_login = $this->Get('u_login');
			$u_pass = $this->Get('u_md5');
		}else{
			if(!isset($db)) return false;
			$u_login = SafeEnv($auth['0'], 255, str);
			$db->Select('users', "`login`='$u_login'");
			if($db->NumRows() > 0){
				$u = $db->FetchRow();
				$reg = true;
				$u_pass = $u[2];
			}else{
				return false;
			}
		}

		if(isset($config['salt'])){ //   $config  
			if($AdminCookie){
				$md5 = md5($u_pass.$config['salt'].getip());
			}else{
				$md5 = md5($u_pass.$config['salt']);
			}
		}else{
			$md5 = '';
		}

		if($cookie_md5 == $md5){
			if(!$AdminCookie && $reg){
				$this->RegisterData($u);
			}
			return true;
		}else{
			return false;
		}
	}

	//     
	//       .
	public function UpdateMemberSession()
	{
		global $config, $db;
		if($this->Auth){
			$user_id = $this->Get('u_id');
			$db->Select('users', "`id`='$user_id'");
			if($db->NumRows() > 0){
				$this->RegisterData($db->FetchRow());
			}
		}
	}

	//	    
	public function RegisterData( $user )
	{
		global $config;
		$this->Auth = true;
		$this->Def('u_auth', true); //  
		$this->Def('u_level', SafeDB($user[22], 11, int)); // 
		$this->Def('u_access', SafeDB($user[23], 11, int)); //    
		$this->Def('u_id', SafeDB($user[0], 11, int)); //  

		$this->Def('u_login', SafeDB($user[1], 30, str)); // 
		$this->Def('u_md5', SafeDB($user[2], 32, str)); //    md5

		$this->Def('u_name', SafeDB($user[3], 50, str)); // 
		$this->Def('u_truename', SafeDB($user[4], 250, str)); // 
		$this->Def('u_age', SafeDB($user[5], 3, int)); // 
		$this->Def('u_email', SafeDB($user[6], 50, str)); // 
		$this->Def('u_hideemail', SafeDB($user[7], 1, int)); //   
		$this->Def('u_city', SafeDB($user[8], 100, str)); //
		$this->Def('u_icq', SafeDB($user[9], 15, str)); // ICQ 
		$this->Def('u_homepage', SafeDB($user[10], 250, str)); //  
		$this->Def('u_timezone', SafeDB($user[11], 255, str)); //  
		if($user[24] == '1'){
			$uavatar = GetPersonalAvatar(SafeDB($user[0], 11, int), SafeDB($user[24], 1, int), SafeDB(RealPath2($user[12]), 250, str));
		}else{
			$uavatar = GetGalleryAvatar(SafeDB(RealPath2($user[12]), 250, str));
		}
		$this->Def('u_avatar', $uavatar); // 
		$this->Def('u_regdate', SafeDB($user[15], 11, int)); // 
		$this->Def('u_points', SafeDB($user[18], 11, int)); //  
		$this->Def('u_ip', getip()); //   ip 
	}

	//    .
	public function RegisterGuestData()
	{
		global $config;
		$this->Auth = false;
		$this->Def('u_auth', false);
		$this->Def('u_level', '3');
		$this->Def('u_id', '0');
		$this->Def('u_access', '-1');
		$this->Def('u_ip', getip());
		$this->Def('u_avatar', GetGalleryAvatar('guest.gif'));
		$this->Def('u_hits', 1);
		// 
		if(!$this->Get('u_stats_host')){
			$this->host = true;
			$this->Def('u_stats_host', true);
		}
	}

	//         .
	public function UnLogin( $destroy = true )
	{
		global $db;
		$this->Auth = false;
		if($destroy){
			$_SESSION = array();
			$this->session = array();
			session_destroy();
		}
		setcookie('auth', '', time() - 3600);
		setcookie('admin', '', time() - 3600);
		$this->RegisterGuestData();
		$ip = getip();
		$where = "`u_ip`='$ip'";
		$db->Delete('online', $where);
	}
}

$user = NEW User();
$userAuth = IntVal($user->Get('u_auth'));
$userAccess = IntVal($user->Get('u_level'));

?>