<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

if(!$user->isSuperUser()){
	AddTextBox('', $config['general']['admin_accd']);
	return;
}

function AdminAuditMain()
{
	global $db, $config;
	AddCenterBox('  ');
	$query = $db->Select('audit', '');
	$count = count($query);
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 10, int);
	}else{
		$page = 1;
	}
	SortArray($query, 2, true);
	$num = 50;
	if($count > $num){
		$navigator = new Navigation($page);
		$navigator->GenNavigationMenu($query, $num, $config['admin_file'].'?exe=audit');
		AddNavigation();
		$nav = true;
	}else{
		$nav = false;
	}
	if($config['db_type'] != 'FilesDB'){
		$text = '<center><br />     FilesBD 2.5.<br /><br /></center>';
		AddText($text);
	}elseif($count == 0){
		$text = '<center><br />    .<br /><br /></center>';
		AddText($text);
	}elseif($count >= 1){
		$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
		$text .= '<tr><th></th><th></th><th></th><th>IP</th></tr>';
		AddText($text);
		foreach($query as $q){
			$user = GetUserInfo(SafeDB($q['user'], 11, int));
			$date = TimeRender(SafeDB($q['date'], 11, int));
			$action = SafeDB($q['action'], 255, str);
			$ip = SafeDB($q['ip'], 255, str);
			$text = '<tr>
			<td>'.$action.'</td>
			<td>'.$date.'</td>
			<td><a href="'.$config['admin_file'].'?exe=admins&a=editadmin&id='.SafeDB($user['id'], 11, int).'">'.SafeDB($user['name'], 50, str).'</td>
			<td>'.$ip.'</td>
			</tr>';
			AddText($text);
		}
		$text = '</table>';
		AddText($text);
		$text = '<a href="'.$config['admin_file'].'?exe=audit&a=clear">  </a>';
		AddText($text);
	}
}

function AdminAuditClear()
{
	global $db, $config;
	if(isset($_GET['ok']) && SafeEnv($_GET['ok'], 1, int) == '1'){
		$db->Delete('audit', '');
		GO($config['admin_file'].'?exe=audit');
	}else{
		$text = '      ?<br />'.'<a href="'.$config['admin_file'].'?exe=audit&a=clear&ok=1"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a>';
		AddTextBox(" ", $text);
	}
}

function AdminAuditReferers()
{
	global $db, $config;
	AddCenterBox('   ()');
	$query = $db->Select('referers', '');
	$count = count($query);
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 10, int);
	}else{
		$page = 1;
	}
	SortArray($query, 2, true);
	$num = 50;
	if($count > $num){
		$navigator = new Navigation($page);
		$navigator->GenNavigationMenu($query, $num, $config['admin_file'].'?exe=audit&a=referers');
		AddNavigation();
		$nav = true;
	}else{
		$nav = false;
	}
	if($count == 0){
		$text = '<center><br />   .<br /><br /></center>';
		AddText($text);
	}elseif($count >= 1){
		$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
		$text .= '<tr><th></th><th></th></tr>';
		AddText($text);
		foreach($query as $q){
			$referer = SafeDB($q[1], 255, str);
			$count = SafeDB($q[2], 11, int);
			$text = '<tr>
			<td><a href="'.$referer.'" target="_blank">'.$referer.'</a></td>
			<td>'.$count.'</td>
			</tr>';
			AddText($text);
		}
		$text = '</table>';
		AddText($text);
		$text = '<a href="'.$config['admin_file'].'?exe=audit&a=clear_referers">  </a>';
		AddText($text);
	}
}

function AdminAuditClearReferers()
{
	global $db, $config;
	if(isset($_GET['ok']) && SafeEnv($_GET['ok'], 1, int) == '1'){
		$db->Delete('referers', '');
		GO($config['admin_file'].'?exe=audit&a=referers');
	}else{
		$text = '     ?<br />'.'<a href="'.$config['admin_file'].'?exe=audit&a=clear_referers&ok=1"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a>';
		AddTextBox(" ", $text);
	}
}

function AdminAudit( $action )
{
	global $user;
	if($user->CheckAccess2('audit', 'audit_conf')){
		//TAddToolLink('  ', 'main', 'audit');
		TAddToolLink('  ', 'referers', 'audit&a=referers');
	}
	TAddToolBox($action);
	TAddSubTitle('');
	switch($action){
		case 'main':
			AdminAuditMain();
			break;
		case 'clear':
			AdminAuditClear();
			break;
		case 'referers':
			AdminAuditReferers();
			break;
		case 'clear_referers':
			AdminAuditClearReferers();
			break;
		default:
			AdminAuditMain();
	}
}

if(isset($_GET['a'])){
	AdminAudit($_GET['a']);
}else{
	AdminAudit('referers');
}

?>