<?php

# LinkorCMS
#  2006-2008    (galitsky@pochta.ru)
# LinkorCMS Development Group
# www.linkorcms.ru
#  LinkorCMS 1.2.
#   -   (smilesoft@yandex.ru)

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

if(!$user->CheckAccess2('forum', 'forum')){
	AddTextBox('', $config['general']['admin_accd']);
	return;
}
include_once(MOD_DIR.'forum_lang.php');
include_once(MOD_DIR.'functions.php');
include_once(MOD_DIR.'forum_basket.php');
include_once(MOD_DIR.'forum_moderation.php');
include_once(MOD_DIR.'forum_rang.php');
include_once(MOD_DIR.'forum_java.php');
include_once(MOD_DIR.'forum_online.php');
include_once(MOD_DIR.'forum_cache.class.php');
include_once(MOD_DIR.'forum_cache.php');
include_once(MOD_DIR.'forum_add.php');
include_once(MOD_DIR.'forum_navigation.php');
include_once(MOD_DIR.'forum_topic.php');
include_once(MOD_DIR.'forum_posts.php');
include_once(MOD_DIR.'forum_marker.php');

Index_Forum_Add_Java();


function AdminForumGetOrder( $parent_id )
{
	global $db;
	/* @var $db Database_FilesDB */
	$db->Select('forums', "`parent_id`='$parent_id'");
	return $db->NumRows();
}

function AdminForumRender( $forum, $all_forums, $forums_all_id = array() )
{
	global $config, $lang;
	$text = '';
	// move menu
	if(isset($all_forums[$forum['parent_id']])){
		$max_place = count($all_forums[$forum['parent_id']]) - 1;
	}else{
		$max_place = 0;
	}
	if($max_place > 0){
		$order = SafeDB($forum['order'], 11, int);
		if($order > 0 && $order < $max_place){
			$move_menu = '<a href="'.$config['admin_file'].'?exe=forum&a=move&to=up&id='.SafeDB($forum['id'], 11, int).'&pid='.SafeDB($forum['parent_id'], 11, int).'"><img src="images/admin/up.gif" title="" /></a>
			 <a href="'.$config['admin_file'].'?exe=forum&a=move&to=down&id='.SafeDB($forum['id'], 11, int).'&pid='.SafeDB($forum['parent_id'], 11, int).'"><img src="images/admin/down.gif" title="" /></a>';
		}elseif($order == 0){
			$move_menu = '<a href="'.$config['admin_file'].'?exe=forum&a=move&to=down&id='.SafeDB($forum['id'], 11, int).'&pid='.SafeDB($forum['parent_id'], 11, int).'"><img src="images/admin/down.gif" title="" /></a>';
		}elseif($order >= $max_place){
			$move_menu = '<a href="'.$config['admin_file'].'?exe=forum&a=move&to=up&id='.SafeDB($forum['id'], 11, int).'&pid='.SafeDB($forum['parent_id'], 11, int).'"><img src="images/admin/up.gif" title="" /></a>';
		}
	}else{
		$move_menu = '&nbsp;-&nbsp;';
	}
	//  
	$vi = ViewLevelToStr(SafeDB($forum['view'], 1, int));
	// 
	switch($forum['status']){
		case '1':
			$st = '<a href="'.$config['admin_file'].'?exe=forum&a=changestatus&id='.SafeDB($forum['id'], 11, int).'" title=""><font color="#008000">.</font></a>';
			break;
		case '0':
			$st = '<a href="'.$config['admin_file'].'?exe=forum&a=changestatus&id='.SafeDB($forum['id'], 11, int).'" title=""><font color="#FF0000">.</font></a>';
			break;
	}
		$font_start = '';
		$font_end ='';

	// Func 
	if($forum['parent_id'] == '0'){
		$editlink = $config['admin_file'].'?exe=forum&a=cat_editor&id='.SafeDB($forum['id'], 11, int);
		$font_start = '<FONT SIZE="2" COLOR="#3300FF">';
		$font_end = '</FONT>';
	}else{
		$editlink = $config['admin_file'].'?exe=forum&a=forum_editor&id='.SafeDB($forum['id'], 11, int);
	}
	$discussion = $forum['close_topic'] == 1?$lang['close_for_discussion_admin']:$lang['on_for_discussion'];
	if(isset($forums_all_id[$forum['parent_id']])){
	  if($forums_all_id[$forum['parent_id']]['close_topic'] == 1 and $forum['close_topic'] == 0)
	  $discussion =  $lang['close_for_discussion_admin_parent'];
	}
	$func = '<a href="'.$editlink.'"><img src="images/admin/edit.gif" title="" /></a>'.'<a href="'.$config['admin_file'].'?exe=forum&a=delete&id='.SafeDB($forum['id'], 11, int).'&ok=0"><img src="images/admin/delete.gif" title="" /></a>';
	$levs = '<table cellspacing="0" cellpadding="0" border="0" align="left"><tr>';
	$levs .= str_repeat('<td style="border:none;">&nbsp;-&nbsp;</td>', ($forum['parent_id'] == '0' ? 0 : 1));
	$levs .= '<td align="left" style="text-align:left;padding-left:10px;border:none;"><b><a href="'.$editlink.'">'.$font_start.SafeDB($forum['title'], 255, str).$font_end.'</a></b></td>';
	$levs .= '</tr></table>';
	$text .= '<tr><td>'.$move_menu.'</td><td>'.$levs.'</td><td>'.$vi.'</td><td>'.$st.'</td><td>'.$discussion.'</td><td>'.$func.'</td></tr>';
	return $text;
}

function AdminForumMain()
{
	global $db, $config;
	/* @var $db Database_FilesDB */
	$result = $db->Select('forums');
	$forums = array();
	foreach($result as $forum){
		$forums_all_id[$forum['id']] = $forum;
	}
	foreach($result as $forum){
		$forums[$forum['parent_id']][] = $forum;
	}
	$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
	$text .= '<tr><th style="width:80px;"></th><th></th><th></th><th></th><th></th><th></th></tr>';
	if(isset($forums['0'])){
		SortArray($forums['0'], 'order');
		foreach($forums['0'] as $category){
			//    
			$text .= AdminForumRender($category, $forums);
			if(isset($forums[$category['id']])){
				SortArray($forums[$category['id']], 'order');
				foreach($forums[$category['id']] as $forum){
					//   
					$text .= AdminForumRender($forum, $forums, $forums_all_id);
				}
			}
		}
	}
	$text .= '</table>';
	AddTextBox(' ', $text);
}


function AdminForumCatEditor( $action )
{
	global $config, $db, $site;
	/* @var $db Database_FilesDB */
	$f_title = '';
	$f_desc = '';
	$f_parent = 0;
	$f_view = array(false, false, false, false, false);
	$f_status = array(false, false);

	$f_admin_theme_add = array(false, false);
	$f_new_message_email = array(false, true);
	$f_no_link_guest = array(false, false);
	$rang_access=0;
	$rang_add_theme=0;
	$rang_message=0;
	$close_topic= array(false, false);


	if(isset($_GET['id'])){
		// 
		$id = SafeDB($_GET['id'], 11, int);
		$db->Select('forums', "`id`='$id'");
		$forum = $db->FetchRow();
		$f_title = SafeDB($forum['title'], 255, str);
		$f_desc = SafeDB($forum['description'], 0, str);
		$f_parent = SafeDB($forum['parent_id'], 11, int);

		$f_admin_theme_add[(int)$forum['admin_theme_add']] = true;
		$f_new_message_email[(int)$forum['new_message_email']] = true;
		$f_no_link_guest[(int)$forum['no_link_guest']] = true;
		$rang_access= SafeDB($forum['rang_access'], 11, int);
	    $rang_add_theme= SafeDB($forum['rang_add_theme'], 11, int);
	    $rang_message= SafeDB($forum['rang_message'], 11, int);
		$close_topic[(int)$forum['close_topic']] = true;

		$f_view[(int)$forum['view']] = true;
		$f_status[(int)$forum['status']] = true;
		$id_param = '&id='.$id;
		$b_cap = '';
		if($action != 'forum_editor'){
			$c_cap = ' ';
		}else{
			$c_cap = ' ';
		}
		unset($forum);
	}else{
		// 
		$f_title = '';
		$f_view[4] = true;
		$f_status[1] = true;

		$f_admin_theme_add[0] = true;
		$f_new_message_email[1] = true;
		$f_no_link_guest[0] = true;
	   	$close_topic[0] = true;

		$id_param = '';
		$b_cap = '';
		if($action != 'forum_editor'){
			$c_cap = ' ';
		}else{
			$c_cap = ' ';
		}
	}
	FormRow('', $site->Edit('title', htmlspecialchars($f_title), false, 'style="width:200px;" maxlength="255"'));
	if($action == 'forum_editor'){
		FormTextRow('', $site->HtmlEditor('desc', $f_desc, 500, 150));
		$forums = $db->Select('forums', "`parent_id`='0'");
		if(count($forums)==0){
			AddTextBox($c_cap, '   !  .');
			return;
		}
		SortArray($forums, 'order');
		$cat_data = array();
		foreach($forums as $forum){
			$site->DataAdd($cat_data, SafeDB($forum['id'], 11, int), SafeDB($forum['title'], 255, str), $forum['id'] == $f_parent);
		}
		FormRow(' ', $site->Select('parent_id', $cat_data));
	}
	$visdata = array();
	$site->DataAdd($visdata, 'all', '', $f_view[4]);
	$site->DataAdd($visdata, 'members', ' ', $f_view[2]);
	$site->DataAdd($visdata, 'guests', ' ', $f_view[3]);
	$site->DataAdd($visdata, 'admins', ' ', $f_view[1]);
	FormRow('', $site->Select('view', $visdata));

	if($action== 'forum_editor'){
	$endata = array();
	$site->DataAdd($endata, '1', '', $f_admin_theme_add[1]);
	$site->DataAdd($endata, '0', '', $f_admin_theme_add[0]);
	FormRow('  <BR>  ', $site->Select('admin_theme_add', $endata));
	$endata = array();
	$site->DataAdd($endata, '1', '', $f_no_link_guest[1]);
	$site->DataAdd($endata, '0', '', $f_no_link_guest[0]);
 	FormRow('   ', $site->Select('no_link_guest', $endata));
	$endata = array();
    $site->DataAdd($endata, '1', '', $f_new_message_email[1]);
	$site->DataAdd($endata, '0', '', $f_new_message_email[0]);
	FormRow(' <BR>    <BR>   ', $site->Select('new_message_email', $endata));
	 FormRow('<CENTER><B>:</B></CENTER>',' &nbsp;');
    FormRow('   :<BR>   <BR>  ',ForumAdminGetUsersTypesComboBox('rang_access',$rang_access));
	FormRow(' :<BR>    <BR>  ',ForumAdminGetUsersTypesComboBox('rang_add_theme',$rang_add_theme));
	FormRow('   :<BR>    <BR>   ',ForumAdminGetUsersTypesComboBox('rang_message',$rang_message));
	FormRow('&nbsp;',' &nbsp;');
	}

	$endata = array();
	$site->DataAdd($endata, '1', '', $close_topic[1]);
	$site->DataAdd($endata, '0', '', $close_topic[0]);
	FormRow('  .<BR>   .',
	$site->Select('close_topic', $endata));

	$endata = array();
	$site->DataAdd($endata, '1', '', $f_status[1]);
	$site->DataAdd($endata, '0', '', $f_status[0]);
	FormRow('', $site->Select('status', $endata));
	AddCenterBox($c_cap);
	AddForm($site->FormOpen('config', $config['admin_file'].'?exe=forum&a=cat_save'.$id_param), $site->Submit($b_cap));
}

function AdminForumCatSave()
{
	global $db, $config;
	/* @var $db Database_FilesDB */
	$f_title = SafeDB($_POST['title'], 255, str);
	$f_view = ViewLevelToInt($_POST['view']);
	$f_status = SafeEnv($_POST['status'], 1, int);

	    $f_admin_theme_add= 0;
		$f_new_message_email = 0;
		$f_no_link_guest= 0;
		$rang_access=0;
		$rang_message=0;
		$close_topic=0;
		$rang_add_theme=0;

	if(isset($_POST['admin_theme_add']))
		$f_admin_theme_add= SafeEnv($_POST['admin_theme_add'], 1, int);
	if(isset($_POST['new_message_email']))
		$f_new_message_email = SafeEnv($_POST['new_message_email'], 1, int);
	if(isset($_POST['no_link_guest']))
		$f_no_link_guest= SafeEnv($_POST['no_link_guest'], 1, int);
	if(isset($_POST['rang_access']))
	    $rang_access=SafeEnv($_POST['rang_access'], 11, int);
	if(isset($_POST['rang_message']))
		$rang_message=SafeEnv($_POST['rang_message'], 11, int);
	if(isset($_POST['rang_add_theme']))
	    $rang_add_theme=SafeEnv($_POST['rang_add_theme'], 11, int);
	if(isset($_POST['close_topic']))
		$close_topic= SafeEnv($_POST['close_topic'], 1, int);	  

	if(isset($_POST['desc'])){
		$f_desc = SafeEnv($_POST['desc'], 0, str);
	}else{
		$f_desc = '';
	}
	if(isset($_POST['parent_id'])){
		$f_parent = SafeEnv($_POST['parent_id'], 11, int);
	}else{
		$f_parent = '0';
	}
	if(isset($_GET['id'])){
		// 
		$id = SafeEnv($_GET['id'], 11, int);
		$set = "`parent_id`='$f_parent',`title`='$f_title',`description`='$f_desc',`view`='$f_view',`status`='$f_status',`admin_theme_add`='$f_admin_theme_add',`no_link_guest`='$f_no_link_guest',`new_message_email`='$f_new_message_email',`rang_access`='$rang_access',`rang_message`='$rang_message',`rang_add_theme`='$rang_add_theme',`close_topic`='$close_topic'";
		$db->Update('forums', $set, "`id`='$id'");
	}else{
		// 
		$order = AdminForumGetOrder('0');
		$values = "'','$f_parent','$f_title','$f_desc','0','0','0','0','','','0','$order','$f_status','$f_view','f_admin_theme_add','f_no_link_guest','f_new_message_email', '$rang_access', '$rang_message', '$rang_add_theme','$close_topic'";
		$db->Insert('forums', $values);
	}
    Forum_Cache_ClearAllCacheForum();
	GO($config['admin_file'].'?exe=forum');
}

function AdminForumMove()
{
	global $config, $db;
	$move = SafeEnv($_GET['to'], 4, str); // up, down
	$id = SafeEnv($_GET['id'], 11, int);
	$db->Select('forums', "`id`='$id'");
	if($db->NumRows() > 0){
		$forum = $db->FetchRow();
		$pid = SafeDB($forum['parent_id'], 11, int);
		$forums = $db->Select('forums', "`parent_id`='$pid'");
		SortArray($forums, 'order');
		$c = count($forums);
		// 
		$cur_pos = 0;
		for($i = 0; $i < $c; $i++){
			$forums[$i]['order'] = $i;
			if($forums[$i]['id'] == $id){
				$cur_pos = $i;
			}
		}
		// 
		$rep_pos = $cur_pos;
		if($move == 'up'){
			$rep_pos = $cur_pos - 1;
		}elseif($move == 'down'){
			$rep_pos = $cur_pos + 1;
		}else{
			$rep_pos = $cur_pos;
		}
		if($rep_pos < 0 || $rep_pos >= $c){
			$rep_pos = $cur_pos;
		}
		$temp = intval($forums[$cur_pos]['order']);
		$forums[$cur_pos]['order'] = intval($forums[$rep_pos]['order']);
		$forums[$rep_pos]['order'] = intval($temp);
		for($i = 0; $i < $c; $i++){
			$order = $forums[$i]['order'];
			$id = $forums[$i]['id'];
			$db->Update('forums', "`order`='$order'", "`id`='$id'");
		}
	}
	Forum_Cache_ClearAllCacheForum();
	GO($config['admin_file'].'?exe=forum');
}

function AdminForumDelete()
{
	global $config, $db;
	if(!isset($_GET['id'])){
		GO($config['admin_file'].'?exe=forum');
	}
	if(isset($_GET['ok']) && $_GET['ok'] == '1'){
		ForumAdminDeleteForum(SafeEnv($_GET['id'], 11, int));
		Forum_Cache_ClearAllCacheForum();
		GO($config['admin_file'].'?exe=forum');
	}else{
		/* @var $db Database_FilesDB */
		$db->Select('forums', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
		$r = $db->FetchRow();
		if($r['parent_id'] == -1){
			$f = '';
		}else{
			$f = '';
		}
		$text = '    '.$f.' "'.SafeDB($r['title'], 255, str).'"?       .<br />'.'<a href="'.$config['admin_file'].'?exe=forum&a=delete&id='.SafeEnv($_GET['id'], 11, int).'&ok=1"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a>';
		AddTextBox("!", $text);
	}
}

function AdminForumChangeStatus()
{
	global $config, $db;
	$db->Select('forums', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	$r = $db->FetchRow();
	if($r['status'] == 1){
		$en = '0';
	}else{
		$en = '1';
	}
	$db->Update('forums', "status='$en'", "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	Forum_Cache_ClearAllCacheForum();
	GO($config['admin_file'].'?exe=forum');
}

/***********************************/
function AdminForumBasket($table='forum_basket_post')
{
	global $db, $config, $site;

	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'],10,int);
	}else{
		$page = 1;
	}

	if($table == 'forum_basket_post'	){
	$site->Title .= ' >  ';
	$caption =  ' ';
	}
	else
	{$site->Title .= ' >  ';	
	$caption =  ' ';
	}
	$result = $db->Select($table);
		if(count($result)>20){
		$navigator = new Navigation($page);
		$navigator->GenNavigationMenu($result,20,$config['admin_file'].'?exe=forum&a='.$table);
		AddNavigation();
		$nav = true;
	}else{
		$nav = false;
		
	}														  
	if($table == 'forum_basket_post'	){		
  $table_caption = ' ()';
   if(count($result)>0){
	 $mposts = array();
	 $mop='showtopic&topic=';
	 	  
	 $where = '';
	   foreach($result as $mpost)	  
		{
		 	 $where .=	"`id`='".$mpost['obj_id']."' or ";
		}
			$where = substr($where,0, strlen($where)-3);
	        $result_posts = $db->Select('forum_posts', $where);
			if(count($result_posts)>0)
		      {
				 foreach($result_posts as $mpost)
				  {
				    $mposts[$mpost['id']] =  $mpost['object'];
					$mpostsm[$mpost['id']] =  $mpost['message'];
				  }
				 foreach($result as $mpost)	  
		          {
					 $mpost['obj_id2'] =  $mposts[$mpost['obj_id']];
					 $mpost['obj_id'] =  $mpost['obj_id'] ;
					 $mpost['date'] =  $mpost['date'] ;
					 $mpost['user'] =  $mpost['user'] ;
					 $mpost['reason'] =  $mpost['reason'] ;
					 $mpost['message'] = $mpostsm[$mpost['obj_id']]; 
		 	         $result2[] = $mpost	 ;
		          }
				    $result =  $result2;
		      }
   }
	}
	else
	{
	  $mop='showtopic&topic=';
	  $table_caption = ' ( )';
	   if(count($result)>0)
		   {

		     $where = '';
	   foreach($result as $mpost)	  
		{
		 	 $where .=	"`id`='".$mpost['obj_id']."' or ";
		}
			$where = substr($where,0, strlen($where)-3);
	        $result_topics = $db->Select('forum_topics', $where);
			if(count($result_topics)>0)
		      {
				 foreach($result_topics as $mtopic)
				  {
				   	$mtopics[$mtopic['id']] =  $mtopic['title'];
				  }
				 foreach($result as $mtopic)	  
		          {
					 $mpost['obj_id'] =  $mtopic['obj_id'] ;
					 $mpost['date'] =  $mtopic['date'] ;
					 $mpost['user'] =  $mtopic['user'] ;
					 $mpost['reason'] =  $mtopic['reason'] ;
					 $mpost['message'] = $mtopics[$mtopic['obj_id']]; 
		 	         $result2[] = $mpost	 ;
		          }
				    $result =  $result2;
		      }
	       }
	}

	$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
	$text .= '<tr><th> </th><th> </th><th>  </th><th></th><th>  <BR>'. $table_caption.'</th><th></th></tr>';
		foreach($result as $basket){
		$mop =$mop.($table == 'forum_basket_post'?$basket['obj_id2']:$basket['obj_id']);
		$ainfo = GetUserInfo($basket['user']);
		$text .= '<tr>
		<td>'.$ainfo['name'].'</td>
		<td>'.TimeRender($basket['date'], false, false).'</td>
		<td>'.TimeRender($basket['date']+(86400*$config['forum']['clear_basket_day']), false, false).'</td>
		<td>'.$basket['reason'].'</td>
		<td>'.(isset($basket['message'])?$basket['message']:'').'</td>
		<td><a href="index.php?name=forum&op=restore_basket&'.$table.'='.$basket['obj_id'].'"></a>
		&nbsp;<a href="index.php?name=forum&op='.$mop.'" target="_blank"></a>	</td>
		</tr>';	
	}
	$text .= '</table>';
	AddTextBox($caption , $text);
	if($nav){
		AddNavigation();
	}
}

include_once ($config['apanel_dir'].'configuration/functions.php');
function AdminForum( $action )
{	 global $config;

if(isset($config['forum']['basket'])){
if ($config['forum']['basket'] == true	 )
	switch($action){
		case 'forum_basket_posts':
		case 'forum_basket_topics':
	 	case 'forum_basket':
	TAddToolLink('  ', 'main', 'forum');
	TAddToolLink(' ', 'forum_basket_topics', 'forum&a=forum_basket_topics');
	TAddToolLink(' ', 'forum_basket_posts', 'forum&a=forum_basket_posts');
	TAddToolBox($action);
	TAddSubTitle(' > ');
	switch($action){
	      ////////////////// 
		case 'forum_basket_posts':
			AdminForumBasket();
			break;
			case 'forum_basket_topics':
			AdminForumBasket('forum_basket_topics');
			break;
			default:
			AdminForumBasket();
	}
		////////////////////////////////////////////
		return true;
		break;
	}
	else
	{
	    if($config['forum']['del_auto_time']>0)
			{
			  Forum_Basket_RestoreBasketAll()	;
	        }
	}
}

	TAddToolLink(' ', 'main', 'forum');
	TAddToolLink(' ', 'cat_editor', 'forum&a=cat_editor');
	TAddToolLink(' ', 'forum_editor', 'forum&a=forum_editor');
if(isset($config['forum']['basket']))
	if ($config['forum']['basket'] == true	 )
	TAddToolLink('', 'forum_basket', 'forum&a=forum_basket');

	TAddToolLink('', 'config', 'forum&a=config');
	TAddToolBox($action);
	TAddSubTitle('');
	switch($action){
		case 'main':
			AdminForumMain();
			break;
		case 'changestatus':
			AdminForumChangeStatus();
			break;
		case 'cat_editor':
		case 'forum_editor':
			AdminForumCatEditor($action);
			break;
		case 'cat_save':
			AdminForumCatSave();
			break;
		case 'move':
			AdminForumMove();
			break;
		case 'delete':
			AdminForumDelete();
			break;

		////////////////// 
		case 'config':
			AdminConfigurationEdit('forum', 'forum', false, false, ' ');
			return true;
			break;
		case 'configsave':
			AdminConfigurationSave('forum&a=config', 'forum', false);
			return true;
			break;
		////////////////////////////////////////////

		case 'update':
		if (file_exists(MOD_DIR.'update.php')){
        include_once(MOD_DIR.'update.php');	 
			Forum_Update();
			return true;
		}
		else
		{
			global $site, $lang;
		 	AddTextBox($lang['error'] , $lang['error_file_exists'].' <B>'.MOD_DIR.'update.php'.'</B> ');

		}
			break;
		default:
			AdminForumMain();
	}
}
if(isset($_GET['a'])){
	AdminForum($_GET['a']);
}else{
	AdminForum('main');
}
?>