<?php
# LinkorCMS
# LinkorCMS Development Group
# www.linkorcms.ru
#  LinkorCMS 1.2.
#    

//    .
function Forum_Add_AddPost2( $topic = null )
{
	global $db, $config, $user, $lang;
	$er = array();
	$text = '';
	if($topic == null){
		if(isset($_GET['topic'])){
			$object = SafeEnv($_GET['topic'], 11, int);
		}else{
			$er[] = $lang['error'].': !isset($_GET[\'topic\']).';
		}
	}else{
		$object = $topic;
	}
	if((!isset($_POST['name'])
			|| !isset($_POST['email'])
			|| !isset($_POST['site'])
			|| !isset($_POST['icq'])
			|| !isset($_POST['text']))
			&& !$user->Auth)
	{
		$er[] = $lang['no_data'];
	}else{
		if($user->Auth){
			$name = $user->Get('u_name');
			$email = $user->Get('u_email');
			$hideemail = $user->Get('u_hideemail');
			$site = $user->Get('u_homepage');
			$icq = $user->Get('u_icq');
			$uid = $user->Get('u_id');
		}else{
			$er[] =$lang['no_reg_add'];
		}
		$text = SafeEnv($_POST['text'], 0, str);
		if(strlen($text) == 0){
			$er[] =$lang['no_message'];
		}
	}
	if(!$user->Get('u_add_forum')){
		$er[] =$lang['blocking'];
	}
	if(count($er) == 0){
		$mdb = $db->Select('forum_topics', "`id`='$object'");
		if( count($mdb)>0 and $mdb[0]['delete'] == 0 or  $config['forum']['basket'] == false){
		$vals = Values('', $object, $uid, time(), $name, $site, $email, $hideemail, $icq, $text, getip(),0);
		$db->Insert('forum_posts', $vals);
		return true;
		}
		else
		{
		   $er[] = $lang['topic_basket'].'.'.$lang['no_topic_basket_edit'];
		   return $er;
		}
	}else{
		return $er;
	}
}

function Forum_Add_AddTopic()
{
	global $user, $db, $site, $config, $lang;
	/* @var $db Database_FilesDB */
	include_once ($config['inc_dir'].'comment.class.php');
	if(isset($_GET['forum']) && isset($_POST['topic_title']) && isset($_POST['text'])){
		$page=1;
		if(isset($_GET['page']))
		$page=$_GET['page'];
		//  
		$forum_id = SafeEnv($_GET['forum'], 11, int);
		$db->Select('forums',"`id`='$forum_id'");
		$forum = $db->FetchRow();
		if($user->AccessIsResolved($forum['view']) && $user->AccessIsResolved(2) && $forum['parent_id'] != '0' && $user->Get('u_add_forum')){
				#   
				$rang=Rang_UserStatus($forum);
				if($rang['rang_access']){
			$uniq_code = GenRandomString(12, '1234567890');
			$topic_title = SafeEnv($_POST['topic_title'], 255, str);
			$time = time();
			$topic_values = Values('', $forum_id, $topic_title, '1', '0', '0', $time, $user->Get('u_id'), $user->Get('u_name'), $time, '0', '', $uniq_code,0,0,0);
			if(strlen($topic_title) == 0){
				$topic_error = array();
				$topic_error[] = $lang['no_title_topic'];
				$site->AddTextBox($lang['error'], IndexForumPrintErrors($topic_error));
				return;
			}
			$db->Insert('forum_topics', $topic_values);
			//  
			$db->Select('forum_topics', "`uniq_code`='$uniq_code'");
			$topic = $db->FetchRow();
			$topic_id = SafeDB($topic['id'], 11, int);
			$result = Forum_Add_AddPost2($topic_id);
			if(is_array($result)){
				$site->AddTextBox($lang['error'], IndexForumPrintErrors($result));
				$db->Delete('forum_topics', "`id`='$topic_id'");
			}else{
				$user->ChargePoints($config['points']['forum_post']);
				$forum['topics'] = SafeDB($forum['topics'],11,int) + 1;
				IndexForumSetLastPostInfo($forum, $topic);

				$u_id = $user->Get('u_id');
				$time = time();
				$vals = "'$u_id','$topic_id','$time'";
				$db->Insert('forum_topics_read',$vals);
				if($config['forum']['update_cache_in_add'])
				Forum_Cache_ClearAllCacheForum();
				GO('index.php?name=forum&op=showforum&forum='.$forum_id);
			}
		}else{
			$site->AddTextBox($lang['error'], $lang['error_access_category']);
		}
		}else{
			$site->AddTextBox($lang['error'], $lang['error_access_category']);
		}
	}else{
		$site->AddTextBox($lang['error'], $lang['error_data']);
	}
}


function Forum_Add_AddPost()
{
	global $db, $config, $user, $site, $lang;
	$topic_id = SafeEnv($_GET['topic'], 11, int);
	$forum_id = SafeEnv($_GET['forum'], 11, int);

	$db->Select('forums',"`id`='$forum_id'");
	$forum = $db->FetchRow();
	if($user->AccessIsResolved($forum['view']) && $user->AccessIsResolved(2) && $forum['parent_id'] != '0'){
				#   
				$rang=Rang_UserStatus($forum);
				if($rang['rang_access']){
		$result = Forum_Add_AddPost2();
		if(is_array($result)){
			$site->AddTextBox($lang['forum'], IndexForumPrintErrors($result));
		}else{
			$user->ChargePoints($config['points']['forum_post']);
			$db->Select('forum_topics',"`id`='$topic_id'");
			if($db->NumRows() > 0){
			$topic = $db->FetchRow();
				
				$u_id = $user->Get('u_id');
				$db->Delete('forum_topics_read',"`tid`='$topic_id' and `mid`='$u_id'");
				$time = time();
				$vals = "'$u_id','$topic_id','$time'";
				$db->Insert('forum_topics_read',$vals);

				$forum['posts'] = (int)$forum['posts'] + 1;
				$topic['posts'] = (int)$topic['posts'] + 1;
				IndexForumSetLastPostInfo($forum, $topic);	 
				Forum_Subscription_Send($topic_id);
				if($config['forum']['update_cache_in_add'])
				Forum_Cache_ClearAllCacheForum();   
			}
			GO('index.php?name=forum&op=showtopic&topic='.$topic_id.'&view=lastpost');
		}
	}else{
		$site->AddTextBox($lang['error'], $lang['error_access_category']);
	}
	}else{
		$site->AddTextBox($lang['error'], $lang['error_access_category']);
	}
}


function Forum_Add_EditPostSave()
{
	global $db, $site, $user, $lang;
	if(!$user->Auth){
		$site->AddTextBox($lang['forum'], '<center>'.$lang['error_auth'].'</center>');
		return;
	}
	$post_id = SafeEnv($_GET['post'],11,int);
	$db->Select('forum_posts', "`id`='$post_id'");
	$post = $db->FetchRow();
   if( $post['delete'] == 0 or $config['forum']['basket'] == false){
	    $db->Select('forum_topics', "`id`='".$post['object']."'");
	  	$topic = $db->FetchRow();
	if( $topic['delete'] == 0 or $config['forum']['basket'] == false ){
	if($user->Get('u_id') == $post['user_id'] || $user->isAdmin()){
		$topic_id = SafeEnv($_GET['topic'],11,int);
		$text_value = SafeEnv($_POST['text'],100000,str);
		$text_title ='';
		if(isset($_POST['title']))
		$text_title = SafeEnv($_POST['title'],255,str);
		$db->Update('forum_posts',"`message`='$text_value'","`id`='$post_id'");
		if(isset($_POST['title'])){
		$object=$post['object'];
		$db->Update('forum_topics',"`title`='$text_title'", "`id`='$object'");
		}
		$page=1;
		if(isset($_GET['page']))
		$page=$_GET['page'];
		 Forum_Cache_ClearAllCacheForum();
		GO('index.php?name=forum&op=showtopic&topic='.$topic_id.'&page='.$page);
	}else{
		$site->AddTextBox($lang['forum'], '<center>'.$lang['no_right_comment_edit'].'</center>');
		return;
	}
		}
	else
		{
		 $site->AddTextBox($lang['topic_basket_current_post'], '<center>'.$lang['topic_basket_post'].'.</BR><input type="button" value="'.$lang['back'].'"onclick="history.back();"></center>');
		}
   }
   else
	{
	  $site->AddTextBox($lang['post_basket'], '<center>'.$lang['post_basket_no_edit'].'.</BR><input type="button" value="'.$lang['back'].'"onclick="history.back();"></center>');
	}
}


?>