<?php
# LinkorCMS
# LinkorCMS Development Group
# www.linkorcms.ru
#  LinkorCMS 1.2.
# 

function Posts_DeletePost()
{
	global $db, $site, $user, $config, $lang;
	if(isset($_GET['ok'])){
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 11, int);
	}else{
		$page = 1;
	}
		$post_id = SafeEnv($_GET['post'], 11, int);
		$db->Select('forum_posts',"`id`='$post_id'");
		$post = $db->FetchRow();
	 if($post['delete'] == 0){
		 $public =  SafeDB($post['public'],11,int);
		// 
		$topic_id = SafeEnv($_GET['topic'],11,int);
		$set_last = true;
		$last_db = $db->Select('forum_posts',"`object`='$topic_id' and `id`>'$post_id' and `delete`='0'");
		if(count($last_db)>0)
		$set_last = false;

		$db->Select('forum_topics',"`id`='$topic_id'");
		$topic = $db->FetchRow();
	 if($topic['delete'] == 0){
		$tposts = (int)$topic['posts'] - 1;
		if($tposts<0)$tposts =0;
		$last_post =  SafeDB($topic['last_post'],11,int);
		$last_post_topic=  SafeDB($topic['last_post'],11,int);
		    $post_array_ignore = array();
			$post_array_ignore[] = 	 $post_id;
			if($set_last)  
		    TopicSetLastPostInfoDelete($topic_id,$post_array_ignore) 	;
		    $db->Update('forum_topics',"`posts`='$tposts'","`id`='$topic_id'");
		// }
		// 
		$forum_id = SafeDB($topic['forum_id'],11,int);
		$db->Select('forums',"`id`='$forum_id'");
		$forum = $db->FetchRow();
		$fposts = (int)$forum['posts'] - 1;
		 if($fposts<0)$fposts=0;
		$db->Update('forums',"`posts`='$fposts'","`id`='$forum_id'");
		 if($set_last)  
		  ForumSetLastPostInfoDelete($forum_id,'', '', array(),$post_array_ignore);
	 }
	 }
	 if($config['forum']['basket'] == false){
		//  
		ForumAdminDeletePost($post_id);
	 }
	 else
		{
		  $text_value = '';
		  if(isset($_POST['text']))
		  $text_value = SafeEnv($_POST['text'],255,str);
		  Moderation_Do_Basket_Post($post_id, $text_value)	 ;
		}

		Forum_Cache_ClearAllCacheForum();
		GO('index.php?name=forum&op=showtopic&topic='.$topic_id.'&page='.$page);
	}else{
		$text = '<br />'.$lang['delete_post'].'?<br /><br />'
		.' <a href="javascript:history.go(-1)"></a>';
		$site->AddTextBox($lang['forum'], '<center>'.$text.'</center>');
		$site->AddTemplatedBox('', 'module/forum_delete_post.html');
    	$site->AddBlock('delete_form', true, false, 'form');
		$vars = array();
		$vars['basket'] = $config['forum']['basket'] == true ;
	    $vars['url'] ='index.php?name=forum&amp;op=deletepost&amp;topic=' . SafeEnv($_GET['topic'], 11, int) . '&amp;post='. SafeEnv($_GET['post'], 11, int) .'&amp;ok=1';
	    $site->Blocks['delete_form']['vars'] = $vars;
	}
}


function Posts_EditPost()
{
	global $db, $site, $user, $config, $lang;
	if(!$user->Auth){
		$site->AddTextBox($lang['forum'], '<center>'.$lang['error_auth'].'</center>');
		return;
	}
	$post_id = SafeEnv($_GET['post'],11,int);
	$topic = SafeEnv($_GET['topic'],11,int);		
	$db->Select('forum_topics', "`id`='$topic'");
	$topic = $db->FetchRow();
	if( $topic['delete'] == 0 or $config['forum']['basket'] == false){
	 $title='';
	if(SafeDB($topic['starter_id'],11,str)==$user->Get('u_id') or  $user->IsAdmin())
	   $title=SafeDB($topic['title'],0,str);
	$db->Select('forum_posts', "`id`='$post_id'");
	$post = $db->FetchRow();
	if( $post['delete'] == 0 or $config['forum']['basket'] == false){
	if($user->Get('u_id') == $post['user_id'] || $user->isAdmin()){
		Posts_RenderPostForm(true, 0, SafeEnv($_GET['topic'],11,int), SafeDB($post['id'],11,int), SafeDB($post['message'],0,str,false,true),$title);
	}else{
		$site->AddTextBox($lang['forum'], '<center>'.$lang['no_right_comment_edit'].'</center>');
		return;
	}
	   	}
	else
		{
		  $site->AddTextBox($lang['post_basket'], '<center> '.$lang['post_basket_no_edit'].'</BR><input type="button" value="'.$lang['back'].'"onclick="history.back();"></center>');
		}
		}
	else
	{
	   	 $site->AddTextBox($lang['topic_basket_current_post'], '<center> '.$lang['topic_basket_post'].'</BR><input type="button" value="'.$lang['back'].'"onclick="history.back();"></center>');
	}
}

function Posts_RenderPosts( $topic_id, $blockname, $lastpost = false, $page = 0, $EnNav = false, $com_on_page = 10, $nav_url = '' ,$no_link_guest=false,$your_where='' )
{
	global $site, $db, $config, $user, $lang;
	$cache_name = 'IndexForumRenderPosts_page'.$page.'_'; 
	$site->AddBlock($blockname, true, true, 'post');
	if($user->isAdmin() or  $config['forum']['basket'] == false) 
	{
		$your_where=''; 
		$cache_name .= 'object'.$topic_id; 
	}
	else
	{
	   $cache_name .= 'object'.$topic_id.'_u'; 
	}
	if($user->isAdmin()) $cache_name .='a_page'.$page;
	$where = "`object`='" . $topic_id . "'".$your_where;
	if($lastpost){
	  $cache_name .= 'lastpost';
	}
	Forum_Cache_CacheCreate($cache, $cache_name, $config['forum']['maxi_cache_duration']);	 
	
  if(!$coms = $cache->load())
  {	
	$coms = $db->Select('forum_posts', $where);
	SortArray($coms, 'public', false); //  
	if(count($coms) > $com_on_page && $EnNav){
		if($lastpost){
			$page = round(count($coms) / $com_on_page)+1;
		}
		$comm_nav_obj = new Navigation($page, 'navigation');
		$comm_nav_obj->GenNavigationMenu($coms, $com_on_page, $nav_url);
	}
	else
	  {
		  $site->AddBlock('navigation',false, false);
	  }


	$basket = Forum_Basket_RenderBasket($coms);
	$i=1;
	$i2 =1;
	foreach($coms as $comment){
		$uid = $comment[2];
		$vars = array();

		if($comment['delete'] == 0 or $config['forum']['basket'] == false){
		$vars['text'] = htmlspecialchars($comment[9]);
		if ($no_link_guest)
		No_link_guest($vars['text']);	
		$vars['mpage'] =  ($lastpost?$page-1:$page);
		SmiliesReplace($vars['text']);
		$vars['text'] = nl2br($vars['text']);
		$vars['text'] = BbCodePrepare($vars['text']);
		}	 
		else
		{
            $vars['text'] = Forum_Basket_RenderBasketComAdmin($comment[0], $comment[9], $basket ) ;
		}	 
		if($uid != 0){
			$userinfo = GetUserInfo($uid);
			$vars['public'] = $comment['public'];
			if($userinfo['rank_name']<>''){
			$vars['author'] = '<a href="index.php?name=user&amp;op=userinfo&amp;user=' . $uid . '">' . $userinfo['name'] . '</a>';
			}
			else
			{
			 $vars['author'] =  $comment['name'];
			}
			if($userinfo['hideemail'] == '0'){
				$vars['email'] = AntispamEmail($userinfo['email']);
			}else{
				$vars['email'] = '&nbsp;';
			}
			$vars['homepage'] = $userinfo['url'];
			$vars['icq'] = $userinfo['icq'];
			if($userinfo['online']){
				$vars['status'] = $lang['user_online'];
			}else{
				$vars['status'] = '';
			}
			$vars['rank_image'] = ($userinfo['rank_image']<>''?$userinfo['rank_image']:'');
			$vars['rank_name'] = ($userinfo['rank_name']<>''?$userinfo['rank_name']:''); 

			$vars['avatar'] = ($userinfo['avatar_file']<>''?$userinfo['avatar_file']: GetPersonalAvatar(0));
			$vars['regdate'] = TimeRender($userinfo['regdate'], false, false);
			$ruser = true;
		}else{
			$vars['author'] = strip_tags($comment[4]);
			$vars['public'] = $comment[3];
			if($comment[6] != '' && $comment[7] != 0){
				$vars['email'] = AntispamEmail(strip_tags($comment[6]));
			}else{
				$vars['email'] = '&nbsp;';
			}
			if($comment[5] != ''){
				$vars['homepage'] = strip_tags($comment[5]);
			}else{
				$vars['homepage'] = '';
			}
			if($comment[8] != ''){
				$vars['icq'] = strip_tags($comment[8]);
			}else{
				$vars['icq'] = '&nbsp;';
			}
			$vars['rank_image'] = '';
			$vars['rank_name'] = '';
			$vars['avatar'] = GetPersonalAvatar(0);
			$vars['regdate'] = '';
			$ruser = false;
		}
		if($vars['homepage'] != ''){
			$vars['homepage'] = '<a href="http://' . $vars['homepage'] . '" target="_blank">' . $vars['homepage'] . '</a>';
		}else{
			$vars['homepage'] = '&nbsp;';
		}
		$vars['public'] = $lang['added'] . TimeRender($vars['public']);
		$vars['ip'] = SafeDB($comment['user_ip'],19,str);
		$vars['topic_id'] = $topic_id;
		$vars['id'] = SafeDB($comment['id'],11,int);
		$vars['nodelete'] = (SafeDB($comment['delete'], 1, int)?false:true);
		$vars['page'] = $page;
		$vars['last'] = false;
		$vars['start'] = false;
		if($i2 == 1)
		{
		  $vars['start'] = true;
		}
		
		if($i2 == count($coms))
		{
		  $vars['last'] = true;
		}
		$i2++;
		if($comment['delete'] == 0){
		  $vars['is_current_user'] = ($user->Get('u_id') == $comment['user_id'] || $user->isAdmin());
		}	
         else
		{
		   $vars['is_current_user'] = false	;
		}
		
		$site->AddSubBlock($blockname, true, $vars, array(), 'module/forum_post.html');
	}
	if($config['forum']['cache']){
		$mcache = array();
	if (isset($site->Blocks['navigation']))
	$mcache['navigation'] = $site->Blocks['navigation'];
	$mcache['blocks'] = 	 $site->Blocks[$blockname];
	$cache->save($mcache);	
	}
  }
  else
	{
	if (isset($coms['navigation']))
	 $site->Blocks['navigation'] = $coms['navigation'];
	 $site->Blocks[$blockname] = $coms['blocks'];
	}
}

function Posts_RenderPostForm($edit = false, $forum = 0, $topic = 0, $id = 0, $value = '',$text_title='',$loadform=true)
{
	global $site, $db, $config,$user, $lang;
	$site->AddTemplatedBox('', 'module/forum_edit_post.html');
	if($user->Get('u_add_forum')){
	$site->AddBlock('forum_editpost_form',$loadform, false, 'form');
	$vars = array();
	if($edit){
		$page=1;
		if(isset($_GET['page']))
		$page=$_GET['page'];
		$vars['pag'] = $page;
		$vars['post'] = $id;
		$vars['text_value'] = $value;
		$vars['text_title'] = $text_title;
		$vars['edit_title'] = $text_title<>'';
		$vars['topic'] = $topic;
		$vars['title'] = $lang['edit_post'];
		$vars['url'] = "index.php?name=forum&amp;op=savepost&amp;topic={$topic}&amp;post={$id}&amp;page={$page}";
		$vars['edit'] = true;
		$vars['lsubmit'] = $lang['save'];
		$vars['lsubmit_title'] = $lang['save_edit'];
		$vars['visibility'] = 'visible';
	}else{
		$vars['post'] = 0;
		$vars['topic'] = $topic;
		$vars['forum'] = $forum;
		$vars['edit_title'] = $text_title<>'';
		$vars['text_value'] = '';
		$vars['title'] = $lang['add_post'];
		$vars['url'] = "index.php?name=forum&amp;op=addpost&amp;topic=$topic&amp;forum=$forum";
		$vars['edit'] = false;
		$vars['lsubmit'] = $lang['add'];
		$vars['lsubmit_title'] =$lang['add_post'];
		$vars['visibility'] = 'hidden';
	}
	$vars['add'] = !$vars['edit'];
	$site->Blocks['forum_editpost_form']['vars'] = $vars;
    ForumSmile();

	}
}

function Posts_EditPostTitle()
{
	global $db, $site, $user, $config, $lang;
	if(!$user->Auth){
		$site->AddTextBox($lang['forum'], '<center>'.$lang['error_auth'].'</center>');
		return;
	}
	$topic = SafeEnv($_GET['topic'],11,int);		
	$post=$db->Select('forum_posts', "`object`='$topic' and `delete`='0'");
	 SortArray($post,0,false);

	$db->Select('forum_topics', "`id`='$topic'");

	$topic = $db->FetchRow();
	if( $topic['delete'] == 0 or $config['forum']['basket'] == false ){
	 $title='';
	if(SafeDB($topic['starter_id'],11,str)==$user->Get('u_id') or  $user->IsAdmin())
	   $title=SafeDB($topic['title'],0,str);

	if($user->Get('u_id') == $post[0]['user_id'] || $user->isAdmin()){
		Posts_RenderPostForm(true, 0, SafeEnv($_GET['topic'],11,int), SafeDB($post[0]['id'],11,int), SafeDB($post[0]['message'],0,str,false,true),$title);
	}else{
		$site->AddTextBox($lang['forum'], '<center>'.$lang['no_right_comment_edit'].'</center>');
		return;
	}
	}
	else
		{
		 $site->AddTextBox($lang['topic_basket_current_post'], '<center>'.$lang['topic_basket_post'].'</BR><input type="button" value="'.$lang['back'].'"onclick="history.back();"></center>');
		}
}


?>