<?php
# LinkorCMS
# LinkorCMS Development Group
# www.linkorcms.ru
#  LinkorCMS 1.2.																					
#  

function Forum_Topic_DataFilter( &$topic, $root = true )
{	 global  $lang;
	$topic2 = array();
	$topic2['id'] = SafeDB($topic['id'], 11, int);
	$topic2['forum_id'] = SafeDB($topic['forum_id'], 11, int);
	$topic2['title'] = SafeDB($topic['title'], 255, str);
	$topic2['state'] = SafeDB($topic['state'], 1, int);
	$topic2['posts'] = SafeDB($topic['posts'], 11, int);
	$topic2['hits'] = SafeDB($topic['hits'], 11, int);
	$topic2['start_date'] = TimeRender(SafeDB($topic['start_date'], 11, int), true, true);
	$topic2['starter_id'] = SafeDB($topic['starter_id'], 11, int);
	$topic2['starter_name'] = SafeDB($topic['starter_name'], 255, str);
	$topic2['last_post_date'] = SafeDB($topic['last_post'], 11, int);
	$topic2['last_post'] = TimeRender(SafeDB($topic['last_post'], 11, int), true, true);
	$topic2['last_poster_id'] = SafeDB($topic['last_poster_id'], 11, int);
	$topic2['last_poster_name'] = SafeDB($topic['last_poster_name'], 255, str);
	$c = Online_GetCountUser($topic2['id'], $root, true);	 
	$topic2['read'] = $c['count'];
	$topic2['users'] = $c['users'];
	$topic2['close'] = SafeDB($topic['close_topics'], 1, int)==0;
	$topic2['begin'] = !$topic2['close'];
	$topic2['status'] = (!$topic2['close']?$lang['topic_close']:'');
	$topic2['stick'] = ($topic['stick'] == 1?$lang['it_is_ important']:'');
	$topic2['delete'] = SafeDB($topic['delete'], 1, int);
	$topic2['nodelete'] = (SafeDB($topic['delete'], 1, int)?false:true);
	return $topic2;
}

function Forum_Topic_SetHitsData($topic_id)
{
	global  $db,$user;
	if( $topic_id<>''){
		$where = "`id`='$topic_id'";
		$topic = $db->Select('forum_topics',$where);
		if(count($topic)>0)
		{
			$hits = $topic[0]['hits'] + 1;
			$db->Update('forum_topics', "hits='".$hits."'", "`id`='" . $topic_id . "'");
		}
	}

}


function Forum_Topic_ShowTopic()
{
	global $db, $config, $site, $user, $lang;
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 11, int);
	}else{
		$page = 1;
	}

	if(isset($_GET['view']) && $_GET['view'] == 'lastpost'){
		$lastpost = true;
	}else{
		$lastpost = false;
	}

	$topic_id = SafeEnv($_GET['topic'], 11, int);

	if($user->Auth){
			$u_id = $user->Get('u_id');
			$db->Delete('forum_topics_read',"`tid`='$topic_id' and `mid`='$u_id'");
			$time = time();
			$vals = "'$u_id','$topic_id','$time'";
			$db->Insert('forum_topics_read',$vals);
	}

	$cache_name = 'Forum_Topic_ShowTopic_AccessLevel'.$user->AccessLevel();
	  $cache_name .= 'page'.$page;
	if($lastpost){
	  $cache_name .= 'lastpost';
	}
	$your_where = " and`delete`='0'" ;
	if($user->isAdmin() or $config['forum']['basket'] == false)
	{
		$your_where=''; 
	}
	else
	{
	  $cache_name .='_d';
	}
	 $cache_name .='_id'.$topic_id;

if($config['forum']['cache'])
{
  if(!$user->Auth)
	{	
	 	Forum_Cache_CacheCreate(&$quest,$cache_name.'_quest_' , 0);
		 if($block = $quest->load())
		{
			Forum_Topic_SetHitsData($topic_id);
			$site = $block;
			$site->TEcho();
			exit;
			 return true;
		}
	}
}


	Forum_Cache_CacheCreate($cache, $cache_name, $config['forum']['maxi_cache_duration']);
  if(!$topics = $cache->load())
  {
	$topics = $db->Select('forum_topics', "`id`='$topic_id'");	
	if($config['forum']['cache'])
     $cache->save($topics);	 
  }		
	if(count($topics) > 0){	    
		$topic =$topics[0];		   
		$delete = ($config['forum']['basket']?SafeDb($topic['delete'], 1,  int):false) ;	 
		if( $delete == 0 or $user->isAdmin()){	  
		if($delete == 1 and $user->isAdmin()){
			if ($config['forum']['basket']){
			$basket = Forum_Basket_RenderBasket($topics, 'forum_basket_topics');
			
			if(isset($basket[$topic[0]])){
			  $text = Forum_Basket_RenderBasketComAdmin($topic[0], $topic['title'], $basket, true,true ) ;
			  $site->AddTextBox($lang['topic_basket_red'], $text);
			}
			}
		  	}		 
	$c = Online_GetCountUser($topic['id'], false, true);
	$topic2['read'] = $c['count'];
	$topic2['users'] = $c['users'];
		$forum_id = SafeDB($topic['forum_id'], 11, int);
		$mforums  =  Forum_Cache_AllDataTableForum();
		if(count($mforums) > 0){
		 foreach($mforums as $mforum)
			{
			 if($mforum['id'] == $forum_id)  
			   $forum = $mforum;
			}
			 foreach($mforums as $mforum)
			{
			if($mforum['id'] == $forum['parent_id'])  
			            $parent = $mforum;  
			}
		}
		if($parent['close_topic'] == 1){
			  $forum['close_topic'] = 1;
			}
		if(($user->AccessIsResolved($forum['view']) && $forum['parent_id'] != '0') and 
			($user->AccessIsResolved($parent['view']))){

				#   
				$rang=Rang_UserStatus($forum);
				if($rang['rang_access']){
				$right=$rang['right'];
				$is_message_add	 =$rang['rang_message']; 
							
			Navigation_AppLink($lang['forum'], 'index.php?name=forum');
			if(count($mforums) > 0){
		 foreach($mforums as $mforum)
			{
			 if($mforum['id'] == $forum['parent_id'])  
			   $parent = $mforum;  
			}
		}
			Navigation_AppLink($parent['title'], 'index.php?name=forum&amp;cat='.$parent['id']);
			Navigation_AppLink($forum['title'], 'index.php?name=forum&amp;op=showforum&amp;forum='.$forum['id']);
			Navigation_ShowNavMenu();
		   $site->Title .= $lang['site_slas'].$parent['title']  .$lang['site_slas']. $forum['title'] .$lang['site_slas'].$topic['title'];
			
			$site->AddTextBox('','<b>'.$topic['title'].'</b>'.$topic2['read']);
			$db->Update('forum_topics', "hits='" . (SafeDB($topic['hits'], 11, int) + 1) . "'", "`id`='" . $topic_id . "'");
			$site->AddTemplatedBox('', 'module/forum_showtopic.html');
			// 
			$posts_on_page = $config['forum']['posts_on_page'];
			Posts_RenderPosts($topic_id, 'forum_posts', $lastpost, $page, true, $posts_on_page, 'index.php?name=forum&amp;op=showtopic&amp;topic=' . $topic_id,$rang['no_link_guest'], $your_where);
			$is_forum_member = $user->AccessIsResolved(2);
			$site->AddBlock('post_form', $is_forum_member ,false);
			if($is_message_add ){
			$rang= Rang_RangUserTopic($rang,$topic);
			 $is_message_add = $rang['rang_message']; 
			 $right = $rang['right'];
			}
			if(!$is_message_add ) $is_forum_member=false;
			
			if($is_message_add )
			Posts_RenderPostForm(false, $forum['id'], $topic['id'], 0, '','', $is_forum_member);
			
		   $is_subscription = $forum['new_message_email'] == 1;
		   $site->AddBlock('subscription', $is_subscription ,false, 'subs');
		   $vars_subs['topic'] = $topic_id;
		   $site->Blocks['subscription']['vars'] = $vars_subs;

		   $site->AddBlock('is_forum_member', $is_forum_member,false, 'marker');
		   $vars_marker['id'] = $topic_id;
		   $site->Blocks['is_forum_member']['vars'] = $vars_marker;

		   $site->AddBlock('is_marker',true,false, 'marker');
		   $vars_marker['id'] = $topic_id;
		   $site->Blocks['is_marker']['vars'] = $vars_marker;
					$site->AddBlock('topic_right', true, true, 'topic');
					$vars=array();
					$vars['right']=$right;
					$site->AddSubBlock('topic_right', true, $vars);		
					if(isset($topic2['users']))
					 Forum_Online_Render_Online($topic2['users'], $lang['current_online']) ;
			}else{
			$site->AddTextBox($lang['error'], $lang['error_access_category']);
		}
		}else{
			$site->AddTextBox($lang['error'], $lang['error_access_category']);
		}
	}else{
		$site->AddTextBox($lang['topic_basket'], $lang['topic_basket_current'].'</BR><input type="button" value="'.$lang['back'].'"onclick="history.back();"></center>');
	}
	}else{
		$site->AddTextBox($lang['error'], '<center><input type="button" value="'.$lang['back'].'"onclick="history.back();"></center>');
	}
  	$site->AddTextBox('', '<span style="float:right;">'.$lang['quick_transition'].':&nbsp;'. Navigation_GetForumCategoryComboBox($forum_id).'</span>');
if($config['forum']['cache'])
{
  if(!$user->Auth)
	{	
		if($config['forum']['cache']){
		$mcache = array();
		Forum_Cache_CacheCreate(&$quest, $cache_name.'_quest_' , 0);
	    	$quest->save($site);	
		}
	}
}

}

function Forum_Topic_DeleteTopic()
{
	global $db, $site,  $user, $config, $lang;
	if(isset($_GET['ok'])){
		$topic_id = SafeEnv($_GET['topic'], 11, int);
		$db->Select('forum_topics',"`id`='$topic_id'");
		$topic = $db->FetchRow();	
		$forum_id = SafeDB($topic['forum_id'],11,int);
	 if($topic['delete'] == 0){
		// 
		$db->Select('forums',"`id`='$forum_id'");
		$forum = $db->FetchRow();
		$ftopics = (int)$forum['topics'] - 1;
		if($ftopics <0) $ftopics =0;
		$fposts = (int)$forum['posts'] - (int)$topic['posts'];
	    if($fposts <0) $fposts =0;
		$fset = "`topics`='$ftopics',`posts`='$fposts'";
		if((int)$topic['id'] == (int)$forum['last_id']){
			if($fposts == 0){
			$fset .= ",`last_post`='0',`last_poster_id`='0',`last_poster_name`='',`last_title`='',`last_id`='0'";
			}
			else
			{
		      ForumSetLastPostInfoDelete($forum_id, " and (`id`<'$topic_id' or `id`>'$topic_id')");
			}
			}
		
		$db->Update('forums',$fset,"`id`='$forum_id'");
	 }
	 if($config['forum']['basket'] == false){
//  
		ForumAdminDeleteTopic($topic_id);
	 }
	 else
		{
		  if($topic['delete'] == 0){
		  $text_value = '';
		  if(isset($_POST['text']))
		  $text_value = SafeEnv($_POST['text'],255,str);
		  Moderation_Do_Basket_Topic($topic_id, $text_value)	 ;
		  }
		}
	   	Forum_Cache_ClearAllCacheForum();
		GO('index.php?name=forum&op=showforum&forum='.$forum_id);
	}else{
		$db->Select('forum_topics', "`id`='" . SafeEnv($_GET['topic'], 11, int) . "'");
		$topic = $db->FetchRow();
		$text = '  "' . SafeDB($topic['title'], 255, str) . '"?';
		$site->AddTextBox($lang['forum'], '<center>'.$text.'</center>');
		$site->AddTemplatedBox('', 'module/forum_delete_post.html');
    	$site->AddBlock('delete_form', true, false, 'form');
		$vars = array();
		$vars['basket'] =$config['forum']['basket'] == true ;
	    $vars['url'] ='index.php?name=forum&amp;op=deletetopic&amp;topic=' . SafeEnv($_GET['topic'], 11, int) . '&amp;ok=1';
	    $site->Blocks['delete_form']['vars'] = $vars;
	}
}
?>