<?php

# LinkorCMS
#  2006-2008    (galitsky@pochta.ru)
# LinkorCMS Development Group
# www.linkorcms.ru
#  LinkorCMS 1.2.
#   -   (smilesoft@yandex.ru)

if(!defined('VALID_RUN')){
	Header('Location: http://' . getenv("HTTP_HOST") . '/index.php');
	exit();
}

global $user;
$user->Def('u_add_rating', true);
$user->Def('u_add_comment', true);
$user->Def('u_read_comment', true);
$user->Def('u_add_forum', true);
$user->Def('u_read_forum',true);

include_once(MOD_DIR.'forum_lang.php');
include_once(MOD_DIR.'forum_subscription.php');
include_once(MOD_DIR.'functions.php');
include_once($config['inc_dir'].'bbcode.inc.php');
include_once('scripts/bbcode_editor/index.php');
include_once('scripts/forum_scripts/check_topic.php');
include_once(MOD_DIR.'forum_topic.php');
include_once(MOD_DIR.'forum_posts.php');
include_once(MOD_DIR.'forum_moderation.php');
include_once(MOD_DIR.'forum_rang.php');
include_once(MOD_DIR.'forum_java.php');
include_once(MOD_DIR.'forum_online.php');
include_once(MOD_DIR.'forum_cache.class.php');
include_once(MOD_DIR.'forum_cache.php');
include_once(MOD_DIR.'forum_add.php');
include_once(MOD_DIR.'forum_navigation.php');
include_once(MOD_DIR.'forum_marker.php');
include_once(MOD_DIR.'forum_basket.php');
include_once(MOD_DIR.'forum_statistics.php');
Index_Forum_Add_Java();

$site->Title = $lang['forum'];
$forum_navigation = '';
if(!isset($config['forum']['cache']))
{
	$config['forum']['cache'] = false;
	$config['forum']['maxi_cache_duration'] = 600;
	$config['forum']['update_cache_in_add'] = true;
}
function IndexForumDataFilter( &$forum, $root= true , $get_online = true)
{	global  $lang;
$forum2 = array();
$forum2['id'] = SafeDB($forum['id'], 11, int);
$forum2['parent_id'] = SafeDB($forum['parent_id'], 11, int);
$forum2['title'] = SafeDB($forum['title'], 255, str);
$forum2['description'] = SafeDB($forum['description'], 0, str, false, false);
$forum2['topics'] = SafeDB($forum['topics'], 11, int);
$forum2['posts'] = SafeDB($forum['posts'], 11, int);
$forum2['last_post_date'] = SafeDB($forum['last_post'], 11, int);
$forum2['last_post'] = TimeRender(SafeDB($forum['last_post'], 11, int), true, true);
$forum2['last_poster_id'] = SafeDB($forum['last_poster_id'], 11, int);
$forum2['last_poster_name'] = SafeDB($forum['last_poster_name'], 255, str);
$forum2['last_title'] = SafeDB($forum['last_title'], 255, str);
$forum2['last_id'] = SafeDB($forum['last_id'], 11, int);
$forum2['order'] = SafeDB($forum['order'], 11, int);
$forum2['status'] = SafeDB($forum['status'], 1, int);
$forum2['view'] = SafeDB($forum['view'], 1, int);
if($get_online){
$c = Online_GetCountUser($forum2['id'] ,$root);
$forum2['count_read']  = $c['count'];
$forum2['users'] = $c['users'];
}
else
	{
$forum2['count_read']  = ' ';
$forum2['users'] = ' ';
	}
$forum2['admin_theme_add'] = SafeDB($forum['admin_theme_add'], 1, int);
$forum2['new_message_email'] = SafeDB($forum['new_message_email'], 1, int);
$forum2['no_link_guest'] = SafeDB($forum['no_link_guest'], 1, int);
$forum2['rang_access'] = SafeDB($forum['rang_access'], 11, int);
$forum2['rang_message'] = SafeDB($forum['rang_message'], 11, int);
$forum2['rang_add_theme'] = SafeDB($forum['rang_add_theme'], 11, int);
$forum2['close_topic'] = SafeDB($forum['close_topic'], 1, int);
if($forum2['close_topic']==1){
	$forum2['description'].=''.$lang['close_for_discussion'];
}
return $forum2;
}

function IndexForumCatOpen( &$category )
{
	global $site, $lang;
	$category['is_cat_open'] = true;
	$category['is_cat'] = false;
	$category['is_forum'] = false;
	$category['is_cat_close'] = false;
    if($category['close_topic']==1){
	$category['title'].='&nbsp;'.$lang['close_for_discussion'];
    }
	$site->AddSubBlock('forums', true, $category);
}

function IndexForumCatClose( &$category )
{
	global $site, $lang;
	$category['is_cat_close'] = true;
	$category['is_cat'] = false;
	$category['is_forum'] = false;
	$category['is_cat_open'] = false;
	$category['close'] = $category['close_topic']==0;
	$category['begin'] = !$category['close'];
	$category['status'] = (!$category['close']?$lang['category_locked']:'');
	if(!isset(	 $category['count_read']))
	$category['count_read']  = ' ';
	if(!isset(	 $category['users']))
    $category['users'] = ' ';
	$site->AddSubBlock('forums', true, $category);
}

function IndexForumRender( &$forum, $read = false )
{
	global $site, $lang;
	if($forum['parent_id'] == '0'){
		$forum['is_cat'] = true;
		$forum['is_forum'] = false;
	}else{
		$forum['is_cat'] = false;
		$forum['is_forum'] = true;
	}
	$forum['is_cat_open'] = false;
	$forum['is_cat_close'] = false;
	$forum['on'] = !$read;
	$forum['off'] = $read;
	$forum['close'] =$forum['close_topic']==0;
	$forum['begin'] = !$forum['close'];
	$forum['status'] = (!$forum['close']?$lang['category_locked']:'');
	if(!isset(	 $forum['count_read']))
	$forum['count_read']  = ' ';
	if(!isset(	 $forum['users']))
    $forum['users'] = ' ';
	$site->AddSubBlock('forums', true, $forum);
}

function IndexForumMain()
{
	global $site, $user, $lang,$config,$db;
	$cache_name = 'IndexForumMain_'.$user->AccessLevel();
	$cat = false;
	if(isset($_GET['cat'])){
		$cat = true;
		$pid = SafeEnv($_GET['cat'],11,int);
		$e_where =   " and (`id`='$pid' or `parent_id`='$pid')";
		$cache_name .=   "_$pid";
		Navigation_AppLink($lang['forum'], 'index.php?name=forum');
	}else{
		$e_where = '';
	}
$s_title = (!$cat?$lang['statistics']:$lang['statistics_cat']);
$statistics = Forum_Statistics_Init($s_title);
if($config['forum']['cache'])
{
 if(!$user->Auth)
	{	$cache_name.='quest_'	 ;
	 	Forum_Cache_CacheCreate(&$quest,$cache_name , 0);
		 if($block = $quest->load())
		{	
			$site = $block	;
			//$site->TEcho();
		//	exit;
			 return true;
		}
	}
}

	$result =  Forum_Cache_AllDataTableForum();
	$forums = array();
	foreach($result as $forum){
		if($forum['status'] == 1){
			if($user->AccessIsResolved($forum['view'])){
				if($e_where=='')
				{
					$forums[$forum['parent_id']][] = IndexForumDataFilter($forum);
				}
				else
				{
					if($forum['id'] == $pid or $forum['parent_id'] == $pid)
					$forums[$forum['parent_id']][] = IndexForumDataFilter($forum);
				}
				
			}
		}
	}

	$result = Forum_Cache_AllDataTableForumTopics();
	$topics = array();
	foreach($result as $topic){
		$topics[$topic['forum_id']][] = $topic;
	}

	$read_data = Forum_Marker_GetReadData();
	if(isset($forums['0'])){
		$cat_id =  -1;
		if(isset($_GET['cat'])){
			Navigation_AppLink($forums['0'][0]['title'], 'index.php?name=forum&amp;cat='.$pid);
			Navigation_ShowNavMenu();
			$cat_id =  $_GET['cat'];
		}
		$c_u = Online_GetCountUser($cat_id,true);
		$is_forum_member = $user->AccessIsResolved(2);
		$site->AddBlock('is_forum_member', $is_forum_member, false);

		$site->AddTemplatedBox($lang['forum'].$c_u['count'], 'module/forums.html');
		$site->AddBlock('forums', true, true, 'forum');
		SortArray($forums['0'], 'order');
		foreach($forums['0'] as $category){
			if(isset($forums[$category['id']])){
				IndexForumCatOpen($category);
				IndexForumRender($category);
				SortArray(&$forums[$category['id']], 'order');
				foreach($forums[$category['id']] as $forum){
					if($category['close_topic'] == 1)	 {
					   if($forum['close_topic'] == 0){
						$forum['close_topic'] =1;
				       $forum = IndexForumDataFilter($forum);
					   }
					}
					$statistics['topics_count'] += $forum['topics'];
				    $statistics['reply_count'] += $forum['posts'];
					if($cat){
						if(isset($c_u['users']) and isset($forum['users']['reg']) )
									{
										foreach($forum['users']['reg'] as $muser)
										{
											$c_u['users']['reg'][] = $muser; 
										}
									}
					}
					$read = true;
					if(isset($topics[$forum['id']])){
						foreach($topics[$forum['id']] as $topic){

							if(isset($read_data[SafeDB($topic['id'],11,int)])){
								if($read_data[SafeDB($topic['id'],11,int)]['date'] < SafeDB($topic['last_post'],11,int)){
									$read = false;
								}
							}else{
								$read = false;
							}
							$statistics['hits'] += $topic['hits'];
							$statistics['author_count'][]= $topic['starter_id'];
							$statistics['author_name'][$topic['starter_id']]['name'] = $topic['starter_name'];
							$statistics['author_name'][$topic['starter_id']]['id']= $topic['starter_id'];
							$statistics['author_name'][$topic['starter_id']]['count']= 
								(isset($statistics['author_name'][$topic['starter_id']]['count'])?
									$statistics['author_name'][$topic['starter_id']]['count']+1:1);
						}
					}
					IndexForumRender($forum, $read);
				}
				IndexForumCatClose($category);
			}
		}
	}else{
		$site->AddTextBox($lang['forum'], $lang['no_category'] );
	}
	if(isset($_GET['cat'])){
		$cat = $_GET['cat'];
	}
	else
	{
		$cat = 0;
	}
	if(isset($c_u['users']))
	{
	  Forum_Online_Render_Online($c_u['users'], ($cat_id == -1?$lang['all_online']:$lang['current_category'])) ;
	}
	 Forum_Statistics_Author($statistics);
   	 Forum_Statistics_Render($statistics);
	$quick_transition= Navigation_GetForumCategoryComboBox($cat);
	$site->AddTextBox('', '<span style="float:right;">'.$lang['quick_transition'].':&nbsp;'. $quick_transition.'</span>');
		
if($config['forum']['cache'])
{
  if(!$user->Auth)
	{
	 	Forum_Cache_CacheCreate(&$quest, $cache_name, 0);
		$quest->save($site);
	}
}

}

function IndexForumShowForum()
{
	global $db, $config, $site, $user, $lang;
	$cache_name = 'IndexForumShowForum_AccessLevel'.$user->AccessLevel();
	$statistics = Forum_Statistics_Init($lang['statistics_cat']);

	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 11, int);
	}else{
		$page = 1;
	}
	$cache_name .= '_page'.$page;

	$your_where=" and`delete`='0'";
	if($user->isAdmin() or  $config['forum']['basket'] == false)
	{
		$your_where='';
	}
	else
	{
		$cache_name .= '_u';
	}

	$topics_on_page = $config['forum']['topics_on_page'];
	$online_user = array();

  	if($config['forum']['cache'])
	{
	 if(!$user->Auth)
	{	
		if(isset($_GET['forum'])){
		$forum_id = SafeEnv($_GET['forum'], 11, int);
		$cache_name.='_forum_id'.$forum_id.'_'	;
		}

		 $cache_name.='_quest_'	 ;
	 	Forum_Cache_CacheCreate(&$quest,$cache_name , 0);
		 if($block = $quest->load())
		{
			$site = $block;
		//	$site->TEcho();
		//	exit;
			 return true;
		}
	}
	}

	if(isset($_GET['forum'])){
		$forum_id = SafeEnv($_GET['forum'], 11, int);
		$c_u = Online_GetCountUser($forum_id);
		$online_user = $c_u['users'];	  	
		
		if($_GET['forum']>0){
			$forum = array();
			$forum_parent = array();
			$mforums  =  Forum_Cache_AllDataTableForum();

			if(count($mforums) > 0){
				foreach($mforums as $mforum)
				{
					if($mforum['id'] == $forum_id)
					$forum = $mforum;
					if($mforum['parent_id'] == 0)
					$forum_parent['id'] = $mforum;
				}
				if(count($forum) > 0)
				foreach($mforums as $mforum)
				{
					if($mforum['id'] == $forum['parent_id'])
					$parent = $mforum;
				}
				if(count($forum) == 0){
					IndexForumMain();
					return;
				}
			}
		}
		else
		{
			IndexForumMain();
			return;
		}

		if(count($forum) > 0 ){
			if($forum['parent_id'] == '0')
			{
				if($_GET['forum']>0)
				$_GET['cat'] = $forum['id'];
				IndexForumMain();
				return;
			}
			if($forum['parent_id'] != '0'){
			if($parent['close_topic'] == 1){
			  $forum['close_topic'] = 1;
			}
				$forum = IndexForumDataFilter($forum);

				if($user->AccessIsResolved($parent['view'])){
					#   
					$rang=Rang_UserStatus($forum);
					if($rang['rang_access']){
						$right=$rang['right'];
						$is_theme_add	 =$rang['is_theme_add'];

						Navigation_AppLink($lang['forum'], 'index.php?name=forum');
						$parent = IndexForumDataFilter($parent);
						Navigation_AppLink($parent['title'], 'index.php?name=forum&amp;cat='.$parent['id']);
						Navigation_AppLink($forum['title'], 'index.php?name=forum&amp;op=showforum&amp;forum='.$forum['id']);
						Navigation_ShowNavMenu();
						$site->Title = $site->Title . $lang['site_slas'] .$parent['title'].$lang['site_slas'] . $forum['title'];
						$is_forum_member = $user->AccessIsResolved(2);
						if(!$is_theme_add  ) $is_forum_member=false;
						if(!$user->Get('u_add_forum')  ) $is_forum_member=false;
						$site->AddBlock('is_forum_member', $is_forum_member, false, 'topic');
						$site->SetVar('is_forum_member', 'forum_id', $forum['id']);
						if($user->AccessIsResolved($forum['view']) and $user->AccessIsResolved($parent['view'])){
							//  
							$topics = array();
							$topics_stick = array();
							Forum_Cache_CacheCreate(&$cache, $cache_name.'_forum_id'.$forum_id, $config['forum']['maxi_cache_duration']);
							if(!$topics = $cache->load())
							{
								$alltopics = $db->Select('forum_topics', "`forum_id`='$forum_id'".$your_where);
								if(count($alltopics)>0)
								{
									foreach($alltopics as $topic )
									{
										if($topic['stick'] == 0)
										{
											$topics[] = $topic;
										}
										else
										{
											$topics_stick[] = $topic;
										}
											$statistics['topics_count'] ++;
				                            $statistics['reply_count'] += $topic['posts'];
											$statistics['hits'] += $topic['hits'];
											$statistics['author_count'][]= $topic['starter_id'];
											$statistics['author_name'][$topic['starter_name']]['name'] = $topic['starter_name'];
											$statistics['author_name'][$topic['starter_name']]['id']= $topic['starter_id'];
											$statistics['author_name'][$topic['starter_name']]['count']= 
												(isset($statistics['author_name'][$topic['starter_name']]['count'])?
													$statistics['author_name'][$topic['starter_name']]['count']+1:1);
										}

 	                              Forum_Statistics_Author(&$statistics );
								}
								
								if(is_array($topics)){	  
									SortArray($topics, 'last_post', true);
									$topics = array_merge($topics_stick, $topics);
								}
								elseif(is_array($topics_stick))	 
								{
								  SortArray($topics_stick, 'last_post', true);
									$topics = $topics_stick;
								}
								
								if(count($topics) > $topics_on_page){
									$navigation = new Navigation($page);
									$navigation->GenNavigationMenu($topics, $topics_on_page, 'index.php?name=forum&amp;op=showforum&amp;forum=' . $forum_id);
									$mtopics['navigation'] = $site->Blocks['navigation'];
								}
								else
								{
		                          $site->AddBlock('navigation',false, false);
								}
							  if($user->Auth)
							   	if($config['forum']['cache'])
									{
								       $mtopics['topics']= $topics;
								       $cache->save($mtopics);
								    }
							}
							else
							{
								if(isset($topics['navigation']))
								{
								  $site->Blocks['navigation'] = $topics['navigation'];
								}
								else
								{
								  $site->Blocks['navigation'] = false;
								}
								$topics = $topics['topics'];
							}
							$site->AddBlock('no_topics',count($topics) == 0);
							$basket = Forum_Basket_RenderBasket($topics, 'forum_basket_topics') ;
							$site->AddTemplatedBox('', 'module/forum_topics.html');
							$site->AddBlock('statistik', true, true, 'stat');
							$stat['count_read'] =  $c_u['count'];
							$site->AddSubBlock('statistik', true, $stat) ;
							$site->AddBlock('topics', true, true, 'topic');
							$read_data = Forum_Marker_GetReadData();
							if(is_array($topics))
							if(count($topics) > 0){
								foreach($topics as $topic){
									$topic = Forum_Topic_DataFilter($topic, false);
									if(isset($online_user) and isset($topic['users']['reg']) and isset($online_user['reg']))
									{
										foreach($topic['users']['reg'] as $muser)
										{
											$online_user['reg'][] = $muser; 
										}
									}
								
									if($topic['delete'] > 0 and  $config['forum']['basket'] == true)
									if(isset($basket[$topic['id']]))
									$topic['title'] =  $topic['title'].'<BR>'.Forum_Basket_RenderBasketComAdmin($topic['id'], $topic['title'], $basket,false ) ;
									$topic['page'] = $page ;

									if(isset($read_data[$topic['id']]) && $read_data[$topic['id']]['date'] >= $topic['last_post_date']){
										$topic['on'] = false;
										$topic['off'] = true;
										
									}else{
										$topic['on'] = true;
										$topic['off'] = false;
									}
									if($rang['close_topic']==1){
										$topic['close'] = $rang['close_topic']==0;
										$topic['begin'] = $rang['close_topic']==1;
										$topic['status'] = (!$topic['close']?$lang['topic_close']:'');
									}
										if(!isset($topic['read']))
										$topic['read']  = ' ';
										
									$site->AddSubBlock('topics', true, $topic);
								}
							}
							$site->AddBlock('topic_form', $is_forum_member, false, 'form');

							if( $is_forum_member){
								$site->SetVar('topic_form', 'url', 'index.php?name=forum&amp;op=addtopic&amp;forum=' . $forum_id);

								ForumSmile();
							}
							$site->AddBlock('topic_right', true, true, 'topic');
							$vars=array();
							$vars['right']=$right;
							$site->AddSubBlock('topic_right', true, $vars);
						}else{
							$site->AddTextBox($lang['error'], $lang['error_access_category']);
						}
					}else{
						$site->AddTextBox($lang['error'], $lang['error_access_category']);
					}
				}else{
					$site->AddTextBox($lang['error'], $lang['error_access_category']);
				}
			}else{
				$site->AddTextBox($lang['error'], $lang['error_access_category']);
			}
		}else{
			$site->AddTextBox($lang['error'], $lang['error_no_forum'] );
		}
	}else{
		$site->AddTextBox($lang['error'], $lang['error_no_forum'] );
	}
	if(isset($_GET['forum'])){
		$cat = $_GET['forum'];
	}
	else
	{
		$cat = 0;
	}
		if(isset($online_user ))
	{
	 if(isset($online_user ['reg']))
	  Forum_Online_Render_Online($online_user , $lang['current_category']) ;

	}
	   	 Forum_Statistics_Render($statistics);

	$site->AddTextBox('', '<span style="float:right;">'.$lang['quick_transition'].':&nbsp;'. Navigation_GetForumCategoryComboBox($cat).'</span>');
if($config['forum']['cache'])
{
  if(!$user->Auth)
	{	
		if($config['forum']['cache']){
		$mcache = array();
	 	Forum_Cache_CacheCreate(&$quest, $cache_name, 0);
		$quest->save($site);	
		}
		}
	}
}


if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}
switch($op){
	case 'main':
		IndexForumMain();
		break;
	case 'showforum':
		IndexForumShowForum();
		break;
	case 'addtopic':
		Forum_Add_AddTopic();
		break;
	case 'showtopic':
		Forum_Topic_ShowTopic();
		break;
	case 'addpost':
		Forum_Add_AddPost();
		break;
	case 'login':
		if(!$user->Auth){
			$site->Login('');
			$user->Def('forum_referrer', $_SERVER['HTTP_REFERER']);
		}else{
			GO($user->Get('forum_referrer'));
		}
		break;
	case 'markread':
		Forum_Marker_CheckAll();
		break;
	case 'deletetopic':
		if($user->isAdmin()){
			Forum_Topic_DeleteTopic();
		}else{
			HackOff();
		}
		break;
	case 'closetopic':
		if($user->isAdmin()){
			Moderation_CloseTopic();
		}else{
			HackOff();
		}
		break;
	case 'begintopic':
		if($user->isAdmin()){
			Moderation_BeginTopic();
		}else{
			HackOff();
		}
		break;
	case 'deletepost':
		if($user->isAdmin()){
			Posts_DeletePost();
		}else{
			HackOff();
		}
		break;
	case 'editpost':
		Posts_EditPost();
		break;
	case 'savepost':
		Forum_Add_EditPostSave();
		break;
	case 'edittopic':
		Posts_EditPostTitle();
		break;
	case 'edit_topics':
		Moderation_Edit_Topics();
		break;
	case 'edit_posts':
		Moderation_Edit_Posts();
		break;
	case 'marker':
		if(isset($_GET['marker']))
	//	Forum_Marker_SetReadData($_GET['marker']);
		exit;
		break;
	case 'markerhits':
		if(isset($_GET['topic_id']))
	//	Forum_Marker_SetHitsData($_GET['topic_id']);
		exit;
		break;
	case 'subscription':
		Forum_Subscription();
		break;
	case 'restore_basket':
		if($user->isAdmin()){
			if(isset($_GET['forum_basket_post']))
			{
				Forum_Basket_RestoreBasketPost(SafeEnv($_GET['forum_basket_post'],11,int));
			}
			elseif(isset($_GET['forum_basket_topics']))
			{
				Forum_Basket_RestoreBasketTopic(SafeEnv($_GET['forum_basket_topics'],11,int));
			}
		}
		break;
	default:
		HackOff();
}

?>