<?php

/*
#############################################
# LinkorCMS
# ==================================
#    2006-2008 
#    (galitsky@pochta.ru)
# =====================================================
# :	       
#   -   (smilesoft@yandex.ru)
#############################################
*/

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit;
}

define("TREE_CHILD_ID_FORUM",'child');
$FCatsData = array();

class TreeForum{

	var $Table;	//    .
	var $tree;	//   .

	public $Cats;	//    
					//     .
	public $IdCats;	//    
					//      .

	var $data = array(),
		$childs = array(),
		$sel_id = 0;

	public $IdKey = 'id';
	public $ParentKey = 'parent_id';
	public $TitleKey = 'title';
	public $TitleKey2 = 'title2';
	public $FileCounterKey = 'file_counter';
	public $CatCounterKey = 'cat_counter';
	public $ex_where = '';


	//  
	function TreeForum($Table, $IdKey = 'id', $ParentKey = 'parent', $TitleKey= 'title',
		$FileCounterKey = 'file_counter', $CatCounterKey = 'cat_counter', $ex_where='')
	{
		global $db, $config;
		$this->IdKey = $IdKey;
		$this->ParentKey = $ParentKey;
		$this->TitleKey = $TitleKey;
		$this->FileCounterKey = $FileCounterKey;
		$this->CatCounterKey = $CatCounterKey;
		$this->ex_where = $ex_where;
		$cats = array();
		$cats2 = array();

		if(!is_array($Table)){
			$this->Table = $Table;
			$Table = $db->Select($Table,($this->ex_where<>''?$this->ex_where:''));
		}
		
		foreach($Table as $cat){
			$cats[$cat[$ParentKey]][] = $cat;
			$cats2[$cat[$IdKey]] = $cat;
		}

		$this->Cats = $cats;
		$this->IdCats = $cats2;
	}

	//  
	function NewTree(&$tree, $pid, $source, $fid)
	{
		//  
		if(isset($source[$pid])){

			//   
			for($i=0, $c=count($source[$pid]); $i<$c; $i++){
				$ncat = $source[$pid][$i];
				$this->NewTree($ncat, $ncat['id'], $source, $fid);
				if($pid == $fid){
					$tree[] = $ncat;
				}else{
					$tree[TREE_CHILD_ID_FORUM][] = $ncat;
				}
			}

			return $tree;
		}else{
			return array();
		}
	}


	function ToCatsTree($tree, $level, $callbackFunc)
	{
		if(isset($tree[TREE_CHILD_ID_FORUM])){
			for($i=0, $c=count($tree[TREE_CHILD_ID_FORUM]); $i<$c; $i++){
				call_user_func_array($callbackFunc,array($tree[TREE_CHILD_ID_FORUM][$i],$level));
				$this->ToCatsTree($tree[TREE_CHILD_ID_FORUM][$i],$level+1,$callbackFunc);
			}
		}
	}

	function GetIds($tree, &$result)
	{
		if(isset($tree[TREE_CHILD_ID_FORUM])){
			for($i=0, $c=count($tree[TREE_CHILD_ID_FORUM]); $i<$c; $i++){
				$result[] = $tree[TREE_CHILD_ID_FORUM][$i][$this->IdKey];
				$this->GetIds($tree[TREE_CHILD_ID_FORUM][$i],$result);
			}
		}
	}

	function GetChildTree($pid)
	{
		$tree = array();
		$this->NewTree($tree, $pid, $this->Cats, $pid);
		$this->tree = $tree;
		return $tree;
	}

	//     
	/*  
		function UserFunc($cat,$level){
		$cat -   
		$level -  
	*/
	function ListingTree($pid, $callbackFunc)
	{
		$this->GetChildTree($pid);
		if((!is_array($callbackFunc) && !@function_exists($callbackFunc)) || (is_array($callbackFunc) && !@method_exists($callbackFunc[0],$callbackFunc[1]))){
			error_handler(NOTICE,'CallBack   . : CallBack function is not predestined.','Tree->ListingTree()');
			return false;
		}else{
			if(count($this->tree) == 0){
				return false;
			}
			for($i=0, $c=count($this->tree); $i<$c; $i++){
				call_user_func_array($callbackFunc, array($this->tree[$i], 0));
				$this->ToCatsTree($this->tree[$i], 1, $callbackFunc);
			}
			return true;
		}
	}

	//      
	//       $pid.
	function GetAllChildId($pid)
	{
		$this->GetChildTree($pid);
		$result = array();
		$c = count($this->tree);
		if($c > 0){
			for($i=0; $i<$c; $i++){
				$result[] = $this->tree[$i][$this->IdKey];
				$this->GetIds($this->tree[$i],$result);
			}
		}
		$result[] = $pid;
		return $result;
	}

	 function GetAllChildIdNameEngl($pid)
	{
		$this->GetChildTree($pid);
		$name = '';
		$result = array();
		$c = count($this->tree);
		if($c > 0){
			for($i=0; $i<$c; $i++){
				$result[] = $this->tree[$i][$this->IdKey];
				$name = $name.$this->tree[$i][$this->TitleKey2 ].'/';
				$this->GetIds($this->tree[$i],$result);
			}
		}
		$result[] = $pid;
		return $name;
	}

	//    
	function GetParentId($curId)
	{
		global $db, $config;
		if(isset($this->IdCats[$curId])){
			return $this->IdCats[$curId][$this->ParentKey];
		}else{
			return 0;
		}
	}


  	//    
	function GetParentname($curId)
	{
		global $db, $config;
		if(isset($this->IdCats[$curId])){
			return $this->IdCats[$curId][$this->TitleKey];
		}else{
   
		$db->Select($this->Table,"`".$this->IdKey."`='$this->ParentKey'");
		 if($db->NumRows() > 0){
			$cat = $db->FetchRow();
			 $name=$cat[$this->TitleKey];
			return  $name; }
		}
	}

 	//    
	function GetParentNameEngl($curId)
	{
		global $db, $config;
		if(isset($this->IdCats[$curId])){
			return $this->IdCats[$curId][$this->TitleKey2];
		}else{
   
		$db->Select($this->Table,"`".$this->IdKey."`='$this->ParentKey'");
		 if($db->NumRows() > 0){
			$cat = $db->FetchRow();
			  $name=$cat[$this->TitleKey2];
			return  $name; }
		}
	}


	//   
	function GetAllParent($curId, $reverse=true)
	{
		global $db, $config;
		if(count($this->IdCats)>0){
			$find = true;
			$result = array();
			while($find){
				if(isset($this->IdCats[$curId])){
					$result[] = $this->IdCats[$curId];
					$curId = $this->IdCats[$curId][$this->ParentKey];
					$find = true;
				}else{
					$find = false;
				}
			}
			$result2 = array();
			if($reverse){
				$c=count($result)-1;
				for($i=$c; $i >= 0; $i--){
					$result2[] = $result[$i];
					unset($result[$i]);
				}
				$result = $result2;
			}
			return $result;
		}else{
			return false;
		}
	}

	//      
	//      
	function CalcFileCounter($id, $inc)
	{
		global $db,$config;
		$db->Select($this->Table,"`".$this->IdKey."`='$id'");
		if($db->NumRows()>0){
			$cat = $db->FetchRow();
			if($inc==true){
				$counter_val = $cat[$this->FileCounterKey] + 1;
			}else{
				$counter_val = $cat[$this->FileCounterKey] - 1;
			}
			$db->Update($this->Table,$this->FileCounterKey."='$counter_val'","`".$this->IdKey."`='$id'");
		}
	}

	//      
	//      
	function CalcCatCounter($id, $inc)
	{
		global $db, $config;
		$db->Select($this->Table,"`".$this->IdKey."`='$id'");
		if($db->NumRows() > 0){
			$cat = $db->FetchRow();
			if($inc==true){
				$counter_val = $cat[$this->CatCounterKey] + 1;
			}else{
				$counter_val = $cat[$this->CatCounterKey] - 1;
			}
			$db->Update($this->Table, $this->CatCounterKey."='$counter_val'", "`".$this->IdKey."`='$id'");
		}
	}

  function CatsDataFileCount($tree, $level)
	{	   
		global $site, $FCatsData;
		if($tree[$this->FileCounterKey]>0)
			{
		   return ' ('.$tree[$this->FileCounterKey].')'	;
		     }
			 elseif(isset($this->Cats[$tree['id']])	)
		{
		    $count = 0;
		 //  foreach($this->Cats[$tree['id']] as $c)
		//	   $count =  $count+ $c[$this->FileCounterKey];
		 return   ' ('.count($this->Cats[$tree['id']] ).')' ;
		}
		else
		{
		  return  ' (0)';
		}

	}
	function CatsData($tree, $level)
	{	   //$this->Cats
		global $site, $FCatsData;
		if(in_array($tree[$this->IdKey], $this->childs) === false){
			$levs = str_repeat('&nbsp;-&nbsp;', $level);
			$site->DataAdd($FCatsData, $tree[$this->IdKey], $levs.$tree[$this->TitleKey].($this->viewitems && isset($tree[$this->FileCounterKey])?$this->CatsDataFileCount($tree, $level):''), ($tree[$this->IdKey] == $this->sel_id));
		}
	}

	#        
	function GetCatsData($sel_id, $viewitems = false, $root = false, $id = 0, $xor = false)
	{
		global $site, $FCatsData ,$lang;
		
		$this->childs = array();
		$this->sel_id = $sel_id;
		$this->viewitems = $viewitems;
		if($xor){
			$this->childs = $this->GetAllChildId($id);
		}
		if($root){
			$site->DataAdd($FCatsData, '0',$lang['first_page_forum'], $sel_id==0);
		}

		$this->ListingTree(0, array($this, 'CatsData'));
		return $FCatsData;
	}

}

?>