<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$site->Title = '';

include_once (MOD_DIR.'functions.php');

// ,     e-mail 
function MailIsSetEmail( $email )
{
	global $db;
	$db->Select('users', "`email`='$email'");
	return $db->NumRows() > 0;
}

function IndexMailIsSelected()
{
	global $user;
	return $user->isDef('mail_selected');
}

function IndexMailEnterMail( $message = '' )
{
	global $site;
	$site->AddTemplatedBox('', 'module/mail.html');
	$site->AddBlock('mail');
	$vars['message'] = $message;
	$vars['form_action'] = 'index.php?name=mail&amp;op=topics';
	$vars['lemail'] = ' e-mail';
	$vars['lsubmit'] = '';
	$site->Blocks['mail']['vars'] = $vars;
}

if(isset($_POST['mail_block_form'])){
	$user->UnDef('mail_selected');
}

if(!IndexMailIsSelected()){
	if(isset($_POST['mail_form']) || isset($_POST['mail_block_form'])){
		$mail_selected = SafeEnv($_POST['email'], 50, str);
		if(!CheckEmail($mail_selected)){
			IndexMailEnterMail('E-mail    .');
			return;
		}elseif(MailIsSetEmail($mail_selected)){
			$site->Login(' <b>'.$mail_selected.'</b>  ,  .');
			return;
		}else{
			$user->Def('mail_selected', $mail_selected);
		}
	}elseif($user->Auth && $user->Get('u_email') != ''){
		$mail_selected = $user->Get('u_email');
		$user->Def('mail_selected', $mail_selected);
	}else{
		IndexMailEnterMail();
		$site->Login();
		return;
	}
}else{
	$mail_selected = $user->Get('mail_selected');
}

function IndexMailTopics()
{
	global $site, $db, $mail_selected;
	$db->Select('mail_topics', "`status`='1'");
	$site->AddTemplatedBox('', 'module/mail_topics.html');
	$site->AddBlock('mail');
	$vars['form_action'] = 'index.php?name=mail&amp;op=topics_save';
	$vars['lfor'] = ' ';
	$vars['lnew'] = ' ';
	$vars['lhtml'] = 'HTML';
	$vars['ltext'] = '';
	$vars['email'] = $mail_selected;
	$vars['lcount'] = '';
	$vars['lhistory'] = '';
	$vars['lsubmit'] = '';
	$site->Blocks['mail']['vars'] = $vars;
	$db->Select('mail_list', "`email`='$mail_selected'");
	$ads = array();
	while($ad = $db->FetchRow()){
		$ads[$ad[1]] = $ad;
	}
	$site->AddBlock('mail_topics', true, true, 'topic');
	$db->Select('mail_topics', '');
	while($topic = $db->FetchRow()){
		$topic_vars = array();
		$topic_vars['id'] = SafeDB($topic[0], 11, int);
		$topic_vars['title'] = SafeDB($topic[1], 255, str);
		$topic_vars['description'] = SafeDB($topic[2], 0, str);
		$topic_vars['count'] = SafeDB($topic[5], 11, int);
		$topic_vars['history_url'] = 'index.php?name=mail&amp;op=history&amp;topic_id='.SafeDB($topic[0], 11, int);
		$topic_vars['checked'] = isset($ads[$topic[0]]);
		if($topic_vars['checked']){
			$topic_vars['text_checked'] = $ads[$topic[0]][3] == '0';
		}else{
			$topic_vars['text_checked'] = false;
		}
		$site->AddSubBlock('mail_topics', true, $topic_vars);
	}
}

function IndexMailTopicsSave()
{
	global $site, $db, $mail_selected, $user;
	if(!isset($_POST['mail_topics_form'])){
		GO('index.php?name=mail&op=topics&error=1');
	}
	if(isset($_POST['topic'])){
		$topics = SafeEnv($_POST['topic'], 11, int);
		$html = SafeEnv($_POST['html'], 1, int);
		$mls = $db->Select('mail_list', "`email`='$mail_selected'");
		$mail_list = array();
		foreach($mls as $mail){
			if(!isset($topics[$mail['topic_id']])){
				$db->Delete('mail_list', "`email`='{$mail['email']}'");
				CalcListCounter($mail['topic_id'], false);
				continue;
			}
			$mail_list[$mail['topic_id']] = $mail;
		}
		if($user->Auth){
			$user_id = $user->Get('u_id');
		}else{
			$user_id = 0;
		}
		$c = count($topics);
		for($i = 0; $i < $c; $i++){
			if(!isset($mail_list[$topics[$i]])){
				$vals = Values($user_id, $topics[$i], $mail_selected, $html[$i]);
				$db->Insert('mail_list', $vals);
				CalcListCounter($topics[$i], true);
			}
		}
	}
	$site->AddTextBox('', '<center><br />   .<br /><br /><a href="index.php?name=mail&amp;op=topics"></a><br /><br /></center>');
}

function IndexMailNewEmail()
{
	global $user, $site;
	$user->UnDef('mail_selected');
	IndexMailEnterMail();
	$site->Login();
}

function IndexMailHistory()
{
	global $site, $db, $config;
	if(isset($_GET['topic_id'])){
		$topic_id = SafeEnv($_GET['topic_id'], 11, int);
	}else{
		GO('index.php?name=mail&op=topics');
	}
	$db->Select('mail_topics', "`id`='$topic_id'");

	if($db->NumRows() > 0){
		$topic = $db->FetchRow();
	}else{
		GO('index.php?name=mail&op=topics');
	}
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 10, int);
	}else{
		$page = 1;
	}
	$mails = $db->Select('mail_history', "`topic_id`='$topic_id'");
	if($db->NumRows() == 0){
		$site->AddTextBox('', '<center><br />   "'.SafeDB($topic[1], 250, str).'"  .<br /><br /><a href="javascript:history.go(-1)"></a><br /><br /></center>');
		return;
	}
	SortArray($mails, 3, false);

	$num = 20; // FIXME: $config['mail']['mail_on_page'];
	$navigation = new Navigation($page);
	$navigation->GenNavigationMenu($mails, $num, 'index.php?name=mail&amp;op=history&amp;topic_id='.$topic_id);

	$site->AddTemplatedBox('', 'module/mail_showid_nav.html');
	$site->AddBlock('mail_nav');
	$vars['lprev'] = ' ';
	$vars['prev_id'] = true;
	$vars['next_id'] = false;
	$vars['back'] = false;
	$vars['prev_url'] = 'index.php?name=mail&amp;op=topics';
	$site->Blocks['mail_nav']['vars'] = $vars;
	$site->AddTemplatedBox(' ', 'module/mail_mail.html');
	$site->AddBlock('mail_history');
	$vars['topic'] = SafeDB($topic[1], 255, str);
	$vars['ldate'] = ' ';
	$vars['lsubject'] = ' ';
	$site->Blocks['mail_history']['vars'] = $vars;
	$site->AddBlock('mail', true, true);
	foreach($mails as $mail){
		$vars = array();
		$vars['subject'] = SafeDB($mail[2], 250, str);
		$vars['date'] = TimeRender(SafeDB($mail[3], 11, int));
		$vars['url'] = 'index.php?name=mail&amp;op=showid&amp;topic_id='.$topic_id.'&amp;id='.(SafeDB($mail[0], 11, int));
		$site->AddSubBlock('mail', true, $vars);
	}
}

function IndexMailShowId()
{
	global $site, $db;
	if(isset($_GET['topic_id'])){
		$topic_id = SafeEnv($_GET['topic_id'], 11, int);
	}else{
		GO('index.php?name=mail&op=topics');
	}
	if(isset($_GET['id'])){
		$id = SafeEnv($_GET['id'], 11, int);
	}else{
		GO('index.php?name=mail&op=topics');
	}
	$mails = $db->Select('mail_history', "`topic_id`='$topic_id'");
	SortArray($mails, 3, false);
	$prev_id = false;
	$next_id = false;
	$find = false;
	for($i = 0, $c = count($mails); $i < $c; $i++){
		if($mails[$i][0] == $id){
			if($i < $c - 1){
				$next_id = $mails[$i + 1][0];
			}
			if($i > 0){
				$prev_id = $mails[$i - 1][0];
			}
			$mail = $mails[$i];
			$find = true;
			break;
		}
	}
	if(!$find){
		GO('index.php?name=mail&op=topics');
	}
	$site->AddTemplatedBox('', 'module/mail_showid_nav.html');
	$site->AddBlock('mail_nav');
	$vars['lprev'] = ' ';
	$vars['lnext'] = ' ';
	$vars['lback'] = '  ';
	$vars['prev_id'] = $prev_id;
	$vars['next_id'] = $next_id;
	$vars['back'] = true;
	$vars['prev_url'] = 'index.php?name=mail&amp;op=showid&amp;topic_id='.$topic_id.'&amp;id='.$prev_id;
	$vars['back_url'] = 'index.php?name=mail&amp;op=history&amp;topic_id='.$topic_id;
	$vars['next_url'] = 'index.php?name=mail&amp;op=showid&amp;topic_id='.$topic_id.'&amp;id='.$next_id;
	$site->Blocks['mail_nav']['vars'] = $vars;
	$site->AddTemplatedBox('  ', 'module/mail_showid.html');
	$site->AddBlock('mail');
	$vars['subject'] = SafeDB($mail[2], 255, str);
	$vars['date'] = TimeRender(SafeDB($mail[3], 11, int));
	$vars['ldate'] = ' ';
	$vars['text'] = nl2br(SafeDB($mail[6], 0, str));
	// HTML //($mail[8]?nl2br(SafeDB($mail[7],0,str)):SafeDB($mail[7],0,str));
	$site->Blocks['mail']['vars'] = $vars;
	$site->AddTemplatedBox('', 'module/mail_down_tab.html');
	$site->AddBlock('mail_down_tab');
	$vars['lsubscribe'] = '   .';
	$vars['subscribe_url'] = 'index.php?name=mail&amp;op=subscribe&amp;topic_id='.$topic_id;
	$site->Blocks['mail_down_tab']['vars'] = $vars;
}

function IndexMailSubscribe()
{
	global $site, $db, $mail_selected, $user;
	if(isset($_POST['topic_id'])){
		$topic_id = SafeEnv($_POST['topic_id'], 11, int);
		if(!isset($_POST['mail_block_form'])){
			GO('index.php?name=mail&op=topics&error=1');
		}
		$html = SafeEnv($_POST['html'], 1, int);
	}elseif(isset($_GET['topic_id'])){
		$topic_id = SafeEnv($_GET['topic_id'], 11, int);
		$html = 1;
	}else{
		GO('index.php?name=mail&op=topics&error=2');
	}
	$db->Delete('mail_list', "`email`='$mail_selected' and `topic_id`='$topic_id'");
	if($user->Auth){
		$user_id = $user->Get('u_id');
	}else{
		$user_id = 0;
	}

	$db->Select('mail_topics', "`id`='$topic_id'");
	$topic = $db->FetchRow();
	$count = SafeDB($topic['count'], 11, int) + 1;
	$db->Update('mail_topics', "count='$count'", "`id`='$topic_id'");

	$vals = Values($user_id, $topic_id, $mail_selected, $html);
	$db->Insert('mail_list', $vals);
	$site->AddTextBox('', '<center><br />,      .<br />      <a href="index.php?name=mail&amp;op=topics"></a>.<br /><br /><a href="javascript:history.go(-1)"> </a>.<br /><br /></center>');
}

if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'topics';
}

switch($op){
	case 'topics':
		IndexMailTopics();
		break;
	case 'topics_save':
		IndexMailTopicsSave();
		break;
	case 'change':
		IndexMailChangeEmail();
		break;
	case 'new':
		IndexMailNewEmail();
		break;
	case 'subscribe':
		IndexMailSubscribe();
		break;
	case 'history':
		IndexMailHistory();
		break;
	case 'showid':
		IndexMailShowId();
		break;
	default:
		HackOff();
}

?>