<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

if(!$user->CheckAccess2('smilies', 'smilies')){
	AddTextBox('', $config['general']['admin_accd']);
	return;
}

$smiles_dir = 'uploads/smilies/';
$mod = $config['admin_file'].'?exe=smilies';

function AdminSmilesGetAllSmiles( &$sid, $dir_name, $selected = '', $smilies = array() )
{
	global $site, $smiles_dir;
	static $i = -1;
	static $sfiles = array();
	static $xor_smilies = array();
	static $xsm = false;
	if(!$xsm){
		foreach($smilies as $sm){
			$xor_smilies[$sm['file']] = true;
		}
	}
	$dir = @opendir($dir_name);
	while($file = @readdir($dir)){
		if(is_dir($dir_name.$file) && ($file != '.') && ($file != '..')){
			AdminSmilesGetAllSmiles($sid, $dir_name.$file.'/', $selected, $smilies);
		}else{
			$ext = GetFileExt($file);
			if($ext == '.gif' || $ext == '.png'){
				$rf = str_replace($smiles_dir, '', $dir_name).$file;
				if(!isset($xor_smilies[$rf]) || $selected == $rf){
					$site->DataAdd($sfiles, $rf, $rf, $selected == $rf);
					$i++;
				}
				if($selected != $rf){
					$sel = false;
				}else{
					$sel = true;
					$sid = $i;
				}
			}
		}
	}
	return $sfiles;
}

function AdminSmilesMain()
{
	global $db, $config, $site, $smiles_dir, $mod;
	$smilies = $db->Select('smilies', '');
	$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
	$text .= '<tr><th></th><th></th><th></th><th> </th><th>  </th><th></th></tr>';
	while($row = $db->FetchRow()){
		switch($row['enabled']){
			case "1":
				$en = '<a href="'.$mod.'&a=changestatus&id='.SafeDB($row['id'], 11, int).'" title=" "><font color="#008000"></font></a>';
				break;
			case "0":
				$en = '<a href="'.$mod.'&a=changestatus&id='.SafeDB($row['id'], 11, int).'" title=" "><font color="#FF0000"></font></a>';
				break;
		}
		$func = "<a href=\"$mod&a=editsmile&id={$row[0]}\"><img src=\"images/admin/edit.gif\" title=\"\" /></a><a href=\"$mod&a=delsmile&sid={$row[0]}\"><img src=\"images/admin/delete.gif\" title=\"\" /></a>";
		$text .= "<tr><td><a href=\"$mod&a=editsmile&id={$row[0]}\"><img src=\"$smiles_dir{$row['file']}\" /></a></td><td>{$row['code']}</td><td>{$row['desc']}</td><td>{$row['file']}</td><td>$en</td><td>$func</td></tr>";
	}
	$text .= '</table><br />.: :.';
	$sfiles = AdminSmilesGetAllSmiles($id, $smiles_dir, '', $smilies);
	if(isset($sfiles[0])){
		$fname = $sfiles[0]['name'];
	}else{
		$fname = '';
	}
	AddCenterBox('');
	AddText($text);
	// ----------------------------------
	if(count($sfiles) > 0){
		FormRow('', $site->Select('file', $sfiles, false, "onchange=\"document.newsmile.image.src='$smiles_dir'+document.newsmile.file.value\""));
		FormRow('', "<img id=\"image\" src=\"$smiles_dir$fname\" />");
		FormRow('', $site->Edit('code'));
		FormRow('', $site->Edit('desc'));
		FormRow('', $site->Radio('indexview', 'on', true).'&nbsp;'.$site->Radio('indexview', 'off').'');
		AddForm("<form name=\"newsmile\" action=\"$mod&a=addsmile\" method=\"post\">", $site->Submit(''));
	}else{
		AddText('<br />   .');
	}
}

function AdminSmilesEditSmile()
{
	global $db, $config, $site, $smiles_dir, $mod;
	$id = SafeEnv($_GET['id'], 11, int);
	$smilies = $db->Select('smilies', '');
	$db->Select('smilies', "`id`='$id'");
	$smd = $db->FetchRow();
	$sfiles = AdminSmilesGetAllSmiles($sid, $smiles_dir, $smd['file'], $smilies);
	$en = array(false, false);
	$en[$smd['enabled']] = true;
	FormRow('', $site->Select('file', $sfiles, false, "style=\"width:130px;\" onchange=\"document.newsmile.image.src='$smiles_dir'+document.newsmile.file.value\""));
	FormRow('', '<img id="image" src="'.$smiles_dir.$sfiles[$sid]['name'].'" />');
	FormRow('', $site->Edit('code', $smd['code']));
	FormRow('', $site->Edit('desc', $smd['desc']));
	FormRow('', $site->Radio('indexview', 'on', $en[1]).'&nbsp;'.$site->Radio('indexview', 'off', $en[0]).'');
	AddCenterBox(' ');
	AddForm('<form name="newsmile" action="'.$mod.'&a=seditsave&id='.$id.'" method="post">', $site->Button('', 'onclick="history.go(-1)"').$site->Submit(''));
}

function AdminSmilesEditSave()
{
	global $db, $config, $mod;
	$id = SafeEnv($_GET['id'], 11, int);
	$disp = EnToInt(SafeEnv($_POST['indexview'], 3, str));
	$vals = Values('', SafeEnv($_POST['code'], 30, str), SafeEnv($_POST['desc'], 255, str), SafeEnv($_POST['file'], 255, str), $disp);
	$db->Update('smilies', $vals, "`id`='$id'", true);
	GO($mod);
}

function AdminSmilesAddSave()
{
	global $db, $config, $mod;
	$disp = EnToInt(SafeEnv($_POST['indexview'], 3, str));
	$vals = Values('', SafeEnv($_POST['code'], 30, str), SafeEnv($_POST['desc'], 255, str), SafeEnv($_POST['file'], 255, str), $disp);
	$db->Insert('smilies', $vals);
	GO($mod);
}

function AdminSmilesDeleteSmile()
{
	global $config, $db, $smilies_dir, $mod;
	if(isset($_GET['ok']) && $_GET['ok'] == '1'){
		$db->Delete('smilies', "`id`='".SafeEnv($_GET['sid'], 11, int)."'");
		GO($mod);
	}else{
		$r = $db->Select('smilies', "`id`='".SafeEnv($_GET['sid'], 11, int)."'");
		$text = '     <img src="'.$smilies_dir.$r[0]['file'].'" /> ?<br />'."<a href=\"$mod&a=delsmile&sid=".SafeEnv($_GET['sid'], 11, int).'&ok=1"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a>';
		AddTextBox("", $text);
	}
}

function AdminBlocksChangeStatus()
{
	global $config, $db, $mod;
	$db->Select('smilies', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	if($db->NumRows() > 0){
		$r = $db->FetchRow();
		if(SafeDB($r['enabled'], 1, int) == 1){
			$en = '0';
		}else{
			$en = '1';
		}
		$db->Update('smilies', "enabled='$en'", "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	}
	GO($mod);
}

if(isset($_GET['a'])){
	$action = $_GET['a'];
}else{
	$action = 'main';
}

function AdminSmiles()
{
	global $action;
	TAddSubTitle('');
	switch($action){
		case 'main':
			AdminSmilesMain();
			break;
		case 'addsmile':
			AdminSmilesAddSave();
			break;
		case 'delsmile':
			AdminSmilesDeleteSmile();
			break;
		case 'editsmile':
			AdminSmilesEditSmile();
			break;
		case 'seditsave':
			AdminSmilesEditSave();
			break;
		case 'changestatus':
			AdminBlocksChangeStatus();
			break;
		default:
			AdminSmilesMain();
	}
}

AdminSmiles();

?>