<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

if(!$user->CheckAccess2('user', 'user')){
	AddTextBox('', $config['general']['admin_accd']);
	return;
}

$editing = $user->CheckAccess2('user', 'editing');
$rankedit = $user->CheckAccess2('user', 'ranks');
$galeryedit = $user->CheckAccess2('user', 'avatars_gallery');
$confedit = $user->CheckAccess2('user', 'config');

function getUsers( $where = '`type`=\'2\'' )
{
	global $config, $db;
	return $db->Select('users', $where);
}

function QueryStristrFilter( $str, $inez )
{
	global $db;
	if($str == ''){
		return;
	}
	$newResult = array();
	foreach($db->QueryResult as $user){
		if(stristr($user[$inez], $str) !== false){
			$newResult[] = $user;
		}
	}
	$db->QueryResult = $newResult;
}

function AdminUserMain()
{
	global $db, $config, $site, $user, $editing;
	$db->FreeResult();
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 10, int);
	}else{
		$page = 1;
	}
	if(isset($_GET['show'])){
		$show = $_GET['show'];
	}else{
		$show = '';
	}
	$showd = array();
	$site->DataAdd($showd, 'all', ' ', $show == '');
	$site->DataAdd($showd, 'online', ' OnLine', $show == 'online');

	// online
	$sonline = false;
	$onlwhere = '';
	$where = '`type`=\'2\'';
	if(isset($_GET['show'])){
		if($_GET['show'] == 'online'){
			$donline = $user->Online();
			$donline = $donline['members'];
			$onlwhere = '';
			foreach($donline as $memb){
				$onlwhere .= "or `id`='".$memb[2]."'";
			}
			$onlwhere = substr($onlwhere, 3);
			$sonline = true;
			if(count($donline) > 0){
				$where = '`type`=\'2\' and ('.$onlwhere.')';
			}else{
				$where = '`type`=\'2\' and `id`=\'-1\'';
			}
			getUsers($where);
		}
	}

	//
	$searchm = false;
	$criterion = '';
	$sstr = '';
	if(!$sonline && isset($_GET['criterion']) && isset($_GET['stext'])){
		$searchm = true;
		$criterion = $_GET['criterion'];
		$sstr = $_GET['stext'];
		// where
		switch($criterion){
			case 'nikname':
				$sstr = SafeEnv($sstr, 50, str);
				getUsers();
				QueryStristrFilter($sstr, 3);
				break;
			case 'email':
				$sstr = SafeEnv($sstr, 50, str);
				getUsers();
				QueryStristrFilter($sstr, 6);
				break;
			case 'rname':
				$sstr = SafeEnv($sstr, 250, str);
				getUsers();
				QueryStristrFilter($sstr, 4);
				break;
			case 'age':
				$sstr = SafeEnv($sstr, 1, int);
				getUsers('`type`=\'2\' and `age`=\''.$sstr.'\'');
				break;
			case 'city':
				$sstr = SafeEnv($sstr, 100, str);
				getUsers();
				QueryStristrFilter($sstr, 8);
				break;
			case 'site':
				$sstr = SafeEnv($sstr, 250, str);
				getUsers();
				QueryStristrFilter($sstr, 10);
				break;
			case 'icq':
				$sstr = SafeEnv($sstr, 15, str);
				getUsers();
				QueryStristrFilter($sstr, 9);
				break;
			case 'gmt':
				$sstr = SafeEnv($sstr, 3, str);
				getUsers('`type`=\'2\' and `timezone`=\''.$sstr.'\'');
				break;
			case 'active':
				$sstr = SafeEnv($sstr, 1, int);
				getUsers('`type`=\'2\' and `active`=\''.$sstr.'\'');
				break;
			case 'points':
				$sstr = SafeEnv($sstr, 11, int);
				getUsers("`type`='2' and (`points`='$sstr' or `points`>'$sstr')");
				break;
			case 'ip':
				$sstr = SafeEnv($sstr, 15, str);
				getUsers();
				QueryStristrFilter($sstr, 9);
				break;
		}
	}
	$sstr = strval($sstr);
	$searchd = array();
	$site->DataAdd($searchd, 'nikname', '', $criterion == 'nikname');
	$site->DataAdd($searchd, 'email', 'E-mail', $criterion == 'email');
	$site->DataAdd($searchd, 'rname', ' ', $criterion == 'rname');
	$site->DataAdd($searchd, 'age', '', $criterion == 'age');
	$site->DataAdd($searchd, 'city', '', $criterion == 'city');
	$site->DataAdd($searchd, 'site', '', $criterion == 'site');
	$site->DataAdd($searchd, 'icq', 'ICQ', $criterion == 'icq');
	$site->DataAdd($searchd, 'gmt', ' ', $criterion == 'gmt');
	$site->DataAdd($searchd, 'active', '', $criterion == 'active');
	$site->DataAdd($searchd, 'points', ' ', $criterion == 'points');
	$site->DataAdd($searchd, 'ip', 'IP', $criterion == 'ip');
	if(!$sonline && !$searchm){
		getUsers();
	}
	TAddSubTitle('');
	AddCenterBox(' ');
	if($searchm){
		$c = ': '.$db->NumRows();
	}else{
		$c = ' : '.$db->NumRows();
	}
	$serchtool = '';
	$serchtool .= '<table cellspacing="0" cellpadding="0" border="0" class="cfgtable"><tr><td>'."\n";
	$serchtool .= '<form method="get">'.$site->Hidden('exe', 'user').'<table cellspacing="0" cellpadding="0" border="0" width="100%"><tr><td>'.$c.'</td><td>: '.$site->Select('show', $showd).'</td><td>'.$site->Submit(' ').'</td></tr></table></form>'."\n";
	$serchtool .= '</td></tr><tr><td>'."\n";
	$serchtool .= '<form method="get">'.$site->Hidden('exe', 'user').'<table cellspacing="0" cellpadding="0" border="0" width="100%"><tr><td>: </td><td>'.$site->Select('criterion', $searchd).$site->Edit('stext', $sstr).'</td><td>'.$site->Submit('').'</td></tr></table></form>'."\n";
	$serchtool .= '</td></tr></table>'."\n";
	AddText($serchtool);
	SortArray($db->QueryResult, 15, true); //    
	if(count($db->QueryResult) > $config['user']['users_on_page']){
		$navigator = new Navigation($page);
		$navigator->GenNavigationMenu($db->QueryResult, $config['user']['users_on_page'], $config['admin_file'].'?exe=user'.($searchm ? '&criterion='.$criterion.'&stext='.$sstr : ''));
		AddNavigation();
		$nav = true;
	}else{
		$nav = false;
		AddText('<br />');
	}
	$text = '';
	$text .= '<table cellspacing="0" cellpadding="0" class="cfgtable">';
	$text .= '<tr><th></th><th>E-mail</th><th> c</th><th>. </th><th></th><th></th><th></th><th>IP</th><th></th></tr>';
	while($row = $db->FetchRow()){
		if($row[20] == '1'){
			$active = '';
		}elseif($row[20] == '0' && $row[21] == ''){
			$active = '';
		}elseif($row[20] == '0' && $row[21] != ''){
			$active = ''; // <a href="mailto:'.$row[6].'">'.$row[6].'</a>
		}
		$text .= '
		<tr>
		<td>'.($editing ? '<a href="'.$config['admin_file'].'?exe=user&a=edituser&id='.$row[0].'">' : '').'<b>'.$row[3].'</b>'.($editing ? '</a>' : '').'</td>
		<td>'.PrintEmail($row[6], $row[3]).'</td>
		<td>'.TimeRender($row[15]).'</td>
		<td>'.TimeRender($row[16]).'</td>
		<td>'.$row[19].'</td>
		<td>'.$row[18].'</td>
		<td>'.$active.'</td>
		<td>'.$row[17].'</td>
		<td>
		'.($editing ? '<a href="'.$config['admin_file'].'?exe=user&a=edituser&id='.$row[0].'"><img src="images/admin/edit.gif" title="" /></a>
		<a href="'.$config['admin_file'].'?exe=user&a=deluser&id='.$row[0].'"><img src="images/admin/delete.gif" title="" /></a>' : '&nbsp;').'
		</td>
		</tr>';
	}
	$text .= '</table>';
	AddText($text);
	if($nav){
		AddNavigation();
	}
}

function AdminUserDelUser()
{
	global $config, $db, $site;
	if(isset($_GET['ok']) && $_GET['ok'] == '1'){
		$id = SafeEnv($_GET['id'], 11, int);
		if(!isset($_POST['del_comments'])){
			$db->Select('users', "`id`='$id'");
			$guser = $db->FetchRow();
			UpdateUserComments($id, '0', $guser[3], $guser[6], $guser[7], $guser[10], $guser[9]);
		}else{
			DeleteAllUserComments($id);
		}
		$db->Delete('users', "`id`='$id'");
		GO($config['admin_file'].'?exe=user');
	}else{
		$r = $db->Select('users', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
		$text = '<form action="'.$config['admin_file'].'?exe=user&a=deluser&id='.SafeEnv($_GET['id'], 11, int).'&ok=1" method="post">     "'.$r[0][3].'"<br />'.$site->Check('del_comments', '1').'    .<br />'.$site->Submit('').'&nbsp;&nbsp;&nbsp; '.$site->Button('', 'onclick="history.go(-1)"').'</form>';
		AddTextBox("", $text);
	}
}

function AdminUserRanks()
{
	global $config, $db, $site, $rankedit;
	TAddSubTitle(' ');
	$ranks = $db->Select('userranks', '');
	SortArray($ranks, 2);
	$users = $db->Select('users', "`type`='2'");
	foreach($users as $u){
		$r = GetUserRank($u[18], $u[22], $u[23]);
		if(!isset($rcounts[$r[2]])){
			$rcounts[$r[2]] = 0;
		}
		$rcounts[$r[2]]++;
	}
	$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
	$text .= '<tr><th></th><th>. </th><th></th><th></th><th></th></tr>';
	foreach($ranks as $rank){
		if(file_exists($config['general']['ranks_dir'].$rank[3]) && is_file($config['general']['ranks_dir'].$rank[3])){
			$image = '<img src="'.$config['general']['ranks_dir'].$rank[3].'" border="0" />';
		}else{
			$image = '';
		}
		$text .= '<tr><td>'.$rank[1].'</td><td>'.$rank[2].'</td><td>'.(isset($rcounts[$rank[0]]) ? $rcounts[$rank[0]] : '0').'</td><td>'.$image.'</td><td>'.($rankedit ? '<a href="'.$config['admin_file'].'?exe=user&a=editrank&id='.$rank[0].'"><img src="images/admin/edit.gif" title="" /></a><a href="'.$config['admin_file'].'?exe=user&a=delrank&id='.$rank[0].'"><img src="images/admin/delete.gif" title="" /></a>' : '&nbsp').'</td></tr>';
	}
	$text .= '</table>';
	AddCenterBox(' ');
	AddText($text);
	if($rankedit){
		FormRow(' ', $site->Edit('rankname', '', false, 'style="width:140px;"'));
		FormRow('', $site->Edit('rankimage', '', false, 'style="width:180px;"'));
		FormRow('  <br /> ', $site->Edit('minpoints', '0', false, 'style="width:60px;"'));
		AddText('<br /><center>.:   :.</center>');
		AddForm('<form name="addrang" method="post" action="'.$config['admin_file'].'?exe=user&a=addrank">', $site->Submit('')).'<br />';
	}
}

function AdminUserEditRank()
{
	global $db, $config, $site;
	$id = SafeEnv($_GET['id'], 11, int);
	$db->Select('userranks', "`id`='$id'");
	$thrank = $db->FetchRow();
	FormRow(' ', $site->Edit('rankname', $thrank[1], false, 'style="width:140px;"'));
	FormRow('', $site->Edit('rankimage', $thrank[3], false, 'style="width:180px;"'));
	FormRow('  <br /> ', $site->Edit('minpoints', $thrank[2], false, 'style="width:60px;"'));
	AddCenterBox(' ');
	AddForm('<form name="addrang" method="post" action="'.$config['admin_file'].'?exe=user&a=saverank&id='.$id.'">', $site->Button('', 'onclick="history.go(-1)"').$site->Submit(' '));
}

function AdminUserRankSave( $action )
{
	global $config, $db;
	$rankname = SafeEnv($_POST['rankname'], 250, str);
	$rankimage = SafeEnv($_POST['rankimage'], 250, str);
	$minpoints = SafeEnv($_POST['minpoints'], 11, int);
	if($action == 'addrank'){
		$db->Insert('userranks', Values('', $rankname, $minpoints, $rankimage));
	}elseif($action == 'saverank'){
		$db->Update('userranks', "title='$rankname',min='$minpoints',image='$rankimage'", "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	}
	GO($config['admin_file'].'?exe=user&a=ranks');
}

function AdminUserDeleteRank()
{
	global $config, $db;
	if(isset($_GET['ok']) && $_GET['ok'] == '1'){
		$db->Delete('userranks', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
		GO($config['admin_file'].'?exe=user&a=ranks');
	}else{
		TAddSubTitle(' ');
		$r = $db->Select('userranks', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
		$text = '     "'.$r[0][1].'"<br />'.'<a href="'.$config['admin_file'].'?exe=user&a=delrank&id='.SafeEnv($_GET['id'], 11, int).'&ok=1"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a>';
		AddTextBox("!", $text);
	}
}

function AdminUserAvatarsGallery()
{
	global $config, $site, $galeryedit, $db;
	TAddSubTitle(' ');
	if(isset($_GET['user']) && $_GET['user'] == '1'){
		$personal = true;
		$dir = $config['general']['personal_avatars_dir'];
		$dirlink = '<a href="'.$config['admin_file'].'?exe=user&a=avatars">   </a>';
		$users = $db->Select('users', "`type`='2'");
		$c = sizeof($users);
		for($i = 0; $i < $c; $i++){
			$users[$users[$i][12]] = $i;
		}
	}else{
		$personal = false;
		$dir = $config['general']['avatars_dir'];
		$dirlink = '<a href="'.$config['admin_file'].'?exe=user&a=avatars&user=1">  </a>';
	}
	$avatars = GetFiles($dir, false, true, '.gif.jpg.jpeg.png');
	$c = count($avatars);
	$allsize = 0;
	$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
	if($c > 0){
		$col = 0;
		for($i = 0; $i < $c; $i++){
			if($col == 0){
				$text .= '<tr>';
			}
			$col++;
			$imagfn = $dir.$avatars[$i];
			$size = getimagesize($imagfn);
			$fsize = filesize($imagfn);
			$allsize = $allsize + $fsize;
			$text .= '<td align="center">'.'<table cellspacing="0" cellpadding="0" align="center"><tr>'.'<td style="border:none"><a href="'.$imagfn.'" target="_blank"><img src="'.$imagfn.'" border="0" width="64" title="('.$size[0].' x '.$size[1].', '.FormatFileSize($fsize).') '.$avatars[$i].'" /></a></td><td valign="top" style="border:none">'.($galeryedit ? '<a href="'.$config['admin_file'].'?exe=user&a=delavatar&filename='.$avatars[$i].($personal ? '&personal' : '').'"><img src="images/admin/delete.gif" title="" /></a>' : '&nbsp;').'</td></tr>'.'<tr><td colspan="2" align="left" style="border:none">'.(($personal && isset($users[$avatars[$i]])) ? '<a href="'.$config['admin_file'].'?exe=user&a=edituser&id='.$users[$users[$avatars[$i]]][0].'">'.$users[$users[$avatars[$i]]][3].'</a>' : '').'</td>'.'</tr></table></td>';
			if($col == 5){
				$text .= '</tr>';
				$col = 0;
			}
		}
		if($col < 5){
			$text .= '</tr>';
		}
	}else{
		$text .= '<tr><td>     .</td></tr>';
	}
	$text .= '</table>';
	$info = '<table cellspacing="0" cellpadding="0" border="0" class="cfgtable"><tr><td width="34%">  : '.$c.'</td><td width="33%"> : '.FormatFileSize($allsize).'</td><td>'.$dirlink.'</td></tr></table>';
	$text = $info.$text;
	AddCenterBox(' ', $text);
	AddText($text);
	if(!$personal && $galeryedit){
		$text .= '<br />.:   :.';
		FormRow(' ', $site->FFile('avatar'));
		AddForm($site->FormOpen('', $config['admin_file'].'?exe=user&a=saveavatar', 'post', 'multipart/form-data'), $site->Submit(''));
	}
	AddText('<br />');
}

function AdminUserSaveAvatar()
{
	global $config;
	$alloy_mime = array('image/gif'=>'.gif', 'image/jpeg'=>'.jpg', 'image/pjpeg'=>'.jpg', 'image/png'=>'.png', 'image/x-png'=>'.png');
	if(isset($_FILES['avatar'])){
		if(isset($alloy_mime[$_FILES['avatar']['type']]) && $alloy_mime[$_FILES['avatar']['type']] == strtolower(GetFileExt($_FILES['avatar']['name']))){
			copy($_FILES['avatar']['tmp_name'], $config['general']['avatars_dir'].$_FILES['avatar']['name']);
		}elseif(!file_exists($_FILES['avatar']['tmp_name'])){
			AddTextBox('', '<center>     .<br /><a href="javascript:history.go(-1)">  </a></center>');
			return;
		}else{
			AddTextBox('', '<center>  .      GIF, JPEG  PNG.<br /><a href="javascript:history.go(-1)">  </a></center>');
			return;
		}
	}
	GO($config['admin_file'].'?exe=user&a=avatars');
}

function AdminUserDeleteAvatar()
{
	global $config, $db;
	if(isset($_GET['personal'])){
		$dir = $config['general']['personal_avatars_dir'];
		$personal = true;
	}else{
		$dir = $config['general']['avatars_dir'];
		$personal = false;
	}
	$avatar = SafeEnv($_GET['filename'], 250, str);
	$filename = RealPath2($dir.$avatar);
	if(isset($_GET['ok']) && $_GET['ok'] == '1'){
		if(file_exists($filename) && is_file($filename)){
			unlink($filename);
		}
		if($personal){
			$db->Update('users', "a_personal='0',avatar=''", "`a_personal`='1' and `avatar`='$avatar'");
		}
		GO($config['admin_file'].'?exe=user&a=avatars');
		exit();
	}else{
		TAddSubTitle(' ');
		if(file_exists($filename) && is_file($filename)){
			$text = '<table cellspacing="0" cellpadding="5" border="0" align="center"><tr><td align="center">'.'<img src="'.$filename.'" border="0" /></tr></td><tr><td align="center">'.'      . ?<br />'.'<a href="'.$config['admin_file'].'?exe=user&a=delavatar&filename='.SafeEnv($_GET['filename'], 250, str).'&ok=1'.($personal ? '&personal' : '').'"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a><br /><br />'.'</td></tr></table>';
		}else{
			$text = '<center>,    ,      .<br /><a href="javascript:history.go(-1)">  </a></center>';
		}
		AddTextBox("!", $text);
	}
}
include_once ($config['apanel_dir'].'configuration/functions.php');

function AdminUser( $action )
{
	global $config, $editing, $rankedit, $galeryedit, $confedit;
	TAddToolLink('', 'main', 'user');
	if($editing){
		TAddToolLink(' ', 'add', 'user&a=add');
	}
	if($confedit){
		TAddToolLink(' ', 'config', 'user&a=config');
	}
	TAddToolBox($action);
	TAddToolLink(' ', 'ranks', 'user&a=ranks');
	if($rankedit){
		TAddToolLink(' ', 'points', 'user&a=points');
	}
	TAddToolLink(' ', 'avatars', 'user&a=avatars');
	TAddToolBox($action);
	TAddSubTitle('');
	switch($action){
		case 'main':
			AdminUserMain();
			return true;
			break;
		case 'add':
			if($editing){
				include_once ($config['apanel_dir'].'members.php');
				AdminUserEditor('user&a=addsave', 'add', 0, false);
				return true;
			}
			break;
		case 'addsave':
			if($editing){
				include_once ($config['apanel_dir'].'members.php');
				AdminUserEditSave('user', 'addsave', 0, false);
				return true;
			}
			break;
		case 'edituser':
			if($editing){
				include_once ($config['apanel_dir'].'members.php');
				AdminUserEditor('user&a=editsave', 'edit', SafeEnv($_GET['id'], 11, int), false);
				return true;
			}
			break;
		case 'editsave':
			if($editing){
				include_once ($config['apanel_dir'].'members.php');
				AdminUserEditSave('user', 'update', SafeEnv($_GET['id'], 11, int), false);
				return true;
			}
			break;
		case 'deluser':
			if($editing){
				AdminUserDelUser();
				return true;
			}
			break;
		case 'ranks':
			AdminUserRanks();
			return true;
			break;
		case 'editrank':
			if($rankedit){
				AdminUserEditRank();
				return true;
			}
			break;
		case 'saverank':
		case 'addrank':
			if($rankedit){
				AdminUserRankSave($action);
				return true;
			}
			break;
		case 'delrank':
			if($rankedit){
				AdminUserDeleteRank();
				return true;
			}
			break;
		case 'avatars':
			AdminUserAvatarsGallery();
			return true;
			break;
		case 'delavatar':
			if($galeryedit){
				AdminUserDeleteAvatar();
				return true;
			}
			break;
		case 'saveavatar':
			if($galeryedit){
				AdminUserSaveAvatar();
				return true;
			}
			break;
		case 'config':
			if($confedit){
				global $config, $site;
				include_once ($config['apanel_dir'].'configuration/functions.php');
				AdminConfigurationEdit('user', 'user', true, false, '  ""');
				return true;
			}
			break;
		case 'configsave':
			if($confedit){
				global $config;
				include_once ($config['apanel_dir'].'configuration/functions.php');
				AdminConfigurationSave('user&a=config', 'user', true);
				return true;
			}
			break;
		case 'points':
			if($rankedit){
				AdminConfigurationEdit('user', 'points', true, false, ' ', 'a=pointsave');
				return true;
			}
			break;
		case 'pointsave':
			if($rankedit){
				AdminConfigurationSave('user&a=points', 'points', true);
				return true;
			}
			break;
		default:
			return false;
	}
	return false;
}

if(isset($_GET['a'])){
	$a = $_GET['a'];
}else{
	$a = 'main';
}

if(!AdminUser($a)){
	AddTextBox('', $config['general']['admin_accd']);
	return;
}

?>