<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

global $search_results, $searchstr, $db;

$objects = $db->Select('articles', "`active`='1'");

foreach($objects as $object){
	$result = array();
	$result['mod'] = $plugin['mod_title']; //  
	$result['coincidence'] = ''; //    
	$result['title'] = SafeDB($object['title'], 255, str); //  
	$result['public'] = TimeRender(SafeDB($object['public'], 11, int));
	$result['link'] = 'index.php?name=articles&op=read&art='.SafeDB($object['id'], 11, int).'&cat='.SafeDB($object['cat_id'], 11, int);
	$result['text'] = strip_tags($object['description']);
	if(strlen($result['text']) > 255){
		$result['text'] = substr($result['text'], 0, 255).'&nbsp; ...';
	}
	if(SSearch($object['seo_keywords'], $searchstr) != false){
		$result['coincidence'] = ' ';
		$search_results[] = $result;
	}elseif(SSearch($object['seo_description'], $searchstr) != false){
		$result['coincidence'] = '';
		$search_results[] = $result;
	}elseif(SSearch($object['title'], $searchstr) != false){
		$result['coincidence'] = '';
		$search_results[] = $result;
	}elseif(SSearch($object['description'], $searchstr) != false){
		$result['text'] = SCoincidence($object['description'], $searchstr);
		$result['coincidence'] = ' ';
		$search_results[] = $result;
	}elseif(SSearch($object['article'], $searchstr) != false){
		$result['text'] = SCoincidence($object['article'], $searchstr);
		$result['coincidence'] = ' ';
		$search_results[] = $result;
	}
}

?>