<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit;
}

function UserSendActivationMail( $username, $user_mail, $login, $pass, $code, $regtime )
{
	global $config;
	$time = $regtime + 604800;
	$time = date("d.m.Y", $time);

	$text = $config['user']['mail_template'];

	$sr = array(
		'{sitename}',
		'{siteurl}',
		'{username}',
		'{date}',
		'{login}',
		'{pass}',
		'{link}'
	);
	$rp = array(
		$config['general']['site_name'],
		'http://'.$config['general']['site_url'],
		$username,
		$time,
		$login,
		$pass,
		'http://'.$config['general']['site_url'].'/index.php?name=plugins&p=activate&code='.$code
	);

	$text = str_replace($sr, $rp, $text);

	SendMail(
		$username,
		$user_mail,
		'  '.$config['general']['site_name'],
		$text
	);
}

function UserSendEndRegMail( $user_mail, $name, $login, $pass, $regtime )
{
	global $config;
	$text = ', ['.$name.']!

     
'.$config['general']['site_url'].'

 : '.date("d.m.Y", $regtime).'
: '.$name.'

    :
: '.$login.'
: '.$pass.'

,     .
 ,   '.$config['general']['site_url'].'.';
	SendMail($name, $user_mail, '['.$config['general']['site_url'].'] ', $text);
}

function UserSendForgotPassword( $user_mail, $name, $login, $pass )
{
	global $config;
	$ip = getip();
	$text = ', ['.$name.']!

  '.$config['general']['site_url'].'
   .

: '.$name.'

    :
: '.$login.'
: '.$pass.'

     :
http://'.$config['general']['site_url'].'/index.php?name=user&op=editprofile

IP-,     : '.$ip.'

 ,   '.$config['general']['site_url'].'.';
	SendMail($name, $user_mail, '['.$config['general']['site_url'].']  ', $text);
}

function GetGmtArray()
{
	$tlist = timezone_identifiers_list();
	$gmt = array();
	foreach($tlist as $timezone){
		$gmt[] = array($timezone, $timezone);
	}
	return $gmt;
}

function GetGmtData( $val )
{
	global $site;
	$tlist = timezone_identifiers_list();
	$gmt = array();
	foreach($tlist as $timezone){
		$site->DataAdd($gmt, $timezone, $timezone, $val == $timezone);
	}
	return $gmt;
}

function GetGalleryAvatarsData( $avatar, $personal )
{
	global $config, $site;
	$avatars = GetFiles($config['general']['avatars_dir'], false, true, '.gif.jpg.jpeg.png');
	$selindex = 0;
	$avd = array();
	if($personal == '1'){
		$site->DataAdd($avd, '', '', true);
	}
	for($i = 0, $c = count($avatars); $i < $c; $i++){
		if($avatar == $avatars[$i]){
			$sel = true;
			$selindex = $i;
		}else{
			$sel = false;
		}
		$site->DataAdd($avd, $avatars[$i], $avatars[$i], $sel);
	}
	return array($avd, $avatars[$selindex]);
}

function GetGalleryAvatars( $avatar, $personal )
{
	global $config, $site;
	$avatars = GetFiles($config['general']['avatars_dir'], false, true, '.gif.jpg.jpeg.png');
	$selindex = 0;
	$avd = array();
	if($personal == '1'){
		$site->DataAdd($avd, '', '', true);
	}
	for($i = 0, $c = count($avatars); $i < $c; $i++){
		if($avatar == $avatars[$i]){
			$sel = true;
			$selindex = $i;
		}else{
			$sel = false;
		}
		$vars['name'] = $avatars[$i];
		$vars['selected'] = $sel;
		$vars['caption'] = $avatars[$i];
	}
	return $vars;
}

?>