<?php

# LinkorCMS
#  2006-2010    (galitsky@pochta.ru)
# : tree_b.class.php
# :         

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

include ($config['inc_dir'].'tree.class.php'); //class Tree

class IndexTree extends Tree
{
	public $catTemplate = '';
	public $moduleName = '';
	public $id_par_name = 'cat';
	public $NumItems = '';
	public $NumItemsCaption = '';
	public $TopCatName = ' ';

	public function Catalog( $cat_id = 0, $CallBackNumItems = '' )
	{
		$this->NumItems = $CallBackNumItems;
		if($cat_id != 0){
			$this->ShowPath($cat_id);
		}
		$this->ShowCats($cat_id);
	}

	public function ShowCats( $cat_id )
	{
		global $db, $config, $site;
		$vars = array();
		$cats = $this->GetChildTree($cat_id);
		$c = count($cats);
		if($c > 0){
			$site->AddTemplatedBox('', $this->catTemplate);
			$site->AddBlock('downloads_cats', true, true, 'cat');
			for($i = 0; $i < $c; $i++){
				$vars['title'] = '<a href="index.php?name='.$this->moduleName.'&'.$this->id_par_name.'='.$cats[$i][0].'">'.$cats[$i][1].'</a>';
				if(file_exists($cats[$i][3])){
					$vars['icon'] = '<img border="0" src="'.$cats[$i][3].'" />';
				}else{
					$vars['icon'] = '<img border="0" src="images/cat.gif" />';
				}
				$vars['description'] = $cats[$i][2];
				$vars['count'] = $cats[$i][4];
				$sub = '';
				$childs = '';
				if(isset($cats[$i][TREE_CHILD_ID])){
					for($j = 0, $k = count($cats[$i][TREE_CHILD_ID]); $j < $k; $j++){
						$sub .= '<a href="index.php?name='.$this->moduleName.'&'.$this->id_par_name.'='.$cats[$i][TREE_CHILD_ID][$j][0].'">'.$cats[$i][TREE_CHILD_ID][$j][1].'</a>'.' ('.$cats[$i][TREE_CHILD_ID][$j][4].'),&nbsp;';
					}
					$childs .= substr($sub, 0, strlen($sub) - 7).'.';
				}
				$vars['childs_cats'] = $childs;
				$site->AddSubBlock('downloads_cats', true, $vars);
			}
			if($cat_id == 0 && function_exists($this->NumItems)){
				$text = '<br />'.$this->NumItemsCaption.call_user_func($this->NumItems);
			}else{
				$text = '';
			}
			$site->AddBlock('cat_caption', true, false, '', '', $text);
		}elseif($cat_id == 0){
			$site->AddTextBox('', '<center>  .</center>');
		}
	}

	public function ShowPath( $id, $view_obj = false, $obj_title = '' )
	{
		global $site;
		$parents = array();
		$parents = $this->GetAllParent($id);
		$parent = $this->GetParentId($id);
		if($parent == 0 && !$view_obj){
			$burl = 'index.php?name='.$this->moduleName;
		}elseif($parent != 0 && !$view_obj){
			$burl = 'index.php?name='.$this->moduleName.'&'.$this->id_par_name.'='.$parent;
		}elseif($view_obj == true){
			$burl = 'index.php?name='.$this->moduleName.'&'.$this->id_par_name.'='.$id;
		}
		$path = '[<a href="'.$burl.'">&lt;&lt;&lt;</a>] &nbsp;';
		$path .= '<b><a href="index.php?name='.$this->moduleName.'">'.$this->TopCatName.'</a></b>';
		if(!$view_obj){
			$c = count($parents) - 1;
		}else{
			$c = count($parents);
		}
		for($i = 0; $i < $c; $i++){
			$path .= ' / <a href="index.php?name='.$this->moduleName.'&'.$this->id_par_name.'='.$parents[$i][0].'">'.$parents[$i][1].'</a>';
		}
		if(!$view_obj){
			$path .= ' / <b>'.$parents[$c][1].'</b>';
		}else{
			$path .= ' / <b>'.$obj_title.'</b>';
		}
		$site->AddTextBox('', $path);
	}
}

?>