<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

global $db;

$where = "`enabled`='1'";
$w2 = GetWhereByAccess('view');
if($w2 != ''){
	$where .= ' and ('.$w2.')';
}
$pages = $db->Select('pages', $where);
SortArray($pages, "order");

$catsPid = array();
$catsId = array();
foreach($pages as $page){
	$catsPid[$page['parent']][] = $page;
}

//  
$vars['title'] = $title;
$tempvars['content'] = 'block/content/menu.html';
if(isset($catsPid[0])){
	$pages = $catsPid[0];
}else{
	$pages = array();
}

$block_menu_items = $site->CreateBlock(true, true, 'menu_item');

foreach($pages as $page){
	if($page['showinmenu'] == '1'){
		if($page['type'] == 'page'){
			$link = 'index.php?name=pages&amp;file='.SafeDB($page['link'], 255, str);
		}elseif($page['type'] == 'link'){
			$link = SafeDB($page['text'], 255, str);
		}
		$vars_item = array('title'=>$page['title'], 'link'=>$link, 'subitems'=>false);
		$block_menu_subitems = $site->CreateBlock(true, true, 'menu_subitem');
		if(isset($catsPid[$page['id']]) && $page['showinmenu'] == '1'){
			$subpages = $catsPid[$page['id']];
			$vars_item['subitems'] = count($subpages) > 0;
			foreach($subpages as $subpage){
				if($subpage['showinmenu'] == '1'){
					if($subpage['type'] == 'page'){
						$link = 'index.php?name=pages&amp;file='.SafeDB($subpage['link'], 255, str);
					}elseif($subpage['type'] == 'link'){
						$link = SafeDB($subpage['text'], 255, str);
					}
					$vars_subitem = array('title'=>$subpage['title'], 'link'=>$link);
					$block_menu_subitems['sub'][] = $site->CreateSubBlock(true, $vars_subitem);
				}
			}
		}
		$menu_item = $site->CreateSubBlock(true, $vars_item, array(), '', '', array('block_menu_subitems'=>$block_menu_subitems));
		$block_menu_items['sub'][] = $menu_item;
	}
}

$childs['block_menu_items'] = $block_menu_items;

?>