<?php

//   
// LinkorCMS Development Group

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$vars['title'] = $title;

$bconf = unserialize($block_config);
$topic = SafeDB($bconf['topic'], 11, int); //  
$max_news = SafeDB($bconf['count'], 11, int); //    


if($topic != 0){
	$where = "`enabled`='1' and `topic_id`='$topic'";
}else{
	$where = "`enabled`='1'";
}

$ex_where = GetWhereByAccess('view');
if($ex_where != ''){
	$where .= ' and ('.$ex_where.')';
}

$news = $db->Select('news', $where);
$count = count($news);

if($count == 0){
	$en = false;
}else{
	$en = true;
}

SortArray($news, 'date', true); //   
if($count > $max_news){
	$news = array_chunk($news, $max_news);
	$count = $max_news;
}
$tempvars['content'] = 'block/content/news.html';

$site->AddBlock('no_news', !$en);
$site->AddBlock('block_news', $en);
$site->AddBlock('block_news_news', true, true, 'news');

$news_vars = array();
for($i = 0; $i < $count; $i++){
	$news_vars['title'] = SafeDB($news[$i]['title'], 255, str);
	$news_vars['url'] = 'index.php?name=news&amp;op=readfull&amp;news='.SafeDB($news[$i]['id'], 11, int);
	$news_vars['text'] = SafeDB($news[$i]['start_text'], 255, str);
	$news_vars['date'] = TimeRender($news[$i]['date']);
	$site->AddSubBlock('block_news_news', true, $news_vars);
}

?>