<?

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$site->Title = ' ';
include_once ($config['inc_dir'].'tree_b.class.php');
$tree = new IndexTree('articles_cats');
$tree->moduleName = 'articles';
$tree->catTemplate = 'module/download_cat.html';
$tree->id_par_name = 'cat';
$tree->NumItemsCaption = '<center>    : ';
$tree->TopCatName = '';

function IndexArticlesGetNumItems()
{
	global $db;
	$ex_where = GetWhereByAccess('view');
	$db->Select('articles', '`active`=\'1\''.($ex_where != '' ? ' and '.$ex_where : ''));
	return $db->NumRows().'.</center>';
}

function IndexArticlesFunc( $id )
{
	global $config;
	return
	'&nbsp'
	.'<a href="'.$config['admin_file'].'?exe=articles&amp;a=editor&amp;id='.$id.'">'
	.'<img src="images/admin/edit.gif" title="">'
	.'</a>'
	.'<a href="'.$config['admin_file'].'?exe=articles&amp;a=delete&amp;id='.$id.'&amp;ok=0">'
	.'<img src="images/admin/delete.gif" title="">'
	.'</a>';
}

function RenderReadArticle( &$art, $cat, $page )
{
	global $site, $config, $user, $tree;
	$vars = array();
	$func = IndexArticlesFunc(SafeDB($art['id'], 11, int));
	$vars['title'] = SafeDB($art['title'], 250, str).($user->isAdmin() ? $func : '');
	if($config['articles']['show_catnav'] == '1'){
		$vars['cat'] = $tree->IdCats[SafeDB($art['cat_id'], 11, int)][1];
		$vars['catlink'] = 'index.php?name=articles&amp;cat='.SafeDB($art['cat_id'], 11, str);
	}else{
		$vars['cat'] = ' ';
		$vars['catlink'] = 'index.php?name=articles';
	}
	if($art['auto_br_article'] == '1'){
		$vars['article'] = nl2br(SafeDB($art['article'], 0, str, false, false, false));
	}else{
		$vars['article'] = SafeDB($art['article'], 0, str, false, false, false);
	}
	$vars['lauthor'] = '';
	$vars['author'] = SafeDB($art['author'], 200, str);
	$vars['lemail'] = 'E-mail';
	$vars['email'] = SafeDB($art['email'], 50, str);
	$vars['lurl'] = '';
	$vars['site'] = SafeDB($art['www'], 250, str);
	$vars['site_url'] = UrlRender(SafeDB($art['www'], 250, str));
	$vars['lpublic'] = '';
	$vars['public'] = TimeRender(SafeDB($art['public'], 11, int), false);
	$vars['lhits'] = '';
	$vars['hits'] = SafeDB($art['hits'], 11, int);
	$vars['lcomments'] = '';
	$vars['comments'] = SafeDB($art['comments_counter'], 11, int);
	$vars['allow_votes'] = false;
	$vars['addvote_url'] = 'index.php?name=articles&amp;op=addvote&amp;file='.SafeDB($art['id'], 11, int).'&amp;cat='.SafeDB($art['cat_id'], 11, int);
	$site->DataAdd($vdata, '0', ' ');
	$site->DataAdd($vdata, '1', ' ');
	$site->DataAdd($vdata, '2', '');
	$site->DataAdd($vdata, '3', '');
	$site->DataAdd($vdata, '4', '');
	$site->DataAdd($vdata, '5', '');
	$vars['votes'] = $site->Select('vote', $vdata);
	$vars['lvote'] = '  ';
	$vars['addvotesubm'] = $site->Submit(' ');
	$site->AddBlock('article', true, false, 'art');
	$site->Blocks['article']['vars'] = $vars;
}

function RenderArticle( &$art, $cat, $page )
{
	global $site, $config, $user, $tree;
	$vars = array();
	$func = IndexArticlesFunc(SafeDB($art['id'], 11, int));
	$vars['title'] = SafeDB($art['title'], 250, str).($user->isAdmin() ? $func : '');
	if($config['articles']['show_catnav'] == '1'){
		$vars['cat'] = $tree->IdCats[SafeDB($art['cat_id'], 11, int)][1];
		$vars['catlink'] = 'index.php?name=articles&amp;cat='.SafeDB($art['cat_id'], 11, str);
	}elseif($cat == 0 && $config['articles']['show_last'] == '1'){
		$vars['cat'] = 0;
		$vars['catlink'] = '';
	}
	if($art['image'] != ''){
		$vars['image'] = RealPath2($config['articles']['images_dir'].SafeDB($art['image'], 255, str));
		$vars['thumb_image'] = RealPath2($config['articles']['images_dir'].'thumbs/'.SafeDB($art['image'], 255, str));
	}else{
		$vars['image'] = false;
	}
	if($art['auto_br_desc'] == '1'){
		$vars['description'] = nl2br(SafeDB($art['description'], 0, str, false, false, false));
	}else{
		$vars['description'] = SafeDB($art['description'], 0, str, false, false, false);
	}
	$vars['lauthor'] = '';
	$vars['author'] = SafeDB($art['author'], 200, str);
	$vars['lemail'] = 'E-mail';
	$vars['email'] = SafeDB($art['email'], 50, str);
	$vars['lurl'] = '';
	$vars['site'] = SafeDB($art['www'], 250, str);
	$vars['site_url'] = UrlRender(SafeDB($art['www'], 250, str));

	$vars['lpublic'] = '';
	$vars['public'] = TimeRender(SafeDB($art['public'], 11, int), false);
	$vars['link2'] = 'index.php?name=articles&amp;op=read'
			.'&amp;art='.SafeDB($art['id'], 11, int)
			.($config['articles']['show_catnav'] == '1' ? '&amp;cat='.SafeDB($art['cat_id'], 11, int) : '')
			.($page != 1 ? '&amp;p='.$page : '');
	$vars['link'] = '<a href="'.$vars['link2'].'">...</a>';
	$vars['lhits'] = '';
	$vars['hits'] = SafeDB($art['hits'], 11, int);
	$vars['lcomments'] = '';
	$vars['comments'] = SafeDB($art['comments_counter'], 11, int);
	$site->AddSubBlock('articles', true, $vars);
}

function IndexArticlesShow( $cat )
{
	global $db, $config, $site, $tree;
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 10, int);
	}else{
		$page = 1;
	}

	$where = ($cat != 0 ? "`cat_id`='$cat' and " : '')."`active`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$arts = $db->Select('articles', $where);

	SortArray($arts, 2, true);
	$num = $config['articles']['articles_on_page'];

	$navigation = new Navigation($page);
	$navigation->GenNavigationMenu($arts, $num, 'index.php?name=articles&amp;cat='.$cat);

	if($db->NumRows() > 0){
		$site->AddTemplatedBox('', 'module/article.html');
		$site->AddBlock('articles', true, true, 'art');
		for($i = 0, $c = count($arts); $i < $c; $i++){
			RenderArticle($arts[$i], $cat, $page);
		}
	}elseif(!isset($tree->Cats[$cat]) && count($tree->Cats) > 0){
		$site->AddTextBox('', '<center>     .</center>');
	}
}

function IndexArticlesRead()
{
	global $db, $config, $site, $tree, $user;
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}
	if(isset($_GET['lastpage'])){
		$last_page = true;
	}else{
		$last_page = false;
	}
	if(isset($_GET['cat'])){
		$cat = SafeEnv($_GET['cat'], 11, int);
	}else{
		$cat = 0;
	}
	if(isset($_GET['art'])){
		$id = SafeEnv($_GET['art'], 11, int);
	}else{
		GO('index.php?name=articles');
	}

	$where = "`id`='$id' and `active`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$db->Select('articles', $where);

	if($db->NumRows() == 0){
		GO('index.php?name=articles');
	}

	$art = $db->FetchRow();
	if($cat > 0){
		$tree->ShowPath($cat, true, SafeDB($art['title'], 255, str));
	}
	$site->AddTemplatedBox('', 'module/article_read.html');
	// SEO
	$site->SeoTitle = SafeDB($art['seo_title'], 255, str);
	$site->SeoKeyWords = SafeDB($art['seo_keywords'], 255, str);
	$site->SeoDescription = SafeDB($art['seo_description'], 255, str);
	//
	RenderReadArticle($art, $cat, $nav_page);
	$db->Update('articles', "hits='".(SafeDB($art['hits'], 11, int) + 1)."'", "`id`='$id'");

	//  
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts('articles_comments', $art['allow_comments'] == '1');
	$posts->EditPageUrl = 'index.php?name=articles&op=editpost&art='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->DeletePageUrl = 'index.php?name=articles&op=deletepost&art='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->NavigationUrl = 'index.php?name=articles&op=read&art='.$id.'&cat='.$cat;
	$posts->PostFormAction = 'index.php?name=articles&op=addpost&art='.$id.'&cat='.$cat."&page=$nav_page";

	$posts->RenderPosts($id, 'article_comments', 'comments_navigation', $last_page, $nav_page);
	$posts->RenderForm(false, 'article_comments_form');
}

function IndexArticlesAddPost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $db, $config, $site, $user;


	$get_id         = 'art';               //    get   id 
	$table          = 'articles_comments'; //  
	$object_table   = 'articles';          //  
	$counter_field  = 'comments_counter';  //      
	$alloy_field    = 'allow_comments';     //      
	$id = SafeEnv($_GET[$get_id],11,int);

	$db->Select($object_table, "`id`='$id'");
	$obj = $db->FetchRow();
	$alloy_comments = $obj[$alloy_field] == '1';


	$back_url = 'index.php?name=articles&op=read&art='.$id.'&cat='.$cat; //  

	$parent = $_POST['parent_id'];
	$parent = explode('_', $parent, 2);
	$post_parent_id = SafeEnv($parent[1],11,int);
	if($post_parent_id == '0'){
		$back_url .= '&lastpage=1';
	}else{
		$back_url .= '&page='.$nav_page;
	}

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table, $alloy_comments);

	if($posts->SavePost($id, false)){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] + 1;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO($back_url.'#post_'.$db->GetLastId());
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexArticlesEditPost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $site, $config;
	$get_id = 'art'; //    get   id 
	$table = 'articles_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);

	$site->AddTemplatedBox('','edit_comment.html');
	$posts->PostFormAction = 'index.php?name=articles&op=savepost&art='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->RenderForm(true, 'post_form');
}

function IndexArticlesEditPostSave()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config;
	$get_id = 'art'; //    get   id 
	$table = 'articles_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	if($posts->SavePost($id, true)){
		GO('index.php?name=articles&op=read&art='.$id.'&cat='.$cat."&page=$nav_page".'#post_'.SafeEnv($_GET['post_id'],11,int));
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexArticlesDeletePost()
{
	$cat = SafeEnv($_GET['cat'],11,int);

	global $config, $db;
	$get_id = 'art'; //    get   id 
	$table = 'articles_comments'; //  
	$object_table = 'articles'; //  
	$counter_field = 'comments_counter'; //      

	$id = SafeEnv($_GET[$get_id], 11, int);
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	$posts->DeletePageUrl = 'index.php?name=articles&op=deletepost&art='.$id.'&cat='.$cat;
	$deleted_posts_count = $posts->DeletePost();

	if($deleted_posts_count > 0){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] - $deleted_posts_count;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO('index.php?name=articles&op=read&art='.$id.'&cat='.$cat);
	}
}

if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}

switch($op){
	case 'main':
		if(isset($_GET['cat'])){
			$cat = SafeEnv($_GET['cat'], 11, int);
		}else{
			$cat = 0;
		}
		if($config['articles']['show_catnav'] == '1'){
			$tree->Catalog($cat, 'IndexArticlesGetNumItems');
		}
		if($cat != 0 || $config['articles']['show_last'] == '1'){
			IndexArticlesShow($cat);
		}
		break;
	case 'read':
		IndexArticlesRead();
		break;
	case 'addcomment':
		IndexArticlesAddComment();
		break;
	// 
	case 'addpost': IndexArticlesAddPost();
		break;
	case 'editpost': IndexArticlesEditPost();
		break;
	case 'savepost': IndexArticlesEditPostSave();
		break;
	case 'deletepost': IndexArticlesDeletePost();
		break;
	// //
	default:
		HackOff();
}

?>