<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

if(!$user->isSuperUser()){
	AddTextBox('', $config['general']['admin_accd']);
	return;
}
if($config['db_type'] != 'FilesDB'){
	AddTextBox('.', '       .<br />
	       .');
	return;
}

function AdminFdbAdminGenTableMenu( $name )
{
	TAddToolLink('', 'main', 'fdbadmin');
	TAddToolLink('', 'structure', 'fdbadmin&a=structure&name='.$name);
	TAddToolLink('', 'review', 'fdbadmin&a=review&name='.$name);
	TAddToolLink('', 'insert', 'fdbadmin&a=insert&name='.$name);
	TAddToolLink('', 'edittable', 'fdbadmin&a=edittable&name='.$name);
	TAddToolLink('', 'droptable', 'fdbadmin&a=droptable&name='.$name);
	TAddToolBox($_GET['a']);
}

function AdminFdbAdminInitCollForm( &$text, $saveparam )
{
	global $config;
	$text .= '<form action="'.$config['admin_file'].'?exe=fdbadmin&a='.$saveparam.'" method="post"><table cellspacing="0" cellspacing="0" class="cfgtable">'.'<tr><th></th><th></th><th>/</th><th></th><th></th><th> </th><th> </th><th></th><th></th><th></th><th> - </th><th> </th></tr>';
}

function AdminFdbAdminCollForm( &$text, $cols, $name = '', $length = '', $SetType = '', $SetAttributes = '', $SetTableType = '' )
{
	global $site;
	$type = array('varchar', 'tinyint', 'text', 'date', 'smallint', 'mediumint', 'int', 'bigint', 'float', 'double', 'decimal', 'datetime', 'time', 'year', 'char', 'tinyblob', 'tinytext', 'blob', 'mediumblob', 'mediumtext', 'longblob', 'longtext', 'enum', 'set');
	for($i = 0; $i < 24; $i++){
		if($SetType == $type[$i]){
			$checked = true;
		}else{
			$checked = false;
		}
		$site->DataAdd($types, $type[$i], $type[$i], $checked);
	}
	$Attributes = array(array('none', ''), array('binary', 'binary'), array('unsigned', 'unsigned'), array('unsigned_zerofill', 'unsigned zerofill'));
	for($i = 0; $i < 4; $i++){
		if($SetAttributes == $Attributes[$i][0]){
			$checked = true;
		}else{
			$checked = false;
		}
		$site->DataAdd($atr, $Attributes[$i][0], $Attributes[$i][1]);
	}
	for($i = 0; $i < $cols; $i++){
		$text .= '<tr><td>'.$site->Edit('name'.$i, '', false, 'style="width:80px;"').'</td><td>'.$site->Select('type'.$i, $types).'</td><td>'.$site->Edit('length'.$i, '', false, 'style="width:50px"').'</td><td>'.$site->Select('atributes'.$i, $atr).'</td><td>'.$site->Check('null'.$i, 'null').'</td><td>'.$site->Edit('default'.$i, '', false, 'style="width:80px;"').'</td><td>'.$site->Check('auto_increment'.$i, 'val').'</td><td>'.$site->Radio('params'.$i, 'primary').'</td><td>'.$site->Radio('params'.$i, 'index').'</td><td>'.$site->Radio('params'.$i, 'unique').'</td><td>'.$site->Radio('params'.$i, 'noparams', true).'</td><td>'.$site->Check('fulltext'.$i, '1').'</td></tr>';
	}
	$text .= '</table>';
}

function AdminFdbAdminCloseCollForm( &$text, $cols, $btnCaption )
{
	global $site;
	$text .= $site->Hidden('cols', $cols)."<br /><br />".$site->Submit($btnCaption).'</form>';
}

function AdminFdbAdminAddTableForm( &$text, $tablename, $SetComment = '', $SetTableType = '' )
{
	global $site;
	$tabletypes = array(array('default', ' '), array('myisam', 'MyISAM'), array('heap', 'MyISAM'), array('merge', 'Merge'), array('berkeleydb', 'Berkeley DB'), array('isam', 'ISAM'));
	for($i = 0; $i < 4; $i++){
		if($SetTableType == $tabletypes[$i][0]){
			$checked = true;
		}else{
			$checked = false;
		}
		$site->DataAdd($tabletype, $tabletypes[$i][0], $tabletypes[$i][1]);
	}
	$text .= '<font size="2">   '.$site->Edit('comment', $SetComment, false, 'style="width: 300px;"').'&nbsp;&nbsp;&nbsp;&nbsp; '.$site->Select('tabletype', $tabletype).'</font>'.$site->Hidden('tablename', $tablename);
}

function AdminFdbAdmin( $action )
{
	global $db, $config, $site;
	switch($action){
		case 'main':
			include(MOD_DIR.'main.inc.php');
			break;
		case 'newtable':
			include(MOD_DIR.'edittable.inc.php');
			break;
		case 'edittable':
			include(MOD_DIR.'edittable.inc.php');
			break;
		case 'savetable':
			include(MOD_DIR.'savetable.inc.php');
			break;
		case 'editsavetable':
			include(MOD_DIR.'savetable.inc.php');
			break;
		case 'droptable':
			include(MOD_DIR.'droptable.inc.php');
			break;
		case 'renametable':
			include(MOD_DIR.'renametable.inc.php');
			break;
		case 'structure':
			include(MOD_DIR.'structuretable.inc.php');
			break;
		case 'review':
			include(MOD_DIR.'review.inc.php');
			break;
		case 'insert':
			include(MOD_DIR.'insert.inc.php');
			break;
		case 'editfield':
			include(MOD_DIR.'insert.inc.php');
			break;
		case 'insertsave':
			include(MOD_DIR.'insertsave.inc.php');
			break;
		case 'editsave':
			include(MOD_DIR.'insertsave.inc.php');
			break;
		case 'deleterow':
			include(MOD_DIR.'deleterow.inc.php');
			break;
		case 'viewcode':
			include(MOD_DIR.'viewcode.inc.php');
			break;
		case 'viewcollinfo':
			include(MOD_DIR.'viewcollinfo.inc.php');
		break;
		case 'newcoll':
			include(MOD_DIR.'newcoll.inc.php');
			break;
		case 'addcoll':
			include(MOD_DIR.'newcollsave.inc.php');
			break;
		case 'deletecoll':
			include(MOD_DIR.'deletecoll.inc.php');
			break;
	}
}

if(isset($_GET['a'])){
	AdminFdbAdmin($_GET['a']);
}else{
	AdminFdbAdmin('main');
}

?>