<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$columns = array();

if($action == 'newtable'){
	$name = SafeEnv($_POST['name'], 250, str);
	$cols = SafeEnv($_POST['cols'], 10, int);
	$bcaption = '';
	$tcaption = ' ';
	$param = 'savetable';
}elseif($action == 'edittable'){
	$name = SafeEnv($_GET['name'], 250, str);
	$columns = $db->GetTableInfo($name);
	$cols = count($columns['cols']);
	$bcaption = ' ';
	$tcaption = '  "'.$name.'"';
	$param = 'editsavetable';
	AdminFdbAdminGenTableMenu($name);
}else{
	$info = array('num_rows'=>0, 'counter'=>0, 'cols'=>array(), 'type'=>'default', 'comment'=>'');
	for($i = 0; $i < $cols; $i++){
		$columns['cols'][] = array('name'=>'', 'type'=>'varchar', 'length'=>'', 'default'=>'', 'attrabutes'=>'', 'notnull'=>true, 'auto_increment'=>false, 'primary'=>false, 'index'=>false, 'unique'=>false, 'fulltext'=>false);
	}
}

$text = '<form action="'.$config['admin_file'].'?exe=fdbadmin&a='.$param.'" method="post">
	<table cellspacing="0" cellspacing="0" class="cfgtable">
		<tr>
			<th></th>
			<th></th>
			<th>/</th>
			<th></th>
			<th></th>
			<th> </th>
			<th> </th>
			<th></th>
			<th></th>
			<th></th>
			<th> - </th>
			<th> </th>
		</tr>';

$types = array();
$site->DataAdd($types, 'varchar', 'varchar');
$site->DataAdd($types, 'tinyint', 'tinyint');
$site->DataAdd($types, 'text', 'text');
$site->DataAdd($types, 'date', 'date');
$site->DataAdd($types, 'smallint', 'smallint');
$site->DataAdd($types, 'mediumint', 'mediumint');
$site->DataAdd($types, 'int', 'int');
$site->DataAdd($types, 'bigint', 'bigint');
$site->DataAdd($types, 'float', 'float');
$site->DataAdd($types, 'double', 'double');
$site->DataAdd($types, 'decimal', 'decimal');
$site->DataAdd($types, 'datetime', 'datetime');
$site->DataAdd($types, 'timestamp', 'timestamp');
$site->DataAdd($types, 'time', 'time');
$site->DataAdd($types, 'year', 'year');
$site->DataAdd($types, 'char', 'char');
$site->DataAdd($types, 'tinyblob', 'tinyblob');
$site->DataAdd($types, 'tinytext', 'tinytext');
$site->DataAdd($types, 'blob', 'blob');
$site->DataAdd($types, 'mediumblob', 'mediumblob');
$site->DataAdd($types, 'mediumtext', 'mediumtext');
$site->DataAdd($types, 'longblob', 'longblob');
$site->DataAdd($types, 'longtext', 'longtext');
$site->DataAdd($types, 'enum', 'enum');
$site->DataAdd($types, 'set', 'set');

$atr = array();
$site->DataAdd($atr, 'none', '');
$site->DataAdd($atr, 'binary', 'binary');
$site->DataAdd($atr, 'unsigned', 'unsigned');
$site->DataAdd($atr, 'unsigned zerofill', 'unsigned zerofill');

$tabletypes = array();
$site->DataAdd($tabletypes, 'default', ' ');
$site->DataAdd($tabletypes, 'MyISAM', 'MyISAM');
$site->DataAdd($tabletypes, 'HEAP', 'Heap');
$site->DataAdd($tabletypes, 'MERGE', 'Merge');
$site->DataAdd($tabletypes, 'BDB', 'Berkeley DB');

if(isset($info['type'])){
	$tabletypes['selected'] = $info['type'];
}

for($i = 0; $i < $cols; $i++){
	if($action == 'edittable'){
		$types['selected'] = $columns['cols'][$i]['type'];
		if(isset($columns['cols'][$i]['attributes'])){
			$atr['selected'] = $columns['cols'][$i]['attributes'];
		}else{
			$atr['selected'] = '';
		}
	}
	$primary = (isset($columns['cols'][$i]['primary']) ? $columns['cols'][$i]['primary'] : false);
	$unique = (isset($columns['cols'][$i]['unique']) ? $columns['cols'][$i]['unique'] : false);
	$index = (isset($columns['cols'][$i]['index']) ? $columns['cols'][$i]['index'] : false);
	$text .= '<tr>
		<td>'.$site->Edit('name'.$i, (isset($columns['cols'][$i]['name']) ? $columns['cols'][$i]['name'] : ''), false, 'style="width:80px;"').'</td>
		<td>'.$site->Select('type'.$i, $types).'</td>
		<td>'.$site->Edit('length'.$i, (isset($columns['cols'][$i]['length']) ? $columns['cols'][$i]['length'] : ''), false, 'style="width:50px"').'</td>
		<td>'.$site->Select('attributes'.$i, $atr).'</td><td>'.$site->Check('notnull'.$i, 'notnull', (isset($columns['cols'][$i]['notnull']) ? false : true)).'</td>
		<td>'.$site->Edit('default'.$i, (isset($columns['cols'][$i]['default']) ? $columns['cols'][$i]['default'] : ''), false, 'style="width:80px;"').'</td>
		<td>'.$site->Check('auto_increment'.$i, 'val', (isset($columns['cols'][$i]['auto_increment']) ? $columns['cols'][$i]['auto_increment'] : false)).'</td>
		<td>'.$site->Radio('params'.$i, 'primary', $primary).'</td><td>'.$site->Radio('params'.$i, 'index', $index).'</td>
		<td>'.$site->Radio('params'.$i, 'unique', $unique).'</td><td>'.$site->Radio('params'.$i, 'noparams', (!$primary && !$unique && !$index)).'</td>
		<td>'.$site->Check('fulltext'.$i, '1', (isset($columns['cols'][$i]['fulltext']) ? $columns['cols'][$i]['fulltext'] : false)).'</td>
	</tr>';
}

$text .= '</table><font size="2">   '.$site->Edit('comment', '', false, 'style="width: 300px;"').'&nbsp;&nbsp;&nbsp;&nbsp; '.$site->Select('tabletype', $tabletypes).'</font>'.$site->Hidden('tablename', $name).$site->Hidden('cols', $cols)."<br /><br />";

if($action == 'edittable'){
	$text .= $site->Hidden('num_rows', $columns['num_rows']).$site->Hidden('counter', $columns['counter']);
}

$text .= $site->Submit($bcaption).'</form>';
AddTextBox($tcaption, $text);

?>