<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$num_cols = SafeEnv($_POST['cols'], 11, int);
$cols = array();
$col = array();
for($i = 0; $i < $num_cols; $i++){
	$col['name'] = SafeEnv($_POST['name'.$i], 250, str);
	$col['type'] = SafeEnv($_POST['type'.$i], 250, str);
	if($_POST['length'.$i] != ''){
		$col['length'] = SafeEnv($_POST['length'.$i], 11, int);
	}
	if($_POST['default'.$i] != ''){
		$col['default'] = $_POST['default'.$i];
	}else{
		switch($col['type']){
			case "varchar":
			case "char":
				$col['default'] = '';
				break;
		}
	}
	if($_POST['attributes'.$i] != 'none'){
		$col['attributes'] = $_POST['attributes'.$i];
	}
	if(!isset($_POST['notnull'.$i])){
		$col['notnull'] = true;
	}
	if(isset($_POST['auto_increment'.$i])){
		$col['auto_increment'] = true;
	}
	switch($_POST['params'.$i]){
		case "primary":
			$col['primary'] = true;
			break;
		case "index":
			$col['index'] = true;
			break;
		case "unique":
			$col['unique'] = true;
			break;
	}
	if(isset($_POST['fulltext'.$i][$i])){
		$col['fulltext'] = true;
	}
	$cols[] = $col;
	$col = array();
}
if($_POST['tabletype'] != 'default'){
	$query['type'] = $_POST['tabletype'];
}
if($_POST['comment'] != ''){
	$query['comment'] = $_POST['comment'];
}
$query['cols'] = $cols;
if($action == 'savetable'){
	$db->CreateTable(SafeEnv($_POST['tablename'], 250, str), $query);
	GO($config['admin_file'].'?exe=fdbadmin');
}elseif($action == 'editsavetable'){
	$query['num_rows'] = SafeEnv($_POST['num_rows'], 11, int);
	$query['counter'] = SafeEnv($_POST['counter'], 11, int);
	$db->UpdateTableInfo(SafeEnv($_POST['tablename'], 250, str), $query);
	GO($config['admin_file'].'?exe=fdbadmin&a=structure&name='.SafeEnv($_POST['tablename'], 250, str));
}

GO($config['admin_file'].'?exe=fdbadmin');

?>