<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

function AdminFeedBackDepartments()
{
	global $config, $db;
	$db->Select('feedback', '');
	$text = '<table cellspacing="0" cellpadding="0" class="cfgtable">';
	$text .= '<tr><th></th><th>E-mail</th><th></th><th></th></tr>';
	while($row = $db->FetchRow()){
		switch($row[3]){
			case '1':
				$st = '<a href="'.$config['admin_file'].'?exe=feedback&a=changestatus&id='.SafeDB($row[0], 11, int).'" title=""><font color="#008000">.</font></a>';
				break;
			case '0':
				$st = '<a href="'.$config['admin_file'].'?exe=feedback&a=changestatus&id='.SafeDB($row[0], 11, int).'" title=""><font color="#FF0000">.</font></a>';
				break;
		}
		$func = '<a href="'.$config['admin_file'].'?exe=feedback&a=edit&id='.SafeDB($row[0], 11, int).'"><img src="images/admin/edit.gif" title="" /></a>'.'<a href="'.$config['admin_file'].'?exe=feedback&a=delete&id='.SafeDB($row[0], 11, int).'&ok=0"><img src="images/admin/delete.gif" title="" /></a>';
		$text .= '<tr><td><b><a href="'.$config['admin_file'].'?exe=feedback&a=edit&id='.SafeDB($row[0], 11, int).'" title="">'.SafeEnv($row[1], 255, str).'</b></td>
		<td>'.PrintEmail(SafeEnv($row[2], 50, str), SafeEnv($row[1], 255, str)).'</td>
		<td>'.$st.'</td>
		<td>'.$func.'</td>
		</tr>';
	}
	$text .= '</table>';
	AddTextBox('', $text);
}

function AdminFeedBackEditor()
{
	global $config, $db, $site;
	$name = '';
	$email = '';
	$active = array(false, false);
	if(!isset($_GET['id'])){
		$active[1] = true;
		$headt = '';
		$bbb = '';
	}elseif(isset($_GET['id'])){
		$id = SafeEnv($_GET['id'], 11, int);
		$db->Select('feedback', "`id`='".$id."'");
		$fb = $db->FetchRow();
		$name = SafeDB($fb[1], 255, str);
		$email = SafeDB($fb[2], 50, str);
		$active[$fb[3]] = true;
		$headt = '';
		$bbb = ' ';
		unset($fb);
	}
	FormRow('', $site->Edit('name', $name, false, 'style="width:100%;" maxlength="255"'), 200);
	FormRow('E-mail', $site->Edit('email', $email, false, 'style="width:100%;" maxlength="50"'));
	FormRow('', $site->Radio('enabled', 'on', $active[1]).'&nbsp;'.$site->Radio('enabled', 'off', $active[0]).'');
	AddCenterBox($headt);
	AddForm('<form action="'.$config['admin_file'].'?exe=feedback&a=save'.(isset($id) ? '&id='.$id : '').'" method="post">', $site->Submit($bbb));
}

function AdminFeedBackSave()
{
	global $db, $config;
	$name = SafeEnv($_POST['name'], 255, str);
	$email = SafeEnv($_POST['email'], 50, str);
	$active = EnToInt($_POST['enabled']);
	if(!isset($_GET['id'])){
		$vals = Values('', $name, $email, $active);
		$db->Insert('feedback', $vals);
	}else{
		$id = SafeEnv($_GET['id'], 11, int);
		$set = "name='$name',email='$email',active='$active'";
		$db->Update('feedback', $set, "`id`='".$id."'");
	}
	GO($config['admin_file'].'?exe=feedback');
}

function AdminFeedBackChangeStatus()
{
	global $config, $db;
	$db->Select('feedback', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	if($db->NumRows() > 0){
		$r = $db->FetchRow();
		if($r[3] == 1){
			$en = '0';
		}else{
			$en = '1';
		}
		$db->Update('feedback', "active='$en'", "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	}
	GO($config['admin_file'].'?exe=feedback');
}

function AdminFeedBackDelete()
{
	global $config, $db;
	if(!isset($_GET['id'])){
		GO($config['admin_file'].'?exe=feedback');
	}
	if(isset($_GET['ok']) && $_GET['ok'] == '1'){
		$db->Delete('feedback', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
		GO($config['admin_file'].'?exe=feedback');
	}else{
		$r = $db->Select('feedback', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
		$text = '     "'.SafeDB($r[0][1], 255, str).'"<br />'.'<a href="'.$config['admin_file'].'?exe=feedback&a=delete&id='.SafeEnv($_GET['id'], 11, int).'&ok=1"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a>';
		AddTextBox("!", $text);
	}
}
include_once ($config['apanel_dir'].'configuration/functions.php');

function AdminHosting( $action )
{
	TAddToolLink('', 'main', 'feedback');
	TAddToolLink(' ', 'add', 'feedback&a=add');
	TAddToolLink('', 'config', 'feedback&a=config');
	TAddToolBox($action);
	switch($action){
		case 'main':
			AdminFeedBackDepartments();
			break;
		case 'add':
		case 'edit':
			AdminFeedBackEditor();
			break;
		case 'save':
			AdminFeedBackSave();
			break;
		case 'changestatus':
			AdminFeedBackChangeStatus();
			break;
		case 'delete':
			AdminFeedBackDelete();
			break;
		case 'config':
			AdminConfigurationEdit('feedback', 'feedback', true, false, '  " "');
			break;
		case 'configsave':
			AdminConfigurationSave('feedback&a=config', 'feedback', true);
			break;
		default:
			AdminFeedBackDepartments();
	}
}

if(isset($_GET['a'])){
	AdminHosting($_GET['a']);
}else{
	AdminHosting('main');
}

?>