<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$site->Title = ' ';

function IndexFeedBackForm()
{
	global $site, $db, $config;
	$site->AddTemplatedBox(' ', 'module/feedback.html');
	$site->AddBlock('feedback');
	$vars['url'] = 'index.php?name=feedback&amp;op=send';
	$vars['top_text'] = $config['feedback']['top_text'];
	$vars['bottom_text'] = $config['feedback']['bottom_text'];
	$site->Blocks['feedback']['vars'] = $vars;
	$site->AddBlock('departments', true, true, 'department');
	$db->Select('feedback', "`active`='1'");
	$vars = array();
	$vars['id'] = 0;
	$vars['hname'] = '';
	$site->AddSubBlock('departments', true, $vars);
	while($dp = $db->FetchRow()){
		$vars = array();
		$vars['id'] = SafeDB($dp[0], 11, int);
		$vars['hname'] = SafeDB($dp[1], 255, str);
		$site->AddSubBlock('departments', true, $vars);
	}
}

function IndexFeedBackSend()
{
	global $db, $config, $site;
	$err = array();
	if(!isset($_POST['name']) || !isset($_POST['email']) || !isset($_POST['subject']) || !isset($_POST['department']) || !isset($_POST['message']) || !isset($_POST['feedback_form'])){
		GO('index.php');
	}else{
		if($_POST['name'] != ''){
			$name = SafeEnv($_POST['name'], 250, str);
		}else{
			$err[] = ',   !';
		}
		if($_POST['email'] != ''){
			$email = SafeEnv($_POST['email'], 50, str);
		}else{
			$err[] = ',     E-mail!';
		}
		if($_POST['subject'] != ''){
			$subject = SafeEnv($_POST['subject'], 250, str);
		}else{
			$err[] = ',   !';
		}
		if($_POST['department'] != ''){
			$department = SafeEnv($_POST['department'], 11, int);
			$db->Select('feedback', "`active`='1' and `id`='$department'");
			if($db->NumRows() > 0){
				$dep = $db->FetchRow();
				$dep_email = $dep[2];
			}else{
				$err[] = '          .';
			}
		}else{
			$err[] = ',  !';
		}
		if($_POST['message'] != ''){
			$message = SafeEnv($_POST['message'], 3500, str);
		}else{
			$err[] = ',  !';
		}
	}
	if(count($err) == 0){
		$text = "!\n\n"."       \"".$config['general']['site_name']."\".\n"."   .\n\n".": ".$name."\n"."E-mail: ".$email."\n"." : ".$subject."\n"." : ".TimeRender(time())."\n".":\n".$message."\n";
		SendMail('', $dep_email, $subject, $text, false, $name, $email);
		$site->AddTextBox(' ', '<center>   !</center>');
	}else{
		$text = '  ! :<br /><ul>';
		foreach($err as $error){
			$text .= '<li>'.$error.'</li>';
		}
		$text .= '</ul>';
		$site->AddTextBox('', $text);
	}
}

if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}

switch($op){
	case 'main':
		IndexFeedBackForm();
		break;
	case 'send':
		IndexFeedBackSend();
		break;
	default:
		HackOff();
}

?>