<?php
# LinkorCMS
# LinkorCMS Development Group
# www.linkorcms.ru
#  LinkorCMS 1.2.
#  

function  Forum_Statistics_Init( $title = '')
{
global $lang;
$statistics =
		array(
			"topics_count"=>0,
			"reply_count"=>0,
			"hits"=>0,
			"author_count"=>array(),
			"author_name"=>array(),
			"topics_title"=> $lang['topics'],
			"reply_title"=>$lang['reply'],
			"hits_title"=>$lang['hits'],
			"author_topics"=>$lang['author_topics'],
		    "active_author_topics"=>$lang['active_author_topics'],
			"title" => $title
       );
return $statistics;
}

function  Forum_Statistics_Render($statistics = array())
{
 global $site;
 if( count($statistics)>0)
	{
		$site->AddTemplatedBox('', 'module/forum_statistics.html');
		$site->AddBlock('statistics', true,false, 'stat');
		$site->Blocks['statistics']['vars'] =$statistics;
	}
}


function  Forum_Statistics_Author(&$statistics = array())
{
 	if(count($statistics['author_count'])>0){
		$statistics['author_count'] = count(array_unique($statistics['author_count']));
	}
	else
	{
		$statistics['author_count'] = 0;
	}
	$statistics['active'] = '';
 	if(count($statistics['author_name'])>0){
	   SortArray($statistics['author_name'], 'count' ,true);
	   $i = 0;
	   foreach($statistics['author_name'] as $author)
		{
		   $i++;
	      $statistics['active'] .= '<a href="index.php?name=user&op=userinfo&user='.$author['id'].'"> '.$author['name'].'</a> ['.$author['count'].']'.( ($i==20 or count($statistics['author_name']) == $i) ?'.':', ');
		  if($i == 20) break;
		}
	}
}

?>