<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$site->Title = ' ';

function GBCheckFlood()
{
	global $db, $config;
	$flood_time = $config['gb']['floodtime'];
	$db->Select('guestbook', "`user_ip`='".getip()."' and `date`>'".(time() - $flood_time)."'");
	if($db->NumRows() > 0){
		return true;
	}else{
		return false;
	}
}

// 
function IndexGBAddMessage( &$msg )
{
	global $site, $user, $config;
	//    
	if($msg[2] != '' && $msg[3] != '1'){
		$vars['name'] = '<a href="mailto:'.SafeDB($msg['email'], 50, str).'">'.SafeDB($msg['name'], 50, str).'</a>';
		$vars['name2'] = SafeDB($msg['name'], 50, str);
		$vars['email'] = '<a href="mailto:'.SafeDB($msg['email'], 50, str).'"><img src="images/buttons/email.gif" /></a>';
		$vars['email2'] = SafeDB($msg['email'], 50, str);
	}else{
		$vars['name'] = SafeDB($msg[1], 50, str);
		$vars['email'] = '';
	}

	// 
	if($msg[4] != ''){
		$url = UrlRender(SafeDB($msg['url'], 255, str));
		$vars['url'] = '<a href="'.$url.'" target="_blank"><img src="images/buttons/www.gif" /></a>';
		$vars['url2'] = $url;
	}else{
		$vars['url'] = '';
	}

	// 
	if($msg[5] != ''){
		$vars['icq'] = '<a href="http://web.icq.com/'.SafeDB($msg['icq'], 255, str).'" target="_blank"><img src="images/buttons/icq.gif" /></a>';
		$vars['icq2'] = SafeDB($msg['icq'], 255, str);
	}else{
		$vars['icq'] = '';
	}

	// 
	if(trim($msg['answers']) == ''){
		$answers = array();
	}else{
		$answers = unserialize($msg['answers']);
	}

	//   

	$vars['access_answer'] = $user->CheckAccess2('guestbook', 'answer');
	$vars['edit_answer_url'] = $config['admin_file'].'?exe=guestbook&amp;a=editanswer&amp;id='.SafeDB($msg['id'], 11, int);
	$vars['delete_answer_url'] = $config['admin_file'].'?exe=guestbook&amp;a=delanswer&amp;id='.SafeDB($msg['id'], 11, int);
	$vars['add_answer_url'] = $config['admin_file'].'?exe=guestbook&amp;a=addanswer&amp;id='.SafeDB($msg['id'], 11, int);
	if($user->isAdmin()){
		$func = '';
		if(key_exists($user->Name(), $answers)){
			$vars['admin_answer'] = true;
			if($vars['access_answer']){
				$func = '(<a href="'.$vars['edit_answer_url'].'"> </a> :: '
				.'<a href="'.$vars['delete_answer_url'].'"> </a>)';
			}else{
				$func = '';
			}
		}elseif($vars['access_answer']){
			$vars['admin_answer'] = false;
			$func = '(<a href="'.$vars['add_answer_url'].'"></a>)';
		}
		$vars['admin'] = $func;
	}else{
		$vars['admin'] = '';
		$vars['admin_answer'] = false;
	}

	$keys = array_keys($answers);
	$answerstext = '';
	if(count($answers) > 0){
		$answerstext = ': <ul style="margin:3px;margin-left:16px;">'."\n";
		foreach($keys as $key){
			$answerstext .= '<li>'.$key.' - '.$answers[$key]."\n";
		}
		$answerstext .= '</ul>'."\n";
	}

	$vars['date'] = TimeRender(SafeDB($msg['date'], 11, int));
	$vars['text'] = SafeDB($msg['message'], 0, str);
	$vars['answers'] = $answerstext;
	$site->AddSubBlock('guestbook', true, $vars);
}

function IndexGBAddForm( $top = false )
{
	global $site, $user, $config, $userAuth;
	$vars['lname'] = ' *: ';
	$vars['name'] = ($userAuth && $user->isDef('u_name') ? $user->Get('u_name') : '');
	$vars['lemail'] = ' e-mail*: ';
	$vars['email'] = ($userAuth && $user->isDef('u_email') ? $user->Get('u_email') : '');
	$vars['lhideemail'] = '  e-mail  : ';
	$vars['hideemail'] = ($userAuth && $user->isDef('u_hideemail') ? $user->Get('u_hideemail') : '');
	$vars['lsite'] = ' : ';
	$vars['site'] = ($userAuth && $user->isDef('u_homepage') ? $user->Get('u_homepage') : '');
	$vars['licq'] = ' ICQ: ';
	$vars['icq'] = ($userAuth && $user->isDef('u_icq') ? $user->Get('u_icq') : '');
	$vars['ltext'] = ' *: ';
	$vars['text'] = '';
	$vars['kaptcha_url'] = 'index.php?name=plugins&amp;p=antibot';
	$vars['kaptcha_width'] = '120';
	$vars['kaptcha_height'] = '40';
	$vars['scaption'] = '';
	$vars['hcaption'] = ' ';
	$vars['title'] = '  : ';
	$vars['action'] = 'index.php?name=guestbook&amp;op=save';
	if($top){
		$site->AddBlock('bottomgbform', false, false);
		$site->AddBlock('topgbform', true, false, 'form', 'module/guestbookform.html');
		$site->Blocks['topgbform']['vars'] = $vars;
	}else{
		$site->AddBlock('topgbform', false, false);
		$site->AddBlock('bottomgbform', true, false, 'form', 'module/guestbookform.html');
		$site->Blocks['bottomgbform']['vars'] = $vars;
	}
}

function IndexGBMain()
{
	global $db, $config, $site, $userAuth;
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 10, int);
	}else{
		$page = 1;
	}
	$msgs = $db->Select('guestbook', '`premoderate`=\'1\'');
	SortArray($msgs, 8, true);
	$num = $config['gb']['msgonpage'];
	$navigation = new Navigation($page);
	$navigation->GenNavigationMenu($msgs, $num, 'index.php?name=guestbook');

	$site->AddBlock('guestbook', true, true, 'gb');
	if(count($msgs) > 0){
		foreach($msgs as $message){
			IndexGBAddMessage($message);
		}
	}else{
		$site->AddTextBox('', '<center>  .</center>');
	}
	$site->AddTemplatedBox('', 'module/guestbook.html');
	IndexGBAddForm($config['gb']['formposition'] == 'top');
}

function IndexGBAddMsgSave()
{
	global $db, $config, $site, $user, $userAuth;
	$r = array();
	$er = array();
	if(!isset($_GET['name']) || !isset($_POST['email']) || !isset($_POST['site']) || !isset($_POST['icq']) || !isset($_POST['text'])){
		$er[] = '  .';
	}
	if(GBCheckFlood()){
		$er[] = ' ,  .';
	}
	if(strlen($_POST['name']) == 0){
		$er[] = '   .';
	}
	if(strlen($_POST['email']) == 0){
		$er[] = '    e-mail.';
	}elseif(!CheckEmail($_POST['email'])){
		$er[] = '     e-mail.';
	}
	if(strlen($_POST['text']) == 0){
		$er[] = '    ,    .';
	}
	if($_POST['icq'] != ''){
		if(!is_numeric($_POST['icq'])){
			$er[] = '  ICQ     .';
		}
	}
	if(!$user->Auth && !$user->isDef('captcha_keystring') || $user->Get('captcha_keystring') != $_POST['keystr']){
		$er[] = '      .';
	}
	if(count($er) == 0){
		if(isset($_POST['hideemail'])){
			$hideemail = '1';
		}else{
			$hideemail = '0';
		}
		if($userAuth == 1 || $config['gb']['moderation'] == '0'){
			$moderated = 1;
		}else{
			$moderated = 0;
		}
		$vals = Values('', SafeEnv($_POST['name'], 50, str, true), SafeEnv($_POST['email'], 50, str, true), $hideemail, SafeEnv(Url($_POST['site']), 250, str, true), SafeEnv($_POST['icq'], 15, str, true), SafeEnv($_POST['text'], $config['gb']['msgmaxlen'], str, true), '', time(), getip(), $moderated);
		$db->Insert('guestbook', $vals);
		$user->ChargePoints($config['points']['gb_public']);
		if($userAuth == '1' || $config['gb']['moderation'] == '0'){
			GO('index.php?name=guestbook');
		}else{
			$text = '<center><br />!      .<br /><br />';
			$text .= '<input type="button" value="" onclick="history.back();"><br /></center>';
			$site->AddTextBox('', $text);
		}
	}else{
		$text = '      :<br /><ul>';
		foreach($er as $error){
			$text .= '<li>'.$error;
		}
		$text .= '</ul><center><input type="button" value="" onclick="history.back();"></center>';
		$site->AddTextBox('', $text);
	}
}

if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}

switch($op){
	case 'main':
		IndexGBMain();
		break;
	case 'add':
		IndexNewsAddCommentSave();
		break;
	case 'save':
		IndexGBAddMsgSave();
		break;
	default:
		HackOff();
}

?>