<?php

//  

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit;
}

$site->Title = '';
$site->RssTitle = ' RSS';
$site->RssLink = 'http://'.$config['general']['site_url'].'/rss.php';

function IndexNewsFunc( $id )
{
	global $config;
	return
	'&nbsp'
	.'<a href="'.$config['admin_file'].'?exe=news&amp;a=edit&amp;id='.$id.'">'
	.'<img src="images/admin/edit.gif" title="">'
	.'</a>'
	.'<a href="'.$config['admin_file'].'?exe=news&amp;a=delnews&amp;id='.$id.'&amp;ok=0">'
	.'<img src="images/admin/delete.gif" title="">'
	.'</a>';
}

function IndexNewsAdd( &$news, $topic, $readfull=false )
{
	global $newsTemp, $site, $op, $config, $user;

	$func = IndexNewsFunc(SafeDB($news['id'], 11, int));
	$img_view = SafeDB($news['img_view'],1,int);
	$link = 'index.php?name=news&op=readfull&news='.SafeDB($news['id'], 11, int);
	$topic_link = 'index.php?name=news&topic='.SafeDB($news['topic_id'], 11, int);

	$vars['topic'] = $topic;
	$vars['id'] = SafeDB($news['id'],11,int);
	$vars['title'] = SafeDB($news['title'],255,str).($user->isAdmin() ? $func : '');
	$vars['author'] = SafeDB($news['author'],255,str);

	$date = SafeDB($news['date'], 11, int);
	$vars['date'] = TimeRender($date);
	$vars['time'] = date('H:i', $date);
	$vars['day'] = date('d', $date);
	$vars['month'] = date('m', $date);
	$vars['year'] = date('y', $date);
	$vars['year_full'] = date('Y', $date);

	$vars['link'] = $link;
	$vars['cat_link'] = $topic_link;
	$vars['com_count'] = SafeDB($news['comments_counter'],11,int);
	$vars['admin'] = $user->isAdmin();

	if(isset($_GET['topic'])){
		$link .= '&topic='.SafeEnv($_GET['topic'],11,int);
	}

	if(strlen(strip_tags($news['end_text']))>0){ //    .
		$vars['full'] = '<a href="'.$link.'"> </a>';
		$read_more = true;
	}else{
		$vars['full'] = '';
		$read_more = false;
	}

	if(!$readfull){
	//  
		$image = SafeDB(RealPath2($news['icon']),255,str);
		$icons_dir = $config['news']['icons_dirs'];
		if(!is_file($icons_dir.$image)){
			$vars['image'] = '';
			$vars['image_url'] = false;
		}elseif($img_view == 1){ //  
			$vars['image'] = $icons_dir.$image;
			$vars['image_url'] = false;
		}elseif($img_view == 2){ // 
			$vars['image'] = $icons_dir.'thumbs/'.$image;
			$vars['image_url'] = $icons_dir.$image;
		}elseif($img_view == 0){ // 
			$size = ImageSize($icons_dir.$image);
			if($size['width'] > $config['news']['thumb_max_width']){
				$vars['image'] = $icons_dir.'thumbs/'.$image;
				$vars['image_url'] = $icons_dir.$image;
			}else{
				$vars['image'] = $icons_dir.$image;
				$vars['image_url'] = false;
			}
		}


		if($news['allow_comments']=='1'){
			$vars['com'] = '<a href="'.$link.'">('.SafeDB($news['comments_counter'],11,int).')</a>';
		}else{
			$vars['com'] = '';
		}

		if($news['auto_br']=='1'){
			$news['start_text'] = SafeDB(nl2br($news['start_text']),0,str,false,false);
		}else{
			$news['start_text'] = SafeDB($news['start_text'],0,str,false,false);
		}
		$vars['text'] = $news['start_text'];

	}else{
	//  
		if(SafeDB($news['comments_counter'],11,int) > 0){
			$vars['com_status'] = '';
		}else{
			$vars['com_status'] = '  ';
		}
		if($news['auto_br']=='1' && $read_more){
			$news['end_text'] = SafeDB(nl2br($news['end_text']),0,str,false,false);
		}elseif($news['auto_br']=='0' && $read_more){
			$news['end_text'] = SafeDB($news['end_text'],0,str,false,false);
		}elseif($news['auto_br']=='1' && !$read_more){
			$news['end_text'] = SafeDB(nl2br($news['start_text']),0,str,false,false);
		}else{
			$news['end_text'] = SafeDB($news['start_text'],0,str,false,false);
		}
		$vars['text'] = $news['end_text'];
	}

	$site->AddSubBlock('news',true,$vars);
}


function IndexNewsMain()
{
	global $db, $config, $site;

	$site->AddBlock('news',true,true);

	if(isset($_GET['page'])){
		$page=SafeEnv($_GET['page'],10,int);
	}else{
		$page=1;
	}
	if(isset($_GET['topic'])){
		$topic = SafeEnv($_GET['topic'],11,int);
	}else{
		$topic = false;
	}
	$topics = GetTopics();

	$where = "`enabled`='1'".($topic !== false ? " and `topic_id`='$topic'" : "");
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$news = $db->Select('news', $where);
	SortArray($news,2,true);
	$num = $config['news']['newsonpage']; //   

	$navigation = new Navigation($page, 'navigation');
	$navigation->GenNavigationMenu($news, $num, 'index.php?name=news'.($topic !== false ? "&amp;topic=$topic" : ''));

	if(count($news)>0){
		$site->AddTemplatedBox('','module/news.html');
		foreach($news as $s){
			IndexNewsAdd($s,SafeDB($topics[$s['topic_id']]['title'],255,str),false);
		}
	}else{
		if($topic===false){
			$NewsContent = '<center>  </center>';
		}else{
			$NewsContent = '<center>     </center>';
		}
		$site->AddTextBox('',$NewsContent);
	}
}


function GetTopics()
{
	global $db, $config;
	$db->Select('news_topics','');
	$rs = array();
	while($topic=$db->FetchRow()){
		$rs[SafeDB($topic['id'],11,int)] = $topic;
	}
	return $rs;
}

function IndexTopics()
{
	global $site, $config;
	$topics = GetTopics();
	if(count($topics) == 0){
		$site->AddTextBox('','<center>   .</center>');
	}else{
		$site->AddTemplatedBox('','module/news_topics.html');
		$site->AddBlock('news_topics',true,true,'newstopic');
		foreach($topics as $topic){
			$vars = array();
			$vars['url'] = 'index.php?name=news&topic='.SafeDB($topic[0],11,int);
			$vars['image'] = SafeDB(RealPath2($config['news']['icons_dirs'].$topic[3]),255,str);
			$vars['desc'] = SafeDB($topic[2],255,str);
			$vars['title'] = SafeDB($topic[1],255,str);
			$vars['num_news'] = SafeDB($topic[4],11,int);
			$site->AddSubBlock('news_topics',true,$vars);
		}
	}
}

function IndexNewsReadFull()
{
	global $db, $config, $site;

	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}
	if(isset($_GET['lastpage'])){
		$last_page = true;
	}else{
		$last_page = false;
	}

	$site->AddTemplatedBox('','module/news_full.html');
	$site->AddBlock('news',true,true);
	if(isset($_GET['news'])){

		$topics = GetTopics();

		$news_id = SafeEnv($_GET['news'],11,int);

		$where = "`id`='".$news_id."'";
		$ex_where = GetWhereByAccess('view');
		if($ex_where != ''){
			$where .= ' and ('.$ex_where.')';
		}
		$db->Select('news', $where);

		if($db->NumRows()>0){
			$news = $db->FetchRow();
		}
		if($db->NumRows()>0 && $news['enabled']=='1'){ //  
			// SEO
			$site->SeoTitle = SafeDB($news['seo_title'],255,str);
			$site->SeoKeyWords = SafeDB($news['seo_keywords'],255,str);
			$site->SeoDescription = SafeDB($news['seo_description'],255,str);
			//

			IndexNewsAdd($news,SafeDB($topics[$news['topic_id']]['title'],255,str),true);
			$db->Update('news',"hit_counter='".(SafeDB($news['hit_counter'],11,int)+1)."'","`id`='".$news_id."'");

			//  
			include_once($config['inc_dir'].'posts.class.php');
			$posts = new Posts('news_comments', $news['allow_comments'] == '1');
			$posts->EditPageUrl = 'index.php?name=news&op=editpost&news='.$news_id."&page=$nav_page";
			$posts->DeletePageUrl = 'index.php?name=news&op=deletepost&news='.$news_id."&page=$nav_page";
			$posts->NavigationUrl = 'index.php?name=news&op=readfull&news='.$news_id;
			$posts->PostFormAction = 'index.php?name=news&op=addpost&news='.$news_id."&page=$nav_page";

			$posts->RenderPosts($news_id, 'news_comments', 'comments_navigation', $last_page, $nav_page);
			$posts->RenderForm(false, 'news_comments_form');

		}else{
			$site->AddTextBox('','<center>      !<br><input type="button" value="" onclick="history.back();"></center>');
		}
	}else{
		$site->AddTextBox('','<center><input type="button" value="" onclick="history.back();"></center>');
	}
}

function IndexNewsAddPost()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $db, $config, $site, $user;
	$get_id = 'news'; //    get   id 
	$table = 'news_comments'; //  
	$object_table = 'news'; //  
	$counter_field = 'comments_counter'; //      
	$alloy_field     = 'allow_comments';     //      
	$id = SafeEnv($_GET[$get_id],11,int);

	$db->Select($object_table, "`id`='$id'");
	$obj = $db->FetchRow();
	$alloy_comments = $obj[$alloy_field] == '1';

	$back_url = 'index.php?name=news&op=readfull&news='.$id; //  

	$parent = $_POST['parent_id'];
	$parent = explode('_', $parent, 2);
	$post_parent_id = SafeEnv($parent[1],11,int);
	if($post_parent_id == '0'){
		$back_url .= '&lastpage=1';
	}else{
		$back_url .= '&page='.$nav_page;
	}

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table, $alloy_comments);

	if($posts->SavePost($id, false)){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] + 1;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO($back_url.'#post_'.$db->GetLastId());
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexNewsEditPost()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $site, $config;
	$get_id = 'news'; //    get   id 
	$table = 'news_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);

	$site->AddTemplatedBox('','edit_comment.html');
	$posts->PostFormAction = 'index.php?name=news&op=savepost&news='.$id."&page=$nav_page";
	$posts->RenderForm(true, 'post_form');
}

function IndexNewsEditPostSave()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config;
	$get_id = 'news'; //    get   id 
	$table = 'news_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	if($posts->SavePost($id, true)){
		GO('index.php?name=news&op=readfull&news='.$id."&page=$nav_page".'#post_'.SafeEnv($_GET['post_id'],11,int));
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexNewsDeletePost()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config, $db;
	$get_id = 'news'; //    get   id 
	$table = 'news_comments'; //  
	$object_table = 'news'; //  
	$counter_field = 'comments_counter'; //      

	$id = SafeEnv($_GET[$get_id], 11, int);
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	$posts->DeletePageUrl = 'index.php?name=news&op=deletepost&news='.$id."&page=$nav_page";
	$deleted_posts_count = $posts->DeletePost();

	if($deleted_posts_count > 0){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] - $deleted_posts_count;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO('index.php?name=news&op=readfull&news='.$id."&page=$nav_page");
	}
}


if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}

//IndexNewsShow();

switch($op){
	case 'main': IndexNewsMain();
	break;
	case 'readfull': IndexNewsReadFull();
	break;
	case 'topics': IndexTopics();
	break;
	// 
	case 'addpost': IndexNewsAddPost();
		break;
	case 'editpost': IndexNewsEditPost();
		break;
	case 'savepost': IndexNewsEditPostSave();
		break;
	case 'deletepost': IndexNewsDeletePost();
		break;
	// //
	default:
		HackOff();
}

?>