<?php

//  .

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

if(!$user->CheckAccess2('polls', 'polls')){
	AddTextBox('', $config['general']['admin_accd']);
	return;
}

// 
$editpolls = $user->CheckAccess2('polls', 'edit');
$editconf = $user->CheckAccess2('polls', 'config');

function AdminPollsMainFunc()
{
	global $db, $config, $editpolls, $editcomments;
	$time = time();
	$polls = $db->Select('polls', '');
	$text = '<table cellspacing="0" cellpadding="0" class="cfgtable"><tr>';
	$text .= '<th></th><th> </th><th></th><th></th><th></th><th></th></tr>';
	foreach($polls as $poll){
		switch($poll[10]){
			case '1':
				$active = '<font color="#008000">.</font></a>';
				break;
			case '0':
				$active = '<font color="#FF0000">.</font>';
				break;
		}
		if($editpolls){
			$active = '<a href="'.$config['admin_file'].'?exe=polls&a=changestatus&id='.$poll[0].'">'.$active.'</a>';
		}
		$answers = unserialize($poll[5]);
		$c = count($answers);
		$num_voices = 0;
		for($i = 0; $i < $c; $i++){
			$num_voices += $answers[$i][2];
		}
		if($editpolls){
			$func = '<a href="'.$config['admin_file'].'?exe=polls&a=editor&id='.$poll[0].'"><img src="images/admin/edit.gif" title="" /></a><a href="'.$config['admin_file'].'?exe=polls&a=delete&id='.$poll[0].'&ok=0"><img src="images/admin/delete.gif" title="" /></a>';
		}else{
			$func = '-';
		}
		$text .= '<tr>
		<td><a href="'.$config['admin_file'].'?exe=polls&a=editor&id='.$poll[0].'"><b>'.$poll[1].'</b></a></td>
		<td>'.$num_voices.'</td>
		<td>'.$poll[8].'</td>
		<td>'.ViewLevelToStr($poll[9]).'</td>
		<td>'.$active.'</td>
		<td>'.$func.'</td>
		</tr>';
	}
	$text .= '</table>';
	AddTextBox('', $text);
}

function AdminPollsEditor()
{
	global $db, $site, $config, $editpolls;
	if(!$editpolls){
		AddTextBox('', $config['general']['admin_accd']);
		return;
	}
	$view = array(1=>false, 2=>false, 3=>false, 4=>false);
	if(isset($_GET['id'])){ //
		$title = ' ';
		$btitle = '';
		$id = SafeEnv($_GET['id'], 11, int);
		$db->Select('polls', "`id`='$id'");
		$p = $db->FetchRow();
		$poll = $p[1];
		$desc = $p[2];
		$showinblock = $p[6];
		$multianswers = $p[4];
		//
		$answers = unserialize($p[5]);
		$allow_comments = $p[7];
		$active = $p[10];
		$view[$p[9]] = true;
		$uid = '&id='.$id;
	}else{ //
		$title = ' ';
		$btitle = '';
		$poll = '';
		$desc = '';
		$end_date = time();
		$end_n = true;
		$showinblock = true;
		$multianswers = false;
		for($i = 0; $i < $config['polls']['editor_max_answers']; $i++){
			$answers[] = array('', '', '0');
		}
		$allow_comments = true;
		$active = true;
		$view[4] = true;
		$uid = '';
	}
	FormRow('', $site->Edit('poll', $poll, false, 'maxlength="250" style="width:400px;"'));
	FormRow('', $site->Edit('desc', $desc, false, 'maxlength="250" style="width:400px;"'));
	FormRow('  ', $site->Select('showinblock', GetEnData($showinblock, '', '')));
	FormRow('', $site->Select('multianswers', GetEnData($multianswers, '', '')));
	$anstext = '';
	for($i = 0, $c = count($answers); $i < $c; $i++){
		$anstext .= '<tr>'
			.'<td style="width:400px;">'.$site->Edit('answer[]', $answers[$i][0], false, 'style="width:100%;"').'</td>'
			.'<td>'.$site->Edit('color[]', $answers[$i][1], false, 'style="width:60px;"').'</td>'
			.'<td>'.$site->Edit('voices[]', strval($answers[$i][2]), false, 'style="width:44px;text-align:right;"').'</td>'
			.'</tr>';
	}
	FormRow('', '<table cellspacing="0" cellpadding="0" class="cfgtable">'
		.'<tr><th></th><th></th><th></th></tr>'
		.$anstext
		.'</table>'
	);
	FormRow(' ', $site->Select('allow_comments', GetEnData($allow_comments, '', '')));
	FormRow('', $site->Select('active', GetEnData($active, '', '')));
	FormRow('  ', $site->Select('view', GetViewData($view)));
	AddCenterBox($title);
	AddForm('<form action="'.$config['admin_file'].'?exe=polls&a=save'.$uid.'" method="post">', $site->Button('', 'onclick="history.go(-1)"').$site->Submit($btitle));
}

function AdminPollsSave()
{
	global $db, $editpolls;
	if(!$editpolls){
		AddTextBox('', $config['general']['admin_accd']);
		return;
	}
	$poll = SafeEnv($_POST['poll'], 255, str);
	$desc = SafeEnv($_POST['desc'], 255, str);
	$showinblock = EnToInt($_POST['showinblock']);
	$multianswers = EnToInt($_POST['multianswers']);
	$allow_comments = EnToInt($_POST['allow_comments']);
	$active = EnToInt($_POST['active']);
	$view = ViewLevelToInt($_POST['view']);
	$answer = SafeEnv($_POST['answer'], 255, str);
	$color = SafeEnv($_POST['color'], 8, str);
	$voices = SafeEnv($_POST['voices'], 11, int);
	$cnt = count($answer);
	$answers = array();
	for($i = 0; $i < $cnt; $i++){
		$answers[] = array($answer[$i], $color[$i], $voices[$i]);
	}
	$answers = addslashes(serialize($answers));
	if(isset($_GET['id'])){ //
		$set = "question='$poll',description='$desc',multianswers='$multianswers',answers='$answers',showinblock='$showinblock',allow_comments='$allow_comments',view='$view',active='$active'";
		$poll_id = SafeEnv($_GET['id'], 11, int);
		$db->Update('polls', $set, "`id`='$poll_id'");
	}else{
		$vals = Values('', $poll, $desc, time(), $multianswers, $answers, $showinblock, $allow_comments, '0', $view, $active);
		$db->Insert('polls', $vals);
	}
	global $config;
	GO($config['admin_file'].'?exe=polls');
}

function AdminPollsDelete()
{
	global $config, $db, $editpolls;
	if(!$editpolls){
		AddTextBox('', $config['general']['admin_accd']);
		return;
	}
	if(!isset($_GET['id'])){
		GO($config['admin_file'].'?exe=polls');
		exit();
	}
	if(isset($_GET['ok']) && $_GET['ok'] == '1'){
		$id = SafeEnv($_GET['id'], 11, int);
		$db->Delete('polls', "`id`='$id'");
		$db->Delete('polls_comments', "`object_id`='$id'");
		GO($config['admin_file'].'?exe=polls');
		exit();
	}else{
		$r = $db->Select('polls', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
		$text = '     "'.$r[0][1].'" ?<br />'.'<a href="'.$config['admin_file'].'?exe=polls&a=delete&id='.SafeEnv($_GET['id'], 11, int).'&ok=1"></a> &nbsp;&nbsp;&nbsp; <a href="javascript:history.go(-1)"></a>';
		AddTextBox("!", $text);
	}
}

function AdminPollsChangeStatus()
{
	global $config, $db, $editpolls;
	if(!$editpolls){
		AddTextBox('', $config['general']['admin_accd']);
		return;
	}
	$db->Select('polls', "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	$r = $db->FetchRow();
	if($r[10] == 1){
		$en = '0';
	}else{
		$en = '1';
	}
	$db->Update('polls', "active='$en'", "`id`='".SafeEnv($_GET['id'], 11, int)."'");
	GO($config['admin_file'].'?exe=polls');
}
if(isset($_GET['a'])){
	$action = $_GET['a'];
}else{
	$action = 'main';
}

function AdminPollsDeleteComment()
{
	global $config, $db, $site, $user, $editcomments;
	if(!$editcomments){
		AddTextBox('', $config['general']['admin_accd']);
		return;
	}
	if(!isset($_POST['delcomments'])){
		GO($config['admin_file'].'?exe=polls&a=commentsview&id='.SafeEnv($_GET['id'], 11, int));
	}
	if(isset($_GET['ok']) && SafeEnv($_GET['ok'], 1, int) == '1'){
		$cmids = explode(',', $_POST['delcomments']);
		$cmids = SafeEnv($cmids, 11, int);
		$where = '';
		foreach($cmids as $cm){
			$where .= "`id`='$cm' or ";
		}
		$where = substr($where, 0, strlen($where) - 4);
		$cms = $db->Select('polls_comments', $where);
		foreach($cms as $cm){
			$obj = SafeEnv($cm[1], 11, int, false, false);
			CalcCounter('polls', "`id`='$obj'", 'com_counter', -1);
		}
		$db->Delete('polls_comments', $where);
		GO($config['admin_file'].'?exe=polls&a=commentsview&id='.SafeEnv($_GET['id'], 11, int));
	}else{
		$cmcnt = count($_POST['delcomments']);
		$hid = implode(',', $_POST['delcomments']);
		$text = '      ('.$cmcnt.')?<br />'.$site->FormOpen('', $config['admin_file'].'?exe=polls&a=deletecomment'.'&id='.SafeEnv($_GET['id'], 11, int).'&ok=1', 'post').$site->Hidden('delcomments', $hid).$site->Submit('').'&nbsp;&nbsp;&nbsp;'.$site->Button('', 'onclick="history.go(-1)"').$site->FormClose();
		AddTextBox("", $text);
	}
}

include_once ($config['apanel_dir'].'configuration/functions.php');

function AdminPolls()
{
	global $action, $editcomments, $editpolls, $editconf;
	TAddSubTitle('');
	if($editconf || $editpolls){
		TAddToolLink('', 'main', 'polls');
	}
	if($editpolls){
		TAddToolLink(' ', 'editor', 'polls&a=editor');
	}
	if($editconf){
		TAddToolLink('', 'config', 'polls&a=config');
	}
	TAddToolBox($action);
	switch($action){
		case 'main':
			AdminPollsMainFunc();
			break;
		case 'editor':
			AdminPollsEditor();
			break;
		case 'save':
			AdminPollsSave();
			break;
		case 'delete':
			AdminPollsDelete();
			break;
		case 'changestatus':
			AdminPollsChangeStatus();
			break;
		///////////////// 
		case 'config':
			AdminConfigurationEdit('polls', 'polls', true, false, '  ""');
			break;
		case 'configsave':
			AdminConfigurationSave('polls&a=config', 'polls', true, false);
			break;
		default:
			AdminPollsMainFunc();
	}
}

AdminPolls();

?>