<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$site->Title = '';

function IndexPollsViewPolls()
{
	global $db, $site, $config, $user;

	$where = "`active`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$polls = $db->Select('polls', $where);

	$time = time();
	if(count($polls) > 0){
		$site->AddTemplatedBox('', 'module/polls_main.html');
		$site->AddBlock('polls_title', true, false, 'ptitle');
		$site->Blocks['polls_title']['vars'] = array('public'=>'', 'title'=>'', 'comments'=>'', 'voices'=>' ');
		$site->AddBlock('polls', true, true, 'poll');
		SortArray($polls, 3, true);
		foreach($polls as $poll){
			$answers = unserialize($poll[5]);
			$c = count($answers);
			$num_voices = 0;
			for($i = 0; $i < $c; $i++){
				$num_voices += $answers[$i][2];
			}
			$show_results_link = $config['polls']['show_results'];
			$vars = array();
			$vars['title'] = $poll[1];
			$vars['url'] = 'index.php?name=polls&amp;op=viewpoll&amp;poll_id='.$poll[0];
			$vars['public'] = TimeRender($poll[3], false, false);
			$vars['num_voices'] = $num_voices;
			$vars['allow_comments'] = $poll[7];
			$vars['comments'] = $poll[8];
			$site->AddSubBlock('polls', true, $vars);
		}
	}else{
		$site->AddTextBox('', '<center>  .</center>');
	}
}

function IndexPollsViewPoll()
{
	global $db, $site, $user, $op, $config;
	if(!isset($_GET['poll_id'])){
		HackOff();
	}
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}
	if(isset($_GET['lastpage'])){
		$last_page = true;
	}else{
		$last_page = false;
	}

	$id = SafeEnv($_GET['poll_id'], 11, int);

	$where = "`id`='$id' and `active`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$db->Select('polls', $where);
	if($db->NumRows() == 0){
		HackOff();
	}
	$poll = $db->FetchRow();

	$answers = unserialize($poll[5]);

	//  
	$ip = getip();
	if($user->Auth){
		$uid = $user->Get('u_id');
	}else{
		$uid = -1;
	}
	$db->Select('polls_voices', "`poll_id`='$id' and (`user_ip`='$ip' or `user_id`='$uid')");
	$viewresult = $db->NumRows() != 0;
	$viewresult = $viewresult || ($op == 'viewresult' && ($config['polls']['show_results'] == '1' || $user->isAdmin()));

	$answers = unserialize($poll[5]);
	$c = count($answers);
	$num_voices = 0;
	for($i = 0; $i < $c; $i++){
		$num_voices += $answers[$i][2];
	}

	if($viewresult){
		if($num_voices != 0){
			$per_c = 100 / $num_voices;
		}else{
			$per_c = 0;
		}
		$site->AddTemplatedBox('', 'module/poll_result.html');
		$vars = array('lresults_title'=>' ', 'lrvalue'=>'.');
		$site->AddBlock('poll_result_rows', true, true, 'pr');
		$c = count($answers);
		for($i = 0; $i < $c; $i++){
			if($answers[$i][0] != ''){
				$svars = array();
				if($answers[$i][1] != ''){
					$ans = '<font color="'.$answers[$i][1].'">'.$answers[$i][0].'<font>';
				}else{
					$ans = $answers[$i][0];
				}
				$svars['value'] = (round($per_c * $answers[$i][2]));
				$svars['num_voices'] = $answers[$i][2];
				$svars['answertext'] = $ans;
				$site->AddSubBlock('poll_result_rows', true, $svars);
			}
		}
	}else{
		$site->AddTemplatedBox('', 'module/poll.html');
		$vars = array();
		$vars['form_action'] = 'index.php?name=polls&amp;op=voice&amp;poll_id='.$poll[0];
		$site->AddBlock('poll_variants', true, true, 'variant');
		for($i = 0; $i < $c; $i++){
			if($answers[$i][0] != ''){
				if($answers[$i][1] != ''){
					$ans = '<font color="'.$answers[$i][1].'">'.$answers[$i][0].'<font>';
				}else{
					$ans = $answers[$i][0];
				}
				if($poll[4] == '1'){
					$control = $site->Check('voice[]', $i);
				}else{
					$control = $site->Radio('voice[]', $i);
				}
				$site->AddSubBlock('poll_variants', true, array('title'=>$ans, 'control'=>$control));
			}
		}
		$vars['poll_showresults'] = ($config['polls']['show_results'] == '1' || $user->isAdmin());
		$vars['showresults_url'] = 'index.php?name=polls&amp;op=viewresult&amp;poll_id='.$id;
		$vars['others_url'] = 'index.php?name=polls';
	}
	$vars['title'] = $poll[1];
	$vars['back_url'] = 'index.php?name=polls';
	$vars['back_caption'] = '<<<   ';
	$vars['lnum_voices'] = '';
	$vars['num_voices'] = $num_voices;
	$vars['lcomments'] = '';
	$vars['comments'] = $poll[8];
	$site->AddBlock('poll', true, false, '');
	$site->Blocks['poll']['vars'] = $vars;

	//  
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts('polls_comments', $poll['allow_comments'] == '1');
	$posts->EditPageUrl = 'index.php?name=polls&op=editpost&poll_id='.$id."&page=$nav_page";
	$posts->DeletePageUrl = 'index.php?name=polls&op=deletepost&poll_id='.$id."&page=$nav_page";
	$posts->NavigationUrl = 'index.php?name=polls&op=viewpoll&poll_id='.$id;
	$posts->PostFormAction = 'index.php?name=polls&op=addpost&poll_id='.$id."&page=$nav_page";

	$posts->RenderPosts($id, 'poll_comments', 'comments_navigation', $last_page, $nav_page);
	$posts->RenderForm(false, 'poll_comments_form');
}

function IndexPollsVoice()
{
	global $db, $user, $site, $config;
	if(!isset($_GET['poll_id'])){
		GoBack();
	}
	if(!isset($_POST['voice'])){
		$site->AddTextBox('', '<center>      .</center>');
	}else{
		$pid = SafeEnv($_GET['poll_id'], 11, int);

		$where = "`id`='$pid' and `active`='1'";
		$ex_where = GetWhereByAccess('view');
		if($ex_where != ''){
			$where .= ' and ('.$ex_where.')';
		}
		$db->Select('polls', $where);

		if($db->NumRows() == 0){
			GoBack();
		}
		$poll = $db->FetchRow();
		$answers = unserialize($poll[5]);
		$multianswers = $poll[4];
		$voice = SafeEnv($_POST['voice'], 11, int);
		if(!$multianswers){
			$voice = $voice[0];
		}
		//,       
		$ip = getip();
		if($user->Auth){
			$uid = $user->Get('u_id');
		}else{
			$uid = -1;
		}
		$db->Select('polls_voices', "`poll_id`='$pid' and (`user_ip`='$ip' or `user_id`='$uid')");
		if($db->NumRows() == 0){
			if(!$multianswers){
				if(isset($answers[$voice])){
					$answers[$voice][2] = $answers[$voice][2] + 1;
					$answers = serialize($answers);
					$db->Update('polls', "answers='$answers'", "`id`='$pid'");
				}else{
					GoBack();
				}
			}else{
				$c = count($voice);
				for($i = 0; $i < $c; $i++){
					if(isset($answers[$voice[$i]])){
						$answers[$voice[$i]][2] = $answers[$voice[$i]][2] + 1;
					}else{
						GoBack();
					}
				}
				$answers = serialize($answers);
				$db->Update('polls', "answers='$answers'", "`id`='$pid'");
			}
			$voice = serialize($voice);
			if($user->Auth){
				$user_id = $user->Get('u_id');
			}else{
				$user_id = 0;
			}
			$db->Insert('polls_voices', "'','$pid','".getip()."','$voice','$user_id'");
			$user->ChargePoints($config['points']['polls_answer']);
			GoBack();
		}else{
			$site->AddTextBox('', '<center>,       .</center>');
		}
	}
}

function IndexPollsAddPost()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $db, $config, $site, $user;
	$get_id = 'poll_id'; //    get   id 
	$table = 'polls_comments'; //  
	$object_table = 'polls'; //  
	$counter_field = 'com_counter'; //      
	$alloy_field     = 'allow_comments';     //      
	$id = SafeEnv($_GET[$get_id],11,int);

	$db->Select($object_table, "`id`='$id'");
	$obj = $db->FetchRow();
	$alloy_comments = $obj[$alloy_field] == '1';


	$back_url = 'index.php?name=polls&op=viewpoll&poll_id='.$id; //  

	$parent = $_POST['parent_id'];
	$parent = explode('_', $parent, 2);
	$post_parent_id = SafeEnv($parent[1],11,int);
	if($post_parent_id == '0'){
		$back_url .= '&lastpage=1';
	}else{
		$back_url .= '&page='.$nav_page;
	}

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table, $alloy_comments);

	if($posts->SavePost($id, false)){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] + 1;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO($back_url.'#post_'.$db->GetLastId());
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexPollsEditPost()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $site, $config;
	$get_id = 'poll_id'; //    get   id 
	$table = 'polls_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);

	$site->AddTemplatedBox('','edit_comment.html');
	$posts->PostFormAction = 'index.php?name=polls&op=savepost&poll_id='.$id."&page=$nav_page";
	$posts->RenderForm(true, 'post_form');
}

function IndexPollsEditPostSave()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config;
	$get_id = 'poll_id'; //    get   id 
	$table = 'polls_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	if($posts->SavePost($id, true)){
		GO('index.php?name=polls&op=viewpoll&poll_id='.$id."&page=$nav_page".'#post_'.SafeEnv($_GET['post_id'],11,int));
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexPollsDeletePost()
{
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config, $db;
	$get_id = 'poll_id'; //    get   id 
	$table = 'polls_comments'; //  
	$object_table = 'polls'; //  
	$counter_field = 'com_counter'; //      

	$id = SafeEnv($_GET[$get_id], 11, int);
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	$posts->DeletePageUrl = 'index.php?name=polls&op=deletepost&poll_id='.$id."&page=$nav_page";
	$deleted_posts_count = $posts->DeletePost();

	if($deleted_posts_count > 0){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] - $deleted_posts_count;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO('index.php?name=polls&op=viewpoll&poll_id='.$id."&page=$nav_page");
	}
}

if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}

switch($op){
	case 'main':
		IndexPollsViewPolls();
		break;
	case 'voice':
		IndexPollsVoice();
		break;
	case 'viewpoll':
	case 'viewresult':
		IndexPollsViewPoll();
		break;
	// 
	case 'addpost': IndexPollsAddPost();
		break;
	case 'editpost': IndexPollsEditPost();
		break;
	case 'savepost': IndexPollsEditPostSave();
		break;
	case 'deletepost': IndexPollsDeletePost();
		break;
	// //
	default:
		HackOff();
}

?>