<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

global $search_results, $searchstr, $db;

$objects = $db->Select('pages', "`enabled`='1' and `type`='page'");

foreach($objects as $object){
	$result = array();
	$result['mod'] = $plugin['mod_title']; //  
	$result['coincidence'] = ''; //    
	$result['title'] = SafeDB($object['title'], 255, str); // 
	$result['public'] = TimeRender(SafeDB($object['modified'], 11, int)); //  
	//    
	$result['link'] = 'index.php?name=pages&file='.SafeDB($object['link'], 255, str);
	$result['text'] = strip_tags($object['text']);
	if(strlen($result['text']) > 255){
		$result['text'] = substr($result['text'], 0, 255).'&nbsp; ...';
	}
	if(SSearch($object['seo_keywords'], $searchstr) !== false){
		$result['coincidence'] = ' ';
		$search_results[] = $result;
	}elseif(SSearch($object['seo_description'], $searchstr) !== false){
		$result['coincidence'] = '';
		$search_results[] = $result;
	}elseif(SSearch($object['title'], $searchstr) !== false){
		$result['coincidence'] = '';
		$search_results[] = $result;
	}elseif(SSearch($object['text'], $searchstr) !== false){
		$result['text'] = SCoincidence($object['text'], $searchstr);
		$result['coincidence'] = ' ';
		$search_results[] = $result;
	}
}

?>